2026-04-06: Version 4.7.0:
 * Campaign:
   * Change: Additional Remastered balance updates (commit:4b30f8c4637101eebfbea4d102c90cdb0ba0c461, #4888)
   * Fix: Typo in Reclamation level 4 pushing a unit to an imaginary unit spawn array (commit:77fa552348e5b122f5e5898e0d3407a50cd46629, #4888)
 * Translations:
   * Change: Translation updates (commit:8867da90aee0ccc464e299865cefb3b41dfa43f0, #4873)
 * Other:
   * Fix: pieblitfunc: Reset mTexture pointer after deleting (commit:a25c8688fe199df75a49f20738c6c5b12f3a4865, #4886)
   * Fix: Various compilation issues (too many commits, #4887)

2026-04-05: Version 4.7.0-beta2:
 * General:
   * Add: Reclamation soundtrack by @Lupus-Mechanicus (commit: c60373ef9ccc1b5661c850db7c14c3eabfa93f25, #4881)
 * Multiplayer:
   * Fix: Various netplay and netlobby improvements (too many commits, #4878)
 * Networking:
   * Fix: urlrequest: Improve handling of pending requests at shutdown (commit:4ba1b85f1f2d0cab8a69cc1aae5477c7f46cf6ae, #4879)
 * Other:
   * Fix: Flatpak: Migrate to new flat-manager-client (commit:e11955d4669d798c93f3e73bed4b812c4e0e6247, #4877)
   * Fix: CI: Update various dependencies (too many commits, #4880, #4882)

2026-04-04: Version 4.7.0-beta1:
 * General:
   * Add: Add Weapon Stats flag for configuring Captured Units Teleport (commit:11c1b24f02faecaf5b220305858d6f39819c6f3b, #4848)
   * Fix: Mouse cursor not respecting display scale on some OSes (commit:1dddb170ff17a2ea86ed45d7d5e89d80cc86382f, #4809)
   * Fix: Fix 'disabled' state of mouse key code (commit:bfa315073b2c773d3b90e899552658c20595a8d5, #4813)
 * Graphics:
   * Fix: Vulkan: Major improvements for synchronization & recreating swapchain, fixing graphical issues and behavior on some systems (too many commits, #4826)
   * Fix: Numerous model fixes, resolving many shadow issues, from @MaNGusT- (too many commits, #4827)
   * Fix: Remove built in shadows for most skyscrapers and make pipes float less, from @MaNGusT- (commit:7e5250aced97b0bba5741502ac0907e79a685db1, #4834)
   * Fix: Objects incorrectly darkened due to terrain darkness / satellite strike (commit:e12dce6490689d2e87f6a26a7d6dc7cac60b85ab, #4815)
 * Campaign:
   * Add: Update Remastered balance, additional spawns 2.0 (commit:b68249182fa07c46ebd5e4a3d8e6b1726fb301a7, #4818)
   * Add: "Pumpkin" v1.10 Campaign Balance Mod - thanks to @KJeff01 (commit:d5966bc2503c140c0e37bfc57de3c604c7b98843, #4853)
   * Add: Campaign balance descriptions help panel (commit:601d923cc7bd83d15875ac117dd650c29ac06086, #4865)
   * Fix: Classic campaign Howitzer tree path (commit:704d54f310678fd8b60465debebd60a1f0b403d5, #4818)
   * Fix: Various guide topic issues (commit:9c38a8c290b35af00281a7ca053bd523e795543b, #4818)
   * Fix: Missing Intel message issues (commit:82284ff54ac56022f422d8f18418dcacec9d4bee, #4818)
 * Multiplayer:
   * Add: New netlobby support, with IPv4 + IPv6, improved security & privacy, enhanced options, better performance & compatibility with difficult ISPs, and much more (too many commits, #4870)
   * Add: New unified lobby + join screen (too many commits, #4870)
   * Add: Expanded "Host Lobby Options" panel (too many commits, #4870)
   * Add: New --lobbyjoin and --lobbyspectate CLI options (too many commits, #4870)
   * Fix: Properly persist player mute option (commit:19a26f3fe6681659c0a2a03017a395c97e2db936, #4869)
   * Fix: Easily join multiplayer games by Lobby GameID (too many commits, #4870)
 * Networking:
   * Fix: poll_descriptor_set: Handle POLLNVAL in PollDescriptorSet::isSet() (commit:7e1e3063c46868fe1b278b192c04f30cd9b7aae1, #4840)
 * Scripting:
   * Add: Add "Reset Sun" button to the script debugger (commit:906b7194f746a30f96a806ba41867ee168e671f9, #4832)
   * Add: Add an emitSound() JS function (commit:7b42b87ec86d49a57fddb72d1fc5173d6b16668f, commit:51329f10fb254e27d4a0063a6f19d09e3546a78d, #4851)
 * AI:
   * Fix: Semperfi AI: Fully rearm VTOLs (commit:d1ba05370b5dd2fc46776d977f1be95a8ecbaddf, #4807)
 * Balance MP:
   * Fix: Add missing Particle Gun times to camTechEnabler.js (commit:e9a9d876375b8990656e0ccbb63db20bbb6113bd, #4811) 
 * Other:
   * Change: steering: Introduce extensible steering behavior management system (commit:5fa77d392349e5c4b5a9d5ba9f2e3f5f0f0714ec, #4846)
   * Fix: Remove unused power property from sensor.json (commit:0c32a6cfa73d8ddb3db640bf46fcaa895f2a8ff1, #4833)
   * Fix: Reduce apsFeatureLists to a single list and rename to apsFeatureList (commit:a075294251d04f2439da994e4ab9f99692119a7f, #4861)
   * Fix: framework: Simplify some SFINAE checks for PagedEntityContainer and LoopBodyHandlerCallStrategy (commit:a99fdde5d2b622a59c0272aa34728801861ced08, #4862)

2026-02-04: Version 4.6.3:
 * General:
   * Fix: Detect disconnected research categories (commit:23710dd093bcc75169279f601fe646b1d8914352, #4779)
   * Fix: Video sequence skip time delay for powerful systems (commit:e5654b3a9b6a930ab4857d830996b50989bd9ba3, #4785)
   * Fix: VTOLs floating motionless in mid-air after failed embark (commit:55d232be355175e9764b0dd234d0e2d26de8c127, #4785)
   * Fix: Auto-embark transporter selection behavior in skirmish / mp (commit:f5e663f840f7f397f74d1e3f334132298675d7ff, #4785)
   * Fix: Trigger screenSizeDidChange if already started in *TitleUI::start (commit:83329a612dd0aacac0dbd743cd04e8626abaf8d4, #4790)
   * Fix: History console position and sizing when layout changes (commit:eba7eb08ee875bf776b62e26a3f0e5cb81f20eed, #4796)
   * Fix: Various potential crashes / asserts (too many commits, #4719, #4777, #4782)
 * Graphics:
   * Add: Terrain Shadows graphics option, terrain can now cast actual shadows on itself and everything else (too many commits, #4743)
   * Add: Numerous improvements for shadows, lighting, and fog (too many commits, #4743)
   * Change: Remove old fallback terrain renderer (commit:3c31d5d9aab6fe70cab1af00bf1acc5fcff0d233, #4743)
   * Fix: Vulkan: Default-disable additional problematic layers (commit:7b4c5549016183741d2b19591afa8c104213e5a2, #4714)
   * Fix: Black borders when changing display scale while fullscreen on some platforms (commit:4715d7ae4f3a9beec69947493e8ec9bcb540b68b, #4777)
 * Multiplayer:
   * Add: locked.cheats option, to reject debug mode / cheat voting (commit:635b4f7d728ec1c047fb56935ca195f96ec8a406, #4790)
   * Add: Right-clicking on a human player copies the player id to the clipboard (commit:97c43ef2c055668b1188ac879ebc915302cfe832, #4790)
   * Change: Display the player id (b64) instead of the old player hash (commit:c06834c1694316e353e9024f5fa83501caed68cb, #4790)
   * Fix: handlePlayerLeftInGame leftWhilePlayer value (commit:c55b41bc3a5921b442c29216daf8ad42868aa182, #4757)
   * Fix: Auto-not-ready kick behavior (commit:bcb89fe13a57ab407fccd8a17319c288ce3cb525, #4790)
   * Fix: Improve tmp bad IPs list with expiry (commit: 78be0596010eb0118a416607109ca351450ce9ae, #4790)
   * Fix: Return immediately after startMultiplayerGame() in frontendMultiMessages (commit:4d1721cab9e18a114ae8276909ca38b76278b9ad, #4790)
   * Fix: Skip additional graphics or display-related tasks in headless mode (too many commits, #4790)
   * Fix: Reduce amount of host / system message spam when joining lobbies and while in a lobby (too many commits, #4790)
   * Fix: Handle poll connection-related errors in PendingWritesManager (commit:e8cfe956dcb085fd88665dc786ff7a72482bf91c, #4790)
   * Fix: Improve accuracy of multiStatsResearchPerformance accumulation (commit:19e3f29d6f9929ca0668e2cbbebc57c0d1ca7d7d, #4790)
   * Fix: Various possible causes of rare desyncs (too many commits, #4790)
 * Scripting:
   * Add: Optional "quiet" param to includeJSON() (commit:8ca6d1ef105791b3a446fcbb8248e6f9a41bc004, #4750)
   * Fix: Remove or change some defensive checks in skirmish bots (commit:656433b9d0a5dbe631239d235639b9ee60fad849, #4764)
   * Fix: Handle circular references when converting JSValue to json (commit:777a9fb4759d68794f39b6f7317b9b6226aec4a9, #4769)
 * AI:
   * Change: Cobra AI: Improve cyborg style games (commit:d4b0391b3eaa9ba4428d22ec641a56b87648b8ce, #4764)
   * Fix: Nexus AI: Send help chat messages to allies only (commit:ee0a1394f76510d9e243e1f6b926279bd0b880eb, #4786)
 * Translations:
   * Add: Serbian translation (commit:67e7d0cd6eab6815405281880429ec92b3a7111c, #4726)
   * Change: Translation updates (too many commits, #4710, #4802)
 * Other:
   * Fix: Various Wformat warnings and correctness issues (too many commits, #4787)
   * Fix: get-dependencies_linux.sh: Debian / Ubuntu version-handling (commit:c763d01bf83dcb1b5a9e7bd9e4ac77739cd049de, #4795)
   * Fix: Various documentation cleanups (too many commits, #4729, #4784, #4800)

2025-12-09: Version 4.6.2:
 * General:
   * Fix: Add transporter weapon validity check (commit:a085887b4e3093e695f24f40a666170820c494ca, #4617)
   * Fix: Resolve assert when loading replay with in-memory map archive (commit:6be51879a4bc0182ffc19b045d1d4fbe064a6e11, #4619)
   * Fix: Allow stats / mods to change cyborg movement sound (commit:6800ec64a58f92a8387d0b8d1656adcd956c6cf7, #4623)
   * Fix: Correct and clarify some topics of the in-game guide (commit:ae6965a270a9763619687e13e6642d26fbd1d587, #4582)
   * Fix: Various potential crashes / asserts (too many commits, #4597, #4657, #4658, #4659, #4687)
 * Graphics:
   * Fix: MP Transporter model fixes (commit:7fbf3f31097c74b15cdcd2f2bbccd0ec07c95394, commit:ff6df7712aee58e1030bc52b460eb7aa6358aa63, #4627)
   * Fix: Remove validation layers in Vulkan device create info (commit:ac9bc67d6ad24c2663b15e6554d659e787e27da3, #4638)
 * Campaign:
   * Add: Update Reclamation and Fractured Kingdom addon campaigns (commit:c50d79adf14fd8a032eb2fafc1c5c80a83bf4b89, commit:bb1d84ac901682d4b8066be2c5ebd5fc3793a68b, #4634)
   * Fix: Make toggle options in GUI easier to understand (commit:2fa575d5a7a8b608ce4e80cb8f93923de9f1b835, #4645)
   * Fix: Tower Wars tweak for Classic Balance (commit:b3578e1abbcef259ef5639fe4b56bc184185bee5, #4679)
 * Multiplayer:
   * Add: locked.readybeforefull option, to prevent checking ready before all open player slots are full (commit:af81baa87bc49c5312170cbda8dafc5d42d091c4, #4691)
   * Change: Let Insane difficulty AI bots start with gates (commit:8a61dbab079846fd6cc6ea59bc6ef142da8c1586, #4640)
   * Fix: Refactor how player connection state is recorded and handled, resolve "kick loop" (commit:3703421fd2ed99cf98fc5f69c0881d18a0b2d616, #4588)
   * Fix: Trigger lobby browser refresh when exiting game lobby (commit:ae697c460a40e9d097687c37cbd5802f96372e76, #4605)
   * Fix: Improve state management when --startplayers is specified (commit:ae35595678dfb34c1570bdb92fb8acadedf2b7af, #4605)
   * Fix: sendBeacon error when spectator host (commit:119585ec10af38c6207b0e60204471879a4b1875, #4620)
   * Fix: Errors in the maps Valley and Concrete (commit:7e381ce319a092f3c69552381024d09bbd702ee7, commit:169eaa25c6c22474ec9c5ee0c5f602bff7d8e71f, #4636)
   * Fix: Name conflict with MP scavenger body stats (commit:e539abc3e1ae4cd1d344d1fd39c6f4f29ad06768, #4673)
   * Fix: Improve not-ready-kick messaging (commit:f094d72d129a36d7431fa353f4bb9d68a539f8e1, #4691)
   * Fix: netplay: Schedule port mapping request callbacks under the mutex (commit:6ceb6ca5c891ea1244433a81f820c1f2aa63dc52, #4698)
 * Scripting:
   * Add: scriptName to playerData (commit:7b933b4093ce08ed65a3ddbe7c423aa06f380e05, #4647)
   * Change: Add optional center param to fireWeaponAtLoc (commit:43954282e18b96f1f2ad5806911854d800f54963, #4686)
   * Fix: Update quickjs-wz, improving performance and fixing bugs (too many commits, #4596, #4613, #4639, #4685, #4699)
   * Fix: syncRandom() return type (commit:dc4ed949908f7331189b1eeba5821b372d8c7eb7, #4630)
 * AI:
   * Nexus:
     * Improve game performance when multiple Nexus bots are used
     * Fix help system accessing help data incorrectly
     * Fix a countDroid() call doing nothing for when to skip production
   * NullBot family:
     * Fix Hover AI causing "ruleset warnings" over the Mini-Rocket Pod
     * Fix missing parenthesis introduced back in 2016 in function buildVtols (due to a recent commit, and this going unnoticed, that change unintentionally broke NullBot defense building behaviors)
     * Make sure VTOL pads are built in safe areas
   * Cobra:
     * Can use Particle Gun now
     * Create chance() function to remove repeated random() < X calls
     * Slightly refactor research tree into separate functions
     * Update const style convention (similar to libcampaign) to distinguish local and global constants
     * Go for Power research more if available in low oil
     * Reduce or eliminate chance of trapping trucks in high oil maps as it was trying to defend base derricks
     * Try building repair facilities near other repair facilities (works best on high oil maps)
     * Add a Cannon VTOL personality (AV chat command)
     * Bump repair thresholds to medium damage levels
     * Improvements to high oil build orders
     * Much better T2+ No Bases support in all map types
     * Micro optimize low oil build order to build power modules before cyborg factories
     * Try using research labs with modules first when selecting research
     * Some small research path optimizations
     * Force Cobra to research defense topics randomly since they don't take long these days
     * Cobra defends bases and oils better with defenses (kinda turtle-AI like)
     * Fix Cobra building base structures very far away sometimes, due to a cache call collision returning an oil truck's defense structure location
     * Rocket personality now ignores MG past the early game, will go full rocket artillery instead to optimize research
     * Make it prefer stronger bodies faster, more chance to build heavy ones
     * Fix a very old bug on Advanced Bases Cockpit / Cockate where truck production would be delayed for a few minutes (This will also fix other such maps that give almost no base structures on these settings)
   * BoneCrusher:
     * Fix some out-of-bounds access errors causing asserts
     * Huge performance improvements (eliminates stutters in many higher oil maps)
     * Fix a broken if statement for adding oil hunters which wanted to call a function to check something oil related   
 * Balance MP:
   * Change: Partial revert: SuperTransport base HP 3000 -> 2200, due to interaction with PR #3252 (commit:78b304b56ed9564e5d369b2448be4ab07a60069b, #4704)
   * Fix: Copy paste stat error for Particle Gun emplacement (commit:7ed4dabf07e42bc48bc6dcfba8d0f0089f20107f, #4580)
   * Fix: Thermal typo under bbaatow in structure.json (commit:6e4d7e9484addc8f4e8394ff7351b9280a6a6120, #4697)
 * Other:
   * Add: Gentoo support to get-dependencies_linux.sh (commit:19a21960feb437810ba3e6626d6f3355ffa37056, #4584)
   * Add: Debian / Raspberry Pi OS support to get-dependencies_linux.sh (commit:19ead363d027c6734e313837bb5488a6ec6b5a7c, #4591)
   * Add: Reminder messages in tutorial (commit:e6355e51c415d070fdaef5dc22ea663f6539a37d, #4702)
   * Change: Port backend from SDL2 to SDL3 (too many commits, #4661)
   * Fix: GameNetworkingSockets absl symbol leaks with protobuf (commit:fd2ab132761d293eb909f4734bc9b4eec341fa8e, #4576)
   * Fix: Create albums music folder in config (commit:62bcfc9585cd7db0227607374618e3055a1adca0, #4609)
   * Fix: Replace uses of sprintf (commit:ebeaaa7958f35879eea7b57474eff0c89aa4fb03, #4607)
   * Fix: CMake: Update FindZIP to find 7zz (commit:38102e314a79dc8f6b22aed863cc7e6abba7d715, #4621)
   * Fix: Snap: Add workaround for amdgpu.ids issue (commit:251f7c74bb3ac6ea15cbe29148c50fe7163f4188, #4648)

2025-09-16: Version 4.6.1:
 * General:
   * Fix: Add various buggy drivers to the Vulkan driver blocklist (too many commits, #4560, #4568)
   * Fix: Rebuilding search paths and reloading local mods after leaving joined lobby or multiplayer game (commit:d2310199e980f5f3781ff19580c807818598909e, commit:f28a8d1a57b989f9964f2b16f56c9789438e6eb0, #4561)
   * Fix: Call countUpdate at init, not unsynchronized at top of gameLoop (commit:d65dcad91268e71fb26555bfadbf24c61126c082, #4564)
 * Campaign:
   * Fix: Improve campaign coordinate generators (commit:345c26dd053088d474bd37b7d5d01b8c179a91b4, #4570)
 * Multiplayer:
   * Add: hostAutoLagKickAggressiveness config value (commit:f2efcd97a65bfc3abc06c41350ea1c159d6c99d8, #4556)
   * Add: Share more host options with clients, so clients can display the state (commit:48f52846df42c9ca74f7fe03b743b04f9e823715, #4562)
   * Fix: Apply commander distance check to getDroidEffectiveLevel, other tweaks to avoid exploits (too many commits, #4559)
   * Fix: Improve not-ready check / kick / warning (too many commits, #4566)
 * Networking:
   * Fix: netplay: Use shared/weak_ptr for WzConnectionProvider, refactor shutdown handling (too many commits, #4563)
 * Translations:
   * Change: Translation updates (commit:ffe13ab5532b6997c785650167d7db273cf545bb, #4571)

2025-09-08: Version 4.6.0:
 * General:
   * Change: Bump repair spread area from 6 to 10 tiles (commit:027134f560965fec3ff37656c10f5d7e6190da5a, #4547)
   * Remove: Experimental commander-based shield implementation, leave stubs for future shield experiments (commit:b9c9dfbf4ed230e04106c25dcde3dc7cb4b8c8b1, #4537)
   * Fix: Various unloadTransporter issues and edge cases (too many commits, #4548)
 * Campaign:
   * Fix: Prevent campaign Gauss Cannon friendly splash damage (commit:c0ff325fd155e6f38f6c1dba044d9aabf7f87f26, #4543)
 * Multiplayer:
   * Fix: quickchat: Add reset & index swap handling (commit:f75c92f2250eebca74e2ad986f22b7cec080bb6f, #4540)
   * Fix: teamstrategy: Update the player names once revealed (commit:d2bedbbb06b995a3a98a965bffdbbbbab4c5b138, #4542)
   * Fix: Prevent MP penetrating weapons causing friendly fire (commit:355c5119053108b7c422de643100f5e6b176e57a, #4543)
 * Networking:
   * Fix: gns: Guard read/write accesses to activeClients_ with a mutex (commit:256788c35e9140fb9ce182aef103db6662c926e4, #4549)
 * Scripting:
   * Add: isFlying JS field to Droid objects (commit:f349292509f38c1e9c697f9f06777fc71800e8b4, #3830)
 * Translations:
   * Change: Translation updates (commit:802ce2fa34049ad05510cc34d2373f20ccef4fd3, #4536)
 * Other:
   * Update generated docs (commit:c471247a3b3c28c4ce5056e58ba5b1f89c68fce3, #4541)

2025-08-31: Version 4.6.0-beta4:
 * Multiplayer:
   * Fix: Map preview cleanup when returning to lobby browser (commit:281c08938ed521edfff72af20895705390237ba7, #4533)
   * Fix: Lobby browser spectate button issues (commit:b8061a1072b43107a20e3c6f21cc31cd4f5d8212, #4533)

2025-08-31: Version 4.6.0-beta3:
 * General:
   * Add: Add to brain.json: cmdExpRange, shieldRange to cap distance for when shields regenerate and rank to be given to Commanders (commit:903a57b93f45c65bd8b9a65798d8442b6535332e, #4493)
   * Add: Add "Audio Cues" options section, toggle for "Group Reporting" audio cue (commit:688bdb8bd54f0c215195e23ec7d9235008f170b2, #4519)
   * Change: Transporters caught fire when flying over fire; Disabled burning transporter in general as they are always flying (commit:58ca5fb835c360eee6c114ae02637824c0895afb, #4504)
   * Fix: Cleanup Commander template limit code to allow multi-factory production; Don't hide Commander templates at limit; Hardcoded 5 Commander production limit removed as it conflicts with modern scripts (commit:7ffa8e9951e6f41bc5733ae0d486df3d88203c1b, #4506)
   * Fix: Set gameInitialised to true in initSaveGameLoad() to fix autosaves not happening after the new autosave message PR was done (commit:1bc622f83872bd93f548adb24a2cd6c6c9fee504, #4513)
   * Fix: Additional calls to droidRepairStopped() to prevent sticking healthbars until fully healed (commit:18421b3c56aaceb298d0d004a6656626a209f07a, #4518)
 * Graphics:
   * Add: [Vulkan] Ability to block bad drivers, up max requested version to 1.3, Update minimum VK_HEADER_VERSION to 290 (too many commits, #4502)
   * Fix: [Vulkan] Handle getQueueFamiliesInfo failure (commit:8afe3df7c40540424ac5f9c423c2f753f6aaaac1, #4496)
 * Multiplayer:
   * Add: Search for the nearest transporter if the current one is already full during an attempted embark (commit:b9538249871c1521fce983069304ba9118cc26fa, commit:780ac3100c750df9845a369fd02eaab39a0e8ce2, #4422)
   * Add: Blind lobby & netplay tweaks, New lobby game browser. New widgets, more filtering options, more room information, and increased responsiveness (too many commits, #4499)
   * Fix: Additional map preview sanity checks (commit:2838c083f68a484c90611a46fd60ce2ef30fd8c8, #4497)
 * AI:
   * Fix: Fix typos in BoneCrusher (commit:fe1e616c15fe5b652e4d7c814af66c91c7bfcb91, #4444)
 * Networking:
   * Fix: Do not add GNS to joinLobbyGame connection list to prevent a long wait time (commit:0df36e7306342bc1d2a6a9d9a050181b6be4c3ff, #4479)
   * Fix: autoLobbyNotReadyKickRoutine using the wrong value (commit:fe4f29674945b15247d433febb9150e8d22aebdf, #4485)
   * Fix: Move NETshutdown() later in systemShutdown() (commit:e3901055bd0884c97789a8d51a5d5de146cc8b62, #4492)
   * Fix: Prevent 12 year old rare desync from different compiler / standard library implementations of std::sort when an unlucky list of tiles were generated during factory droid placement (commit:9dc499a1edf3266a8a43c8ab4b617109ed993f4c, #4486)
   * Fix: Only output playerLeft event when slot is still allocated (commit:7dec24fae60165ed7dac192fdff6ed2ce5b1413d, #4521)
   * Fix: Kicked-related message was not blinded (commit:a2b0ded3b90abaa828d910e6583b66d07b97438c, #4521)
   * Fix: Improve connectionString parsing, including for IPv6 addresses (commit:8e7fabf243967b26d3b96d2941a7d6826d502930, #4523)
 * Balance MP:
   * Change: brain.json: Adjust shield strength; Additional sanity checks (commit:2622f38fc8c94627f3da1075e51431c1b9794b6b, commit:5dec5ba6274fb785f08dd43092e15e67fc1e23d6, #4522)
 * Other:
   * Add: Add Music Document (commit:8c2572d94162dbebdddbeed815a46f0dbc8ea7e8, #4174)
   * Change: Update angle vcpkg port, vcpkg baseline (too many commits, #4500)
   * Fix: Fix segfault with dumpinfo.cpp trying to use a WZ_MUTEX (commit:4f551999640f519b723ce6384a4c4036ab84d0f1, #4482)
   * Fix: Additional sanity checks (too many commits, #4514)
   * Fix: Match the pre-#4281 behavior for flying unit factory production placement (while preserving the fixes for other units) (commit:c75f6bbcb6df331a72d788175eec21bf55c4cfbd, #4511)
   * Fix: Increment structure count maximum for the new owner on donation (commit:9659b33c754a382f6cfe9826399b2125c356704e, #4517)

2025-08-16: Version 4.6.0-beta2:
 * General:
   * Add: Improve research items tooltips with categories and time (too many commits, #4216)
   * Add: Attempt to break infinitely circling units out of a movement loop after a set time (commit:a60772db154c813feefc30bdfe2bc714287f00ae, 4222)
   * Add: Add new combined (universal) Windows installer (too many commits, #4302, #4305, #4345)
   * Add: Added commander shields, available in MP stats so far (too many commits, #4335, #4361, #4372, #4353)
   * Add: Various mouse edge scrolling fixes, and new "Automatic" Trap Cursor mode (too many commits, #4354)
   * Add: Support multi-threaded fpath job processing (too many commits, #4365)
   * Add: Replace & revamp options menus (too many commits, #4371)
   * Change: Don't stop units if startingPosition is unreachable during RTB order (commit:44c74ab7417ad326c69621d8e58d18088efecbf9, #4285)
   * Change: Improve performance around terrain initialization, speeding up load times and reducing memory (commit:e5d2721c9509d5980484edbf515d2177071c5782, #4439)
   * Fix: Can't build if the droid is centered on the tile (commit:0506f44a8b06315ba4dcfcf48d3ff7be96ea22b4, #4141)
   * Fix: Wall gate flickering when in construction state (commit:2638082843e114a4a2ef0739282b34fcbf9ef8e8, #4140)
   * Fix: Added check for droid distance when working on structure (commit:0d580d2c68fe6ce5192fae2c03f33434c3d96d3f, #4148)
   * Fix: aiUpdateStructure: Avoid (expensive) duplicate call to aiChooseTarget for weapon_slot 0 to vastly improve game performance (commit:8c612d0ad654b7c56cc31bc162b079c2bedc4d89, #4212)
   * Fix: Fix targetAttackWeight() assigning high weights to targets that can't be hit behind terrain (commit:38662e526d2ca42ef6a15eb1b85318913cce0623, commit:79460cfc9a760803d76d313bdae36c891d7d9352, #4223, #4453)
   * Fix: Various savegame / autosave fixes. Performance improvements and display a message when autosaving (too many commits, #4318)
   * Fix: Refactor backend / window initialization, improve Vulkan error handling (too many commits, #4320)
   * Fix: Units sometimes do not retreat (commit:d32b97a09e83fc18cc54c4b7c1c9cb2c78461849, commit:50e05105d93f8a0946282c5fc4024d885d7a65c5, #4367, #4413)
   * Fix: Fix crashes related to DROID_GROUP ids and saveload (commit:44029d5670968c469dde85da03242db31966db2d, #4412)
   * Fix: Make camera mouse pan depend on camera speed, not map size (commit:a72817f904b6d924f97626b05452f5218b8f79f1, commit:69c9fde1ee3bd7755543a8f4cfc289cdb0946b32, #4410, #4423)
   * Fix: Loading challenge clears challenge name in next save (commit:23f3a30e831a3a6562d793bad709d8a374e9a9e0, #4428)
   * Fix: Improve performance when selecting targets (commit:7fc9962a4135f188841b2e431e7a2ca16c13b94f, #4443)
   * Fix: Prevent splash damage from giving exp when damaging friendly objects (commit:90a61c643dae9b73098bc1cd1d2d8f4130d710f0, #4463)
 * Graphics:
   * Add: Add Script Debugger options to Reload Object Models (too many commits, #4265)
   * Add: Show dust cloud when building structures (commit:62c2d881f20f5c061154ac133bbd36a56d0e610b, #4279)
   * Add: Added velocity gain to droid particles upon destruction (commit:3f9895b0d82aefcd9f5006680f6299577198e6b7, commit,28924447fc854d1c68d65277c0c96a6eb2896feb, #4270)
   * Add: Better high-quality water (too many commits, #4336)
   * Add: Blender PIE addon support added for PIE 4 features (too many commits, #4391)
   * Add: OpenGL: Improve OOM detection and messaging, support for KHR_debug on OpenGL ES (too many commits, #4431)
   * Add: Disable some problematic Vulkan layers (too many commits, #4432, #4434)
   * Add: [SDL backend] Support resumable video init, handle crashes (too many commits, #4434)
   * Change: Base plates on base structures don't rely on a hack to change with the tileset (too many commits, #4177)
   * Change: Convert PIELIGHT from union to struct to remove undefined behavior (commit:e348f268246d1eaced8e93426a1a36bb6ea02f0e, #4439)
   * Change: Improved memory allocation patterns for SHAPEs (commit:574f47b3e7c5eefbeb0e4efb0a4cae67f58d1f70, commit:e8c23721c1fb5d3cb48bbf2fe0f0ce05dbec5d5d, #4447)
   * Fix: Shadow issues on Pylon, Crane, Big Cooling Tower, Cooling Tower, and Water Tower (too many commits, #4147)
   * Fix: Script Debugger not showing all feature objects available in the game (commit:606a742fc9ae45760a2f5a48ef54f641cb3e0b29, #4267)
   * Fix: Fix shadow issues on cabins and wrecks and generally fix the whole Wrecked Hover model (too many commits, #4273)
   * Fix: Fixes & improvements to quick object clipping (too many commits, #4306)
   * Fix: Python body connectors tweaked to reduce floating weapon appearance (commit:16f7c5799c76622a4c6b4043244141a9395c9308, #4311)
   * Fix: Fix seams on Panther body (commit:9d1cac44b45f641406d10d2d4ec90c19b567cdb2, #4315)
   * Fix: Shadow issues fixed on metal guard tower defenses and sensor tower (commit:adf38292d83ab1c5a39db3a55da461120d79bb0d, commit:a8316ec01b99aff04af3c8a986e5b19959116e0c, #4369)
   * Fix: Hyper Velocity Cannon mount had seam issues (commit:da13eb6ee287bf254545a75d0d753bf0bc329ad5, #4373)
 * Campaign:
   * Add: Update Fractured Kingdom to v1.4 release (commit:a4f0e481171f24051a222daf1328d3fcab7cea2e, #4259)
   * Add: Port various guide topics from Fractured Kingdom into the base campaign (commit:f611a2a49ea56f3720220ea36362ea107bfecf89, commit:6b6a041ce3f3d0026a3ca79f06b544a7ae7350f6, #4350)
   * Add: Bump Remastered to v1.2.7 -> v1.2.12 release with general campaign changes and fixes listed below (too many commits, #4258)
   * Add: Adds Insane+ tweak option, fully realizing Insane with additional spawns and behavior on most missions. Will likely change a lot over time (commit:5f43426e5210742407a8878e98059f977bea2b01, commit:847d0e761c86a19015c7be39e60630967a596223, #4258)
   * Add: Give ACs some basic splash damage (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Add: Specify missing research names so research appears in the Stats objects (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Add: Add Infinite Time tweak (commit:7681dfa0febf400a0b2082cb5f75ff6460d40f1f, #4258)
   * Add: Add tweak to toggle victory condition reminder (commit:0892665f1168ce5fba32271f04ac453a02d485cb, #4258)
   * Add: Add tweak for Gamma End bonus content, can play it in Classic now (commit:32691fd8f4fc449f71e6e7ecf6672b6dfc0284f3, #4258)
   * Add: Add tweak to toggle between Insane and Insane+ (commit:847d0e761c86a19015c7be39e60630967a596223, #4258)
   * Add: Add tweak to toggle Insane+ behavior on lower difficulties (commit:80c51fa9d4952821f0068a3be24f7d1781933a7f, #4258)
   * Add: Add new Gamma tower defense mission tweak option (commit:db8c5979ea65b2c81934d1d05c381031ddfb6adb, #4258)
   * Add: Add tweak to increase EXP gain (commit:aac3ffb4f8ad688c5bfe5f8c276bb94d1b48249c, #4258)
   * Add: Add tweak to make your structures stronger for those that like to turtle (commit:505e382b11c4e7d8bf61436770b3768795b08cff, #4258)
   * Add: Add Wreck objects to Fastplay, Alpha 3, and Alpha 4 to give these models some use (commit:c2d6a3a2476d865a5ee7df7debd090211c6ef653, commit:b1a4948bc7b8f25103b3a179b08b4ce5b4000c76, #4258)
   * Add: Add Wrecked Hover features to the Alpha 12 map to make use of this model (commit:45289878c3c9a7f5906bbc4832ccceb53ca2a35c, #4258)
   * Add: Add "Defending Your Base" guide topic (commit:a92bea6ca281432a31319ff2bef61a758df5b121, #4416)
   * Change: libcampaign: The VTOL spawn system can make use of reinforcement conditions now (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: libcampaign: Unify VTOL retreat and disappearing code into one new set of conditions and rules inside camVtolCanDisappear() (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: libcampaign: Increase default factory group defense radius from 5 to 6 tiles (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Move first Alpha alloy into Alpha 5 (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Make Tank Trap research cheaper compared to Flamer/MG tower (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Reduce Bombard research time to make waiting not so long after beating Alpha 8 (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Make Pepperpot do more splash damage than Mortar (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Make Whirlwind do more splash damage than Hurricane (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Reduce price/time of Gamma cyborg research (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Half research time for Repair Turret to reduce wait time on Alpha 1 (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Bump Pepperpot to 60 splash damage, leaving it perfectly in-between Mortar and Bombard (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Change: Experiment with increased spinAngle on Tracks to make them feel better by packing more units closer together and making pathing better (commit:d6d24a4ee6200e6e16b47e0e8cdddf8d277bc472, #4258)
   * Change: Change Alpha 8 behavior to allow better sneak potential before the second LZ (commit:c4655a0201c59a2c6bbc13132b65bbd4e42714e3, #4258)
   * Change: Make VTOL HC, MGs, Lasers, and Rails have better damage output; Fix Vindicator weight being too high (commit:9671a434b52607d5b2b0cc7439d27e4d5be1e6d4, #4416)
   * Fix: libcampaign: CAM_REINFORCE_NONE was defined but unused, so make use of it (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: libcampaign: Transporters won't get added to groups via camMakeGroup() (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: libcampaign: camGenerateRandomMapEdgeCoordinate() and camGenerateRandomMapCoordinate() were improved, adds Hover propulsion support (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: Prevent Gamma 3 Project ally stealing your oils. libcampaign: camManageTruck() toggles if an AI player can go after oils (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: Upgrade obsolete units on-map to appropriate ones (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: libcampaign: Release partial factory groups when their factory gets destroyed (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: Make a factory produce Tank Killer units on Beta 9 rather than Lancers (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: libcampaign: Transporter bases now can use an object `posLZ` to specify coordinates for where to land the transporter (not just computing the exact middle of the base) (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: Anti-Cheese the lassat on Gamma 7 and 8. Spamming low rank or cheap units or even walls/tank-traps won't distract it, and trucks will automatically explode when going inside the Lassat targeting zone (commit:5f43426e5210742407a8878e98059f977bea2b01, #4258)
   * Fix: libcampaign: Fix losing after winning when timing a victory precisely at the end of the mission timer on offworld missions (commit:faaef12c9bd53d8c00dc87b66032f914db2eaae1, #4258)
   * Fix: Fix patrol position of the cyborgs defending the Alpha 12 base so they won't get trapped behind the hover factory at times (commit:e8da2231617d720a0279711d6350d952c260bc11, #4258)
   * Fix: Fix the Gamma 9 East Hover patrol position to prevent bottlenecks with units amassing (commit:d9ccd1ed6c2f2719e6b288f24ea3a2f21a232e57, #4258)
   * Fix: Fix VTOL Rail Gun not shooting air units (commit:effedf90f8683711ea65d4c232bcb8158265561e, #4258)
   * Fix: Restore final Alpha MRP/MRA damage upgrade on Alpha 11 since 4.5.0-beta1; Make editing the artifact here easier so this never occurs again (commit:05ff1d31275bd1e71b61322b6d6d1a287d6808ae, #4452)
 * Multiplayer:
   * Add: Initial blind lobby / game support (too many commits, #4175)
   * Add: Skirmish / MP Match Options UI revamp (Advanced Hosting Options, Match Option Preferences, etc) (too many commits, #4291)
   * Add: Add host override to wzcmd event (commit:75dc0e6b917f82fa2cc53e07b9ab851796a7e50f, #4230)
   * Add: Minimum replay file format support (too many commits, #4455)
   * Change: Deprecate current rating lookup, remove user-visible option (commit:41c9bfd54e59acd6215eb06245b8cde53fc4780d, #4408)
   * Fix: Various updates to wzmaplib, map-mods now unsupported (too many commits, #4183, #4184, #4185, #4244, #4193, #4338)
   * Fix: Fix boundary check in script generated maps (commit:a7e3e06862dfb914b28a3fd2bb7cc8d0a269549b, #4156)
   * Fix: Form with replay buttons overlaps with options button (commit:84f8141dec5c841b1e53f47244c73474ba20803f, commit:26af8b772faea61412a7ea168514a0cec7888922, #4144)
   * Fix: Fix premature game loss with mp end conditions (commit:5be1b062d6b6842e71501a0c3ddd407d0442af10, #4266)
   * Fix: Support for kick_redirect and redirect identity command, Deny player name changes when host-muted (too many commits, #4332)
   * Fix: Tighten template design validity checks to prevent someone creating tanks with VTOL weapons, production also prevented (commit:52679bfffdfdbb6769f4c76c7227832b2fed2e81, #4352)
   * Remove: Autorating removal (commit:6438d020c51a11c72703d653f4bb8227eb943aec, #4457)
 * Scripting:
   * Add: Migrate over to quickjs-ng (commit:530f32f35c89ffbce33421c62c7cc66688c15eb5, #4194)
   * Add: New API function structureCanFit() (commit:f5693c8aadbca9ab52babcffa70fa170809e6181, #4405)
   * Change: Center beacon blip (commit:2f7bfd38df78f6fb17bcf2b340114d652073609c, #4168)
   * Change: Make fireWeaponAtLoc() hit immediately (commit:2c59a84dfdcdc6a4797b0bbb700ad343a1a77009, #4420)
   * Change: Fix and alter how the script debugger changes players (commit:ec498e6e4ad7e2ad98c5d03045e83978935bcdc7, #4445)
   * Fix: Fixes to ensure JS_FreeValue() is properly called (commit:b87aea945efb71aed996a1129b95369fcbbabfe6, #4190)
   * Fix: Fix firing of triggerEventPlayerLeft causing a desync (commit:bf838214909bbc2eed429326fc3b7585b9c37ab3, #4333)
   * Fix: Remove the g_pProjLastAttacker global used for eventAttacked to prevent a potential dangling pointer (commit:5a60f05cf4d7ad67d7dd99f3f16c646fe7c04a38, #4462)
 * AI:
   * Add: Add default AI main menu option in Multiplayer Options in the main menu (commit:9faab21054d09e4e664203e0f69818fb7387f24d, #4221)
   * Change: Preserve skirmish AI difficulty when changing AIs (commit:dbed0473de9f86faba735bbee9dfc6f1abc87ba6, #4221)
   * Change: Make NullBots build more VTOL rearming pads (commit:97660b3ef5d81a29b82af0b7e9fa1532c71c8d84, #4399)
 * Networking:
   * Add: Introduce abstractions for client/server-side sockets and connection providers (too many commits, #4105, #4189)
   * Add: Introduce ICompressionAdapter facility for dealing with compression (commit:2fe630f32c35c8930932cd7805ff7f171de8a128, #4191)
   * Add: generalize checkSockets() function to be usable with various polling APIs (commit:37615f58fe18e3af78d8758ea9f6065c4d213d16, commit:b05594e04d9311c1d46eef70c0e5302746b43d2f, $4196)
   * Add: introduce per-WzConnectionProvider pending writes manager mapping (commit:250dabf6818d9ee7d0376cdbc9df61277fa77fa9, #4218)
   * Add: host network backend configuration (too many commits, #4231)
   * Add: GNS network backend implementation (too many commits, #4280, #4297, #4298, #4340, #4332, #4381, #4401)
   * Add: Support async join approval redirect (commit:c791193c747c53d5203d7b8dd107fafd00e46dc5, #4374)
   * Add: Implement pooling for NetMessages (too many commits, #4387)
   * Change: Simplify connection status checks (too many commits, #4195)
   * Change: Extract tcp's socketThreadFunction to a higher level entity as PendingWritesManager (too many commits, #4203)
   * Change: Move checkSocketsReadable to a higher level of abstraction (commit:0b57a36cc4ca824db0fa14def321dd581eced568, #4208)
   * Change: use WzConnectionProvider to create instances of descriptor sets (commit:75025145d3c168dcc4ba76210dca4ab8b4f5bbe4, #4209)
   * Change: some more IClientConnection improvements (safety and completeness) (commit:4d9ae13eac77478497884ba2069fc00768d0e9c7, commit:45b93a96f81f87ef5b35b6bd22dd203edba668c7, #4210)
   * Change: pass compression algorithm to IClientConnection:s externally (commit:e96d22e24e38f05e2b74a3bba1f6d42aa8c4aba9, #4214)
   * Change: un-hardcode connection provider setup (too many commits, #4224)
   * Change: Get rid of static message reader/writer instances (commit:337e2e89cafd2a65f2361029baf7e38d8dc434fa, commit:325845ea312059de843c68d7facdd1ef0f7afad6, #4337)
   * Change: Avoid copying underlying NetMessage data upon transmission (commit:8702dc9d674fb266df17f6780fe33ec9ec59e886, commit:fbcb5dc6d47aef734f25b162e872f1953ff516cb, #4368)
   * Change: Send game time updates only to human player slots (commit:04aea4afdf9d1ee3489560a7b950f719dca4c299, #4376)
   * Fix: Bump MaxMsgSize and NET_BUFFER_SIZE, improve handling of sync logs (too many commits, #4303)
   * Fix: Avoid excessive droid info copies in sendQueuedDroidInfo() (commit:72d59922ce5d3183238be2f2c6352b0729bd3b53, #4344)
   * Fix: Fix crash on host game quit due to invalid C-style cast (commit:eee51e4465cc0935d2a108c233aea2987bc9429e, #4384)
   * Fix: Various cmdinterface & netplay & blind waiting room tweaks (too many commits, #4396, #4406, 4424)
 * Balance MP:
   * Add: Add Particle Gun Laser weapon (too many commits, #4248, #4349)
   * Change: Adjust Emplacement-PlasmaCannon cost 200 -> 350, buildPoints 400 -> 500 (commit:5fde89c6b84764406bd4af1f0db18976ac197fc1, #4206)
   * Change: Increase spinAngle for Tracks in MP 45->65 to allow better unit packing (commit:a1f5090e9339c28ccd4a0b5aab2c34017bed9320, #4417)
 * Other:
   * Add: [Vulkan] Call vmaSetAllocationName for various textures, to aide debugging (commit:3f7a18ab966cc8ce08a4539399bb7eafac723e47, #4242)
   * Add: Add underRepair state / counter to DROID object (too many commits, #4295, #4347)
   * Change: Replace last occurrence of strtok (too many commits, #4260)
   * Change: Use unique_ptr instead of raw pointers for DROID_GROUP storage (commit:f5ead772042e800766c584234a03292e246a2259, #4328)
   * Change: Bump CXX_STANDARD to C++17 (commit:5adc6c973b03fe2884a9d6fe3e8bce702eeea8fa, #4343)
   * Change: Bump MAPTILE per-player counts from uint8_t to uint16_t (commit:0c62391ee07c7b12d285ea000a3866ddc4204c48, #4346)
   * Change: W_EDITBOX: Remove any \r or \n from pasted text (commit:699bc19195c4f149cf80196c6b45fcb4b3481843, #4366)
   * Change: Emscripten updates. Support for newer Emscripten flags, bump CI to Emscripten 4.0.1 (too many commits, #4385, #4397)
   * Change: Update README.md, split into some separate doc files. 21,000th commit! (commit:871f1c64fc0cc62b41fee1ea42abc8c8594e9940, #4386)
   * Fix: Improve visibility related performance (commit:557c3cd1aa568d7d618f68d69033854f1cefaf32, #4213)
   * Fix: Fixes for compiling WZ when specifying C++17 (too many commits, #4245, #4245)
   * Fix: Fix various edge case scenarios and crashes, add sanity checks (too many commits, #4310, #4440)
   * Fix: Inform interface when a droid is removed (commit:1f96fdf6fbf78279664a2d36b1024e2dd9033497, #4317)
   * Fix: Various fixes for gifting droids (messages, sanity checks) (too many commits, #4319)
   * Fix: imdload: Avoid unnecessary iIMDPoly heap allocations (commit:77d5d070ece882bc367630223abdbcb8648df96f, #4321)
   * Fix: Fixes several obvious rendering artifacts, including smoke effects over structure baseplates (commit:ec05b946ce1b69fc15761f3ed580921b254761b5, #4325)
   * Fix: Better sub-tile precision for tile screen coordinates (commit:a78f6f60552fb0da9a4002c32fd67f734081071e, #4322)
   * Fix: Better preserve the order that models are drawn (commit:d32bca260c3ed78a11545f6837d60722c1adc9d2, #4342)
   * Fix: gamehistorylogger: Output score as signed integer (commit:3e098dd6f9d8e9cc8b4c1439124e340e23383184, #4359)
   * Fix: Improve PopoverWidget handling (commit:75a26d7b4e114ffa2e97ee18d8bebe30737f6936, commit:b09c9ba558b0d6eec5266bb0b02fd7a5dd59c162, #4379)
   * Fix: Sanity checks for proximity messages (commit:b1869991eee027a815995b3cbec1f1825ace7eb6, #4390)
   * Fix: Skip expired pages in PagedEntityContainer::find() (commit:89818a18ab18654ada670970a00187a1092d8279, #4427)
   * Fix: Use surface height to calculate tile screen position (commit:262d841aefaf84c035c763769c3cbc999778c8e9, #4459)

2024-11-13: Version 4.5.5:
 * General:
   * Fix: Various potential crashes (too many commits, #4124, #4127)
 * Multiplayer:
   * Fix: Handling certain socket disconnects and error states (commit:845dee0c21bf70cbff540aab2e277ba24999d6be, #4124)
 * Translations:
   * Change: Translation updates (commit:5a891f4b7d0bf110a38694514c6bbbfd6e6da95a, #4123)
 * Other:
   * Add: cmdinterface: New event output, room status json output (too many commits, #4128)
   * Fix: Compilation with Vulkan SDK headers >= 301 (commit:7f8bb2772be83f57a41cd7caf05d84be87a57194, #4122)

2024-11-06: Version 4.5.4:
 * General:
   * Add: In-game options button (too many commits, #4106, #4113)
   * Fix: Transporter timer capacity label area should be clickable (commit:29343d2de5e835c51d08c67c2fbc8a72ccf806e5, #4106)
   * Fix: Do not remove vision from transporters when loading saves (commit:e8530d5828d488523d09a475f012452cb428e2f9, #4094)
   * Fix: Various potential crashes (too many commits, #4069, #4103)
 * Graphics:
   * Change: Improve high-quality terrain water (commit:adcadc8a5ce709e72fc53997ce5cb56c9540930d, #4101)
   * Fix: Loading high-quality terrain water diffuse textures (commit:3a0bc57e8429d77a21af06e15a015076c498f4d5, commit:9008a3bf9fb0f2ff7295b44f87941ade1545121d, #4093)
 * Campaign:
   * Change: Convert Brief and Proximity files to JSON (too many commits, #4068, #4114)
 * Multiplayer:
   * Add: Initial support for admins changing settings via UI (commit:4e7f99ed92e2022f0793372f617511b60147daa8, #4110)
   * Add: Host auto-kick on sustained desync (commit:f8ec4d844335ac70004861202db217f46f2cfab7, #4112)
   * Fix: Refactor socket operations error code return (too many commits, #4092, #4097)
   * Fix: Add campaign HQs to MP stats (commit:b9508a4ba5501d7cee69163807bcacb66c88b108, #4100)
   * Fix: Display and log connection state on joining screen timeout (commit:cc6a1f30d6625e56d2d67305dbf198990cfd522c, #4112)
   * Fix: Only play "Player is exiting" audio when player slot drops, ignore spectators (commit:b9c37598bc48ca1eb9017ea2e740a91e09b098dc, #4112)
 * Scripting:
   * Add: Research field for Stats object (commit:e09daaa63be94463850d8328cc8ce39cd7c660e9, #4091)
 * Balance MP:
   * Change: Plasmite Flamer boost (commit:b0eedf4f57b96a53aecbf8fa3ef0e73d3df816b6, #3989)
 * Translations:
   * Change: Numerous translation updates (commit:98f1a4801b60388685c8bd610b9b33048c0eb6e4, commit:7332fc166c40bf5418419a3cac05f25f7dbaeef7, #4066, #4117)

2024-09-12: Version 4.5.3:
 * General:
   * Change: Give experience when squishing a scavenger (commit:736fae8e874744a7156de54ad4330cb22ab9ec01, #4046)
   * Fix: Various potential crashes (too many commits, #4050, #4051, #4053, #4063)
 * Graphics:
   * Fix: Reset object animation state in a few places (commit:84b93d9c0b12e924a2aabaf35ce02d5124485df1, #4049)
   * Fix: Additional graphics backend fallback options for macOS and Linux (commit:347b7d07835afe1ecf91fd4750890c67e6e3c1b4, #4052)
 * Campaign:
   * Fix: Visibility of units restored during limbo missions (commit:22fa9439c8515b52fd816323f9f0a2a0fe985b7e, #4045)
   * Fix: Reset structure functionality references to objects when going offworld (commit:1de0822cdc1c3f1f650b1c531ebce2fe03918bf0, #4047)
   * Fix: Fill VTOLs when going offworld (commit:87ae96c79799ebe066b5213ea3d49891b3a8a1eb, #4048)
   * Fix: Update Remastered balance (too many commits, #4056)
   * Fix: Update Reclamation addon campaign (commit:9f2ca2e418ed8dfdb9488cb0e11d052fdd3aa1b0, #4059)
   * Fix: Update Fractured Kingdom addon campaign (commit:c980864ed7a920f1419d4027633438276da85d6f, #4059)
 * Translations:
   * Change: Numerous translation updates (commit:c0b1156087bc8654cc3d1f90fa588ff79769c7c7, #3996)

2024-08-13: Version 4.5.2:
 * General:
   * Fix: Make "Reset Pitch" keybind consistent with initial starting pitch (commit:9dd8289e0dff40c2c61b410c924bb9f118b068cf, #4007)
   * Fix: Pending research states when loading savegames (too many commits, #4025)
   * Fix: Units set to hold position don't fire (commit:fa5922fd81af587ed9539240bd382e3e19d3a9ea, #4032)
   * Fix: Various potential crashes (too many commits, #4020, #4021, #4033, #4036, #4037)
 * Graphics:
   * Fix: Improve effects blending when fog is enabled (too many commits, #4017)
   * Fix: Improvements to groups UI (too many commits, #4016)
 * Campaign:
   * Fix: Commander rank thresholds (commit:2db8407581657cf341caf769dddc1f14d5024718, #4026)
   * Fix: Update Fractured Kingdom addon campaign (commit:2e51e96bebce2c7796705105f3b3862bf9371461, #4038)
 * Multiplayer:
   * Fix: UPnP compatibility with certain routers (too many commits, #4023)
 * AI
   * Fix: Use eventGameLoaded for Cobra AI group initialization (commit:7801e80174efd8d20d0f0cab4177a185dcba7191, #4040)

2024-07-08: Version 4.5.1:
 * General:
   * Fix: Various issues with special research topics, "give all" cheat (too many commits, #3961)
   * Fix: Log failures preventing new terrain renderer use and warn user (commit:90b09a45ac6ecff6be5ffd4eb5c65c38849a3360, #3977)
   * Fix: Display information for loading errors caused by mods (commit:b2e54ab549cc4fd34560c3d1d933312d42cfe860, #3978)
   * Fix: Improve handling of mod loading failures (too many commits, #3981)
   * Fix: wzapi: Avoid undefined behavior handling nan (too many commits, #3986)
   * Fix: Various potential crashes (too many commits, #3959, #3967, #3971, #3974, #3976)
 * Campaign:
   * Fix: Propulsion stats in Classic balance (commit:06d1c93d8e11008492776fb86136bca922294a2c, #3961)
 * Multiplayer:
   * Fix: Various netplay log message & state handling issues (too many commits, #3960, #3980)
   * Fix: UPnP compatibility with certain routers (too many commits, #3964, #3987, #3994)
   * Fix: Support auto lag kick for spectators in lobby (commit:2d4ce35607a89961340370b0953713c92ec3ffd3, #3997)
   * Change: GameStoryLogger: Log cheated var (commit:f0f280eaadd314a58aab1f54cc2e3aad9917bbdd, #3975)
 * Balance MP:
   * Change: Reduce prices of certain defensive structures and buff some towers and hardpoints (commit:8164d3bbcdc26320c6efb48125f2b4fa19e3fb69, #3952)
   * Change: Adjust research cost of all defensive structures, except for artillery and bastions (commit:4e2578242c3359ee102669407181f9ad0c752e90, #3965)
 * Other:
   * Fix: Update autohost docs & examples (too many commits, #3983, #3984)

2024-07-01: Version 4.5.0:
 * General:
   * Fix: Exclude retreating droids from formation speed limiting (commit:962136a52487178fb6085cd3fa1a46028173c1a8, #3943)
   * Fix: GameStoryLogger: Generate final frame (commit:406aa3737d89bbb31796c1bd4112a158067194da, #3944)
   * Fix: missionMoveTransporterOffWorld: Clear additional state (commit:976642896b2b6048b33720a496cb93ff8d750936, #3945)
   * Fix: Only process structure group assignment if no droids are also selected (commit:01f80d8461cbdbabfcc3f4cdc965520e79ba6f98, #3949)
   * Fix: Prevent artillery units under firesupport trying to ram targets (commit:badbf21afa3b22cf0319ad147b2fb26b21caf8d4, #3950)
 * Campaign:
   * Change: Some buffs for campaign weapons (commit:38f8e98902eaad204c4cca52263644f8509ad617, #3946)
 * Other:
   * Fix: Emscripten build info (too many commits, #3951)

2024-06-28: Version 4.5.0-beta2:
 * General:
   * Fix: auxStructureNonblocking() for script-queued object removal (commit:14b50356ff4fc61d7bee4b509053c7fc369a65da, #3912)
   * Fix: Script map max tile height handling (commit:b2865de38bc2067ea98bf310130da7530b81589f, commit:7a74975d0381c8ec13bb7c6e1c582863aec1531a, #3917)
   * Fix: Improve checkReferences & object destruction logging (too many commits, #3916, #3938)
   * Fix: Prevent underflow in getMissionTime() calculation (commit:ad280cc7c4dae19c41651490a557229c64b7bf94, commit:893a3b4a6caa70a3c21af7f1f3f9b7bd411e3152, #3918)
   * Fix: Additional checks for AI chooser handling (commit:3854a97098e368f5051d9d233d75049555535d38, #3913)
   * Fix: Create un-versioned mods/campaign directory (commit:5a978fcd1843c3e090111ad9ad6f636e50682281, #3924)
   * Fix: Clip difficulty modifiers to always at least be 1 (commit:0d36fa7a18cea89f74c1b9e545e2388b881c5c37, #3920)
   * Fix: structure.json: Add support for new "baseStructDamageExpLevel" option (commit:1c46b8980636c786e4a39c06d4e586f2c022d093, #3927)
   * Fix: Handling pause states, and guide screen pausing (too many commits, #3930)
   * Fix: Close button on multimenu form (commit:0247d2988f6113ea1bbcd08e8420e7cffc45f6e7, #3923)
   * Fix: Guide Topics: Use different designs for Sensor/Commander guide units to avoid spoilers (commit:17b5ebf35aa1e4fc9fcb6dd965f412ae074ceea3, #3935)
   * Fix: Droid map visibility after returning to home base from fresh away mission saveload (commit:aace08b1c96fc86321441d7b624144aaca11d5b4, #3934)
   * Fix: Check if inside scroll limits before repair/RTB (commit:93a63ced26a9a05e909162264be1d229f4222481, #3936)
   * Fix: Various potential crashes (too many commits, #3914, #3929)
 * Graphics:
   * Fix: Snap muzzle graphics rotation for invisible weapons (commit:4aa75471a7872562ebd4397e4e1bdfa39ce9663d, #3926)
 * Campaign:
   * Add: "PS1 Modifiers" campaign tweak option (commit:2dd38cb06914e4879a6a43d4c02f524a0bc3b157, #3920)
   * Change: Move level loading codes into library (commit:4c6119ebe83e4a34809e28b8495cc90de4799cc8, commit:8609b3cabc6a1678e714990ba0f13339441cd04e, #3919)
 * Multiplayer:
   * Fix: Silence certain spectator-related messages (commit:3d3175d9542d09c73df9d85917ee36a6ae72e629, #3922)
   * Fix: Send auto-kick messages as system messages (commit:8ce7354847ac9b38a23fda164e4ad43cba906fd9, #3932)
   * Change: GameStoryLogger: Add player identity to FixedPlayerAttributes (commit:a1c4bb8512697436d00b537d4e6bf856cad1155c, #3921)
 * Balance MP:
   * Change: Revert 4.5.0-beta1 structure update for MP (commit:102e81cb7f63d9b712c97cc3a591b36c5bbd8f40e, #3927)
   * Change: Decrease HP of Plasmite Flamer (commit:be0e48ac3f95a5e2d9e90fb16cbcbdf9e6b148f4, #3933)

2024-06-23: Version 4.5.0-beta1:
 * General:
   * Add: Emscripten support (too many commits, #3613, #3630, #3643, #3730, #3743)
   * Add: Alert the player to the Lassat being ready via text and audio cues (commit:83f03f31ec40e8d5d55931b41155b1aa65535abd, #3738)
   * Add: Automatic assignment of units produced in factories to groups (too many commits, #3628, #3804, #3806)
   * Add: Add an in-game guide viewable in the escape menu and teaching the player fundamentals throughout the campaign; Various internal UI improvements; Add guide.js to libcampaign (too many commits, #3836, #3863, #3865, #3876, #3893)
   * Add: Formation speed-limiting (too many commits, #3904)
   * Fix: Reset pitch on moving VTOLs after saveload (commit:8346cc2c6356f03deeda66f71aaca6e1405e9393, #3555)
   * Fix: Return to base/LZ when set to retreat at a health level without HQ or repair units/structures present (commit:6a6832aca59e55b43c654d73e3692804c94500e6, commit:dfb2aea8a6d4b24b78fc2631cc99cefc9ebed4bd, #3557)
   * Fix: Do not override saved camera position in skirmish saves (commit:36f970660b09d307a3303740595d3ccc7a598c74, #3558)
   * Fix: Calculate weapon pitch from turret base to prevent wobbly effect on turret when very close to target (commit:e39e763259ca55539ad522159b13383270d37f14, #3538)
   * Fix: Fix damage formula against structures and features incorrectly using Green rank damage reductions since v2.0.10 (commit:a19141ce7e58deaf35494e081da582321d3f9cd9, #3361)
   * Fix: Fix fully armed VTOLs attached to sensors sitting down near former targets (commit:86bb59be4e2fed457f89387f8555b53a116e78d4, #3573)
   * Fix: Various potential crashes (too many commits, #3646, #3647, #3657, #3789)
   * Fix: Prevent scouting/patrol allowing CB droids observing something (commit:748df17934f2614811df7ed374f1ab48083f9933, #3685)
   * Fix: Prevent droidUpdateBuild() passing a negative buildRate to buildStructure(), causing allies to delete your buildings sometimes (commit:d04f77d3707f9e8c38d9de64e8062e7cbfa65848, #3744)
   * Fix: Prevent in-game menu saves changing the challenge score data with the wrong name. Thus not showing score on the challenge tip (commit:af14f626177bb190c164fbc7d9d8164c3472f24d, #3763)
   * Fix: When upgrade change value is negative, use iDivFloor() to floor values (commit:2f00d6def39a0fad713b8210dd7d82268bbe7728, #3795)
   * Fix: research.json: Add support for new "calculationMode" option to avoid accumulated rounding errors (commit:43e8fb0e1dcb76663444b317fc179de2ab068df9, #3796)
   * Fix: Load saved research state before any droids or structures are loaded fixing research attribute re-application issues for home map objects (commit:ca7c20dde8769aeb373c78f77d1a32b409fd0312, #3816)
   * Fix: Prevent sudden tab jumping in the build menu when trucks start a new structure (commit:4b17d7c439dbf9154dfc9bb82b4a45e519cbe2f8, commit:ec5362fc2598b1a625def9a0b98a898755812fbe, #3817)
   * Fix: Enforce Weapon Pitch Limits + Fix Weapon "Unlatching" (commit:ce0014566e01034e0faa2afc73ac512bfe6676d4, #3821)
   * Fix: Improve functionality of favorite buildings (commit:30ae267472c855127f534f4bdae576847cd13ab8, #3841)
   * Change: Teleport units next to Nexus Links (commit:78f09c0a8f0dc3eaf36e4795366902e02eb4e0b7, #3556)
 * Graphics:
   * Add: Support for per pixel point lights (too many commits, #3587, #3610, #3614, #3672, 3784)
   * Add: Add ability to reload model textures at runtime in the debugger (commit:d82483a1295c36b228d83ed2db1e17e1584887a4, commit:86b7b0104431004b34d4505113c97509035ec05a, #3599)
   * Add: Let trees cast shadows and improve tree models. Plant them better to the terrain. (too many commits, #3679)
   * Add: Add Collective/Nexus faction Forts, Collective mortar pits and bunkers, Collective T/L shaped walls, fix seams on Nexus bunkers (commit:130be3890753a321fac90997f6fa971080031e4d, #3822)
   * Add: Give the Assault Gunner cyborg a unique weapon model based off the Assault Gun (commit:82e5de679df55c3a6f900aae6183b0aff9b083ae, #3875)
   * Add: New light cyborg variants of the HVC and TK for Beta campaign (commit:5c137c5dea90992e2f7eceab6f89e85bce426605, commit:6b9e442095b5a96415faafe71f48099e2fa4fab8, #3875)
   * Add: OpenGL: Detect GL_CLAMP_TO_BORDER extensions; glad: Add OpenGL ES 3.1 + 3.2 (too many commits, #3896)
   * Fix: Rendering order of translucent models (i.e. baseplates) vs additive effects (commit:69681de090420cade30eddefc4e862fa7e99652b, #3614)
   * Fix: Limit height of scrollable lists, notably fixing translation link being barely clickable (commit:9426f096a5e865b6c5a17d54bf648ef0925ec738, #3621)
   * Fix: Fix object animation precision so as to prevent shake effect (commit:34b751620c9984580ce556e379ac585449fe400a, #3652)
   * Fix: Fix vertex-winding between Blender PIE addon and Warzone 2100 (commit:4f78fe6c4923ab8a3cba5b3ef3f7be15e42a3f73, #3666)
   * Fix: Normal terrain quality water + fog, adjust blending (commit:715d12d1f7da327f64b5d3333c918acd638bb3ab, #3693)
   * Fix: Fix tiles under skyscrapers not changing to rubble (too many commits, #3731)
   * Fix: Fix bad connectors on Mantis body resulting in odd VTOL weapon location placement (commit:70c1ca95cdaf963ceef9c7a0361abada40e6b260, #3786)
   * Fix: Fixed weapon model issues on the Tank Killer and Super Tank Killer cyborg (commit:1b5cadd9836f6e9e2b2c18b7dd8c7805a9e184c0, commit:37d41ababf08f448975db6ead52aee82454e2973, #3875)
   * Fix: Prevent shadow issues with all the non-fort rail weapons; Fix UV coords on some other mount models causing lime green areas on some (too many commits, #3890)
   * Change: Process child widget clicks based on z-order, partial refactor of Radar widget (too many commits, #3655, #3662, #3664)
   * Change: Adjust skybox fog (commit:83a3afd69dc38fbe2b66fe5ae28bf464dbac8f84, #3673)
   * Change: Warn if OpenGL version is below 3.1 as we may likely remove support for them at some point (commit:d8ce8ba76b9e684fe9fa23c1f42783fffa7418e5, #3870)
 * Campaign:
   * Add: New Campaign Selector, enhanced support for campaign mods (and campaign balance mods). Includes a "Classic" balance option seemingly comparable to at least 2.3.9 (with a 3.2.x option) (too many commits, #3688, #3702, #3756, #3768, #3789, #3796, #3813, #3815, #3881)
   * Add: Add tweak options such as auto-gain power after mission end, 40 unit limit, using classic timers, and auto-saves only mode granting 1 save at the start of a mission (too many commits, #3688)
   * Add: Allow campaign library to map tech to map created artifacts, allow adding/deleting managed tech (commit:dc906767823af3bddd1acf2838265682e2ed126c, #3752)
   * Add: Package + bundle the Reclamation & Fractured Kingdom add-on campaigns (too many commits, #3827, #3902)
   * Fix: Remove transport timer on mission results screen after losing offworld or beating Gamma 9 (commit:063874aacf1ce4205aaea538e9131808b766ba5e, #3563)
   * Fix: Prevent issues with Commanders losing groups, or Commander groups being "tied" together, after offworld transition or saveloading (commit:ba37c6ecc04a1da3c348d6a0408faab5838df9d4, commit:28f50a76c094dde37e79ce5b0efa79873c1a8b9f, #3596, #3728)
   * Fix: Use initNoGoAreas() to prevent LZs from persisting across missions blocking areas that could be built on (commit:d0f004954ff136acc04bd5a2314d71f21b123bc7, #3602)
   * Fix: Prevent launch button disappearing on LZ compromise until widget gets reopened (commit:f0f7bfc1f22cdf38a4e05a8df3ee5fcdfe92b954, #3604)
   * Fix: Let debug mode persist across missions again (commit:8602760d68f074714aa7868545b3af85f46b14f6, #3742)
   * Fix: Don't force player to destroy the Gamma 2 base to win (else would have to destroy it after the nuke event). Add hover unit anti-cheese on Alpha 12 land path factory triggers (commit:dc906767823af3bddd1acf2838265682e2ed126c, #3752)
   * Fix: Prevent noisy assert when attemping to load saves when a flag position is outside scroll limits such as on Gamma 6 (commit:f96ba155a1716590efde7a1b0cef526801aec7cd, #3769)
   * Fix: Prevent picking up artifact multiple times if units are within range at the same time (via a clone wars cheat for example) (commit:e35f41182bf0dd56f3b4d62ea7e872e48f7c41ae, #3736)
   * Fix: Fix LZ flare position being 1 tile off for LZs on Beta 10 and Gamma 8; Bring back Mobile Repair units on Gamma 4 and replace MRP towers with TK hardpoints (commit:4ba5e83f215ef01dab7587376edd48f6dd8d8a6d, #3811)
   * Fix: Improvements to video handling. No more 1 frame flicker if no videos installed (too many commits, #3813)
   * Fix: Prevent "return to LZ" displaying and playing at the end of Gamma 2 sometimes (commit:4424f877be89401642acc14bd0b7e486128afb03, #3881)
   * Change: Update structure durability, pricing, build times; Add Plasteel to Gamma; Improve damage output of all VTOL weapons by 3x+ (damage spread out over multiple shots); Make VTOLs come in waves for offmap spawns (commit:007b31e2e7759511b9e6e296f57a6d6dfbe491f6, #3552)
   * Change: Hellstorm becomes an incendiary weapon; Buff AC damage to win against HVC against tanks if accuracy was bad like from low ranks (commit:007b31e2e7759511b9e6e296f57a6d6dfbe491f6, #3552)
   * Change: Cyborg weapons stronger than tank variants; Nexus unit vision sensor set to NavGunSensor again; VTOL weapon/wave improvements; fixed rotation on Alpha 8 scavenger factory trapping units sometimes (commit:5811cdabfcb1f50540d2322e96cc0778e304dfa1, #3597)
   * Change: Add new Beta campaign cyborgs: Thermite, Sniper, and Tank Killer so cyborgs are useful (commit:5811cdabfcb1f50540d2322e96cc0778e304dfa1, #3597)
   * Change: Destroy player structures/features blocking spawn locations or transporter reinforcements; Remove most AI LZ zones that were used to block areas for this (commit:9321a87995382377eef0e17ad9fe92e1eabff28b, commit:d2e5af0c40303e572cb354467f1a4ca07198eda8, #3607)
   * Change: Improved allied or player defenses/units on Beta 1, Gamma 3, Gamma 6; Move Turbo-Charged Engine Mk2 to Beta 7; Various small balance tweaks to weapons (commit:1f5bfb2425c7f212051702c69ed1eadc78a1f051, #3659)
   * Change: Diversify and fix Beta/Gamma weapon power and build times, Make VTOL MRP an AA weapon like Sunburst, Flamer Bunker now uses Flamer Tower weapon (commit:dc906767823af3bddd1acf2838265682e2ed126c, #3752)
   * Change: Buff Wheels speed and reduce cost and build time; Experiment with new rank thresholds based off the originals; Fix Gauss Cannon modifier and make it penetrate; Base Heavy Gunner off Heavy Cannon after feedback; AA buffs; Pepperpot becomes way stronger than long range artillery; Increase MRP HP (commit:4424f877be89401642acc14bd0b7e486128afb03, #3881);
   * Change: Make Classic Commander/Sensor ranks the originals, which are doubles of those today for the first time again in 14 years (commit:8fb796890b0ada141f27746860b9c33a55c9a1b2, #3881)
 * Multiplayer:
   * Add: Non-blocking client join (w/ new join progress UI) (too many commits, #3825)
   * Add: Add a map search bar to find your installed maps by name (too many commits, #3829)
   * Fix: Fix Plasma Cannon Emplacement research showing a Pulse Laser emplacement (commit:c41351d649bcecad91f73372e4807441d606d3c3, #3684)
   * Fix: Use sounds for quick chat events (commit:2a60e342597ee42fdc9e84f0a54c25c9e5714c3e, #3735)
   * Fix: Make ban button add player to ban list (commit:be23c28a760a0e997e5940ac369d87c127be4e24, #3823)
   * Fix: Let match settings console message display for more than a second at the start of a match (commit:f636cefe5375cbbc34e41a1e3c13fa530fb0b9b0, #3828)
   * Fix: Update reticules when alt-click unloading transporters (commit:da7b3d3ea4c8b9f23cdc259aa00215850ca1e94d, #3840)
   * Fix: Improvements to autoLagKick, kick votes, and ability to kick on "Waiting For Players" screen (too many commits, #3882)
   * Fix: Check if there are available slots before a client wants to move (commit:221be397178a51017cb8ec3222e9dd5da86b870f, #3845)
 * Balance MP:
   * Add: Add Mk2 and Mk3 upgrades to the Depleted Uranium MG Bullets research line to help those that want pure MG in 1v1s (commit:96211672c757540e5b463653081aafe646b6fa73, #3834)
   * Change: Leopard body upgrade: kinetic 12->14, HP 107->120 (commit:b1fabbae7da9544df974663276c91edb5873a353, #3575)
   * Change: Port structure damage formula fix related changes to MP. Here a durability buff is experimented with compared to campaign (commit:1dcf7a0077dd11d26e15e6abf16f15f43d8c1966, commit:9709419754d3ee6671f579a822e942ad80b0c44f, #3553, #3618)
   * Change: EMP Missile Launcher splash damage radius 2->3, long-range 3->5 (commit:6b84872dd3c1318bc4f7e163bf358198cb041d12, #3594)
   * Change: HRA production time rollback 900->800 (commit:e7b3930de81307e163933521c29de0a1f5c7ad1f, #3626)
   * Change: Reduce weight of Heavy Repair Turret 3000->2000 (commit:ea8b8f6f0c6b15bf42643d0fa14169e574874a19, #3833)
   * Change: Make Hi-Energy Laser Emitter depends on Flashlight and the Heavy Laser depend on Pulse Laser (commit:832eb27cba4bc45db35aa70f34948b686046fd94, #3878)
   * Change: Buff Plasmite Flamer HP to help it last in T3 settings when it appears (commit:823e73e7576b7256d325ec8b2829401525c12f55, #3899)
 * Scripting:
   * Add: Add new REF_FORTRESS structure type and decouple fortresses from GENERIC. Add STRUCT_GENERIC stattype (too many commits, #3777)
   * Add: getDroidPath() that returns droid path (commit:e025ff02eb8fb95cdd1120d7a87555f2a8d93c3a, #3793)
   * Add: Add "direction" JS field to Structure objects (commit:62bb60a00220aa59df684502da50ad7fa254747c, #3508)
   * Add: Add an eventDroidRankGained event (commit:9758e9e0f128d949c0fbe82ae2aecb95597f3ebb, #3836)
   * Add: Add BuildPower and Weapons to structures stats (too many commits, #3897)
   * Fix: Fix property results in convResearch() (commit:bdf4a4c5a3143a213049a2c72966075350009f90, #3798)
   * Change: Update QuickJS (too many commits, #3642, #3711, #3743, #3884)
   * Change: change removeObject() API function to defer object removal. You must expect deleted objects to take immediate effect the next tick (too many commits, #3736, #3767, #3770)
   * Change: Remove rules.js hack enabling cyborgSpade. Put the component in the automatically researched truck component research (commit:ce9994640cec9571b360b32c13cd4174d5ca91ab, #3828)
 * AI
   * Fix: Fix BoneCrusher! breaking on saves due to invalid global variable initialization, and fix various linter warnings (commit:5517171f566bdd49be1cf6759204da2bd732066b, #3654)
 * Networking:
   * Add: Replace miniupnpc with libplum to support UPnP, NAT-PMP, and PCP protocols (and can be made to work with IPv6) (too many commits, #3802)
   * Change: Misc minor improvements. moved syncDebug*/WZFile related functions to a separate source file,  (too many commits, #3696, #3780)
   * Change: Pass references to sockets wherever possible (commit:e68a3370613a9c8a87dfaa41f37d7a471799c2b1, #3729)
   * Change: Reduce the number of netplay.h includes, replace with sync_debug.h if that's enough (commit:64025c9e8351d5dfc2450b220a065bc2f26bacf8, #3760)
   * Change: Enable TCP_NODELAY for game sockets (commit:24517868a0bbaa3add345c3e13e61a53593228e4, #3801)
   * Fix: Prevent net messages from being endlessly buffered in modes that don't send them over the network (i.e. campaign, skirmish, etc) (commit:02ff65758102bfcedc9199ba7a1fca2a3ba0bd12, #3720)
   * Fix: Various network improvements (too many commits, #3889, #3898, #3905)
 * Sound:
   * Add: Support higher cap for MAX_TRACKS (commit:db06a776ff642bffcd069181156f97c512868e3d, #3567)
   * Add: Convert audio .cfg files to JSON, remove a ton of lexer/parser code related to loading the old file format (commit:0594ed90d4e5d1e9d52d5b11e48b2e352c5bf556, #3722)
   * Add: Allow audio JSON files to override existing entries (commit:39b0138c6b4a24a1d411e59f310dacd9860cee44, #3772)
   * Add: Support loading audio from memory buffers, use this for menu music (commit:1c2e4eade476205c472465a92524647ce8da702c, #3886)
   * Fix: Fixed generator power hum appearing when it shouldn't; Prevent Oil derrick pump sound from persisting onto offworld maps where they would be on the home map; Cleanup (too many commits, 3716)
 * Other:
   * Add: Dedicated host documentation (too many commits, #3591)
   * Add: Add PagedEntityContainer to provide optimized page-based storage for effects, projectiles, droids, structures, blueprints, and features (too many commits, #3660, #3675, #3689, #3701, #3707, #3714, #3715)
   * Add: Generate artifact attestations to establish build provenance (commit:ab9f711178b6fa68b2741991edf039cf2b9e1cbb, #3803)
   * Fix: Fix distance checking with unit repair algorithm (commit:630ffd70599cfd5047c35d1535740bcbe702bfce, #3571)
   * Fix: Make nvtx easier to package, and add more scope. FreeBSD build fix (commit:b4e108eb5ae5bae2015a4bdb64cc060151129fd3, commit:b9f9a8bed03dbcc5204de5b42e775c4de29a499a, commit:57d397b33ec953c53feaca70743356cca61d0b61, #3585)
   * Fix: Add missing const across the code base (commit:6744315d7c6fc3185544e854d93e5f5d68ea09a6, #3593)
   * Fix: Limit artifact / oil drum pickup events to half a tile height differences (commit:17f6300d3f4ae059836809a08cacdc32ac21b28d, #3625)
   * Fix: Always enumerate map tiles in row order (commit:b43110d0fd2b63cb9181ba757d2066c69c5cf587, commit:8477d839d34db112e52b60e84e1f4474be935f30, #3641)
   * Fix: Fix "makemehero" cheat not giving sensors the correct experience, add supereasy and insane chat command (commit:ae7905a5e2ff48ffe11d750fbe16c0a5f91ee5af, commit:c7b19ffa29cb60af64ea4511e477ebfd3b888f0f, #3703)
   * Fix: Misc compiler warning fixes / dependency updates (too many commits, #3585, #3710, #3711, #3761)
   * Fix: CRC performance improvements (commit:99684c9c920816f3a5bf512a0b779c8da1e4b642, commit:717e5bd0030e1ead6c527ebf839ebfdc5388bf35, #3800)
   * Fix: Fix validity check for stdinreader (commit:f1a50c272921b9b5da8a8fe0c5d55cf82f4b3ebb, #3818)
   * Fix: Fix wzmaplib to export .lev format maps that Flame can edit/read (too many commits, #3831)
   * Fix: Improve formatting performance on Paragraph widgets (too many commits, #3891)
   * Change: Move internal containers from linked-lists to std::lists (too many commits, #3572, #3579, #3588, #3608, 3612, #3671)
   * Change: Very first steps to make DROID and STRUCTURE look like properly encapsulated C++ classes (too many commits, #3606)
   * Change: Convert C-style stat arrays for game objects to std::vector (too many commits, #3616, #3617)
   * Change: Use checkReferences to hopefully prevent all dangling pointer crashes and to help track them (commit:3dae28f96298753ac394863e2f72cd02f8c37475, commit:fa0d3c0ca2d3259bb342f1b839d2f25496bb286a, commit:7849c07f9ec5cadfd7c0add95cbcefbcf4977390, #3670, #3887)
   * Change: Update super-linter, partially enable editorconfig-checker, fix some trailing whitespace issues (too many commits, #3794)
   * Change: Make the makemehero cheat set hero rank experience to 2048 to account for the old thresholds (commit:2f38bfa8786e2aaac80bb561cd94efbd9949c7e5, #3881)

2023-11-29: Version 4.4.2:
 * General:
   * Fix: Various potential crashes (too many commits, #3539, #3540, #3544, #3545)
   * Fix: Clear active console messages when resuming from paused state (commit:aa5cbb60b26a28af3bf3945e9a3dfb68215a7224, #3533)
   * Fix: Make sure VTOLs retreat to repair when attached to VTOL Strike/CB (commit:a093cddcf0927b492885b6a35a7f88689d425bba, #3541)
 * Campaign:
   * Fix: Move a spawn position on Gamma 3 (commit:eee44f2340e6a34681a05ec03ebaf3990f92e179, #3537)
 * Multiplayer:
   * Fix: Do not split departing player research centers with team in non-shared research mode (commit:f8778cdf4b6106215bfafff2d922fd6a3ef445a3, #3542)
 * Other:
   * Fix: Use std::make_{unique,shared} instead of raw new (too many commits, #3535)

2023-11-20: Version 4.4.1:
 * General:
   * Fix: Potential corrupt game config file issue (commit:65728ec3302a5b9d2f9af1cc914647f087917e82, #3489)
   * Fix: Loading old maps with invalid map tile numbers (too many commits, #3484)
   * Fix: Text input handling of virtual key codes, CTRL+V paste, and displaying virtual key names (too many commits, #3498)
   * Fix: aiBestNearestTarget throttling (commit:066f965612344a95858a2a7e8bf2c5f9f1ca3efa, #3502)
   * Fix: Log spam for multi-weapon bodies (commit:50ed2f89ab86302309cb9fb095280733fa0e74fc, #3503)
   * Fix: Spawn position of first clone in clone cheat (commit:36229e062672f3f82584866c12d581ae2087cb45, #3495)
   * Fix: Bring back the 3 turret Ultimate Scavenger truck, Delay Ultimate Scavenger Helicopters a bit (too many commits, #3505)
   * Fix: Always tell VTOLs to rearm after their VTOL Strike/CB sensor dies (commit:1648951a80cb12be316de0161091d24a26931a62, #3507)
   * Fix: Check for non-default sensor/ecm stats like with repair (commit:9b9a4e3993f286d8df0cff12b3df22a4fea4122c, #3516)
   * Fix: Various crashes and memory leaks (too many commits, #3484, #3515, #3523)
 * Graphics:
   * Fix: Handling of MAX_VERTEX_OUTPUT_COMPONENTS on OpenGL < 3.2 (commit:e65dbe7d5f879d915322fc17849613693d6483e6, #3484)
   * Fix: Additional fixes for fallback shaders, gfx_api logging (too many commits, #3491)
   * Fix: [OpenGL] Additional error handling for init (too many commits, #3504)
   * Fix: Model connectors for Ultimate Scavenger Helicopters (commit:02bba99e7409155d8eef12e82a76ed8530eff562, #3515)
   * Fix: DROID_PERSON model display size (commit:012efdd53aefc4033b6e4bcb6f76d8389a404ce8, #3519)
 * Campaign:
   * Fix: Remove unused artifact label from Alpha 3 (commit:550ba340c4d6f2c26298355757dd5a0b26af097d, #3492)
   * Fix: Repair Facility ID on Alpha 9 (commit:e81ca4f5e6d51dc26e66f427f5116f667ec0815f, #3493)
   * Fix: Command/Build reticule init for LDS_EXPAND_LIMBO missions (commit:d89e1878e575fbb02e1c84e95e5e1ab52b023241, #3512)
 * Multiplayer:
   * Add: Chat Options UI, host mute / options (too many commits, #3514)
   * Fix: Player mute state handling (commit:edc449519d76ae3276d42714ea034d4daff15721, #3490)
   * Fix: Non-builtin map replay desync (commit:19fa67f13f2b4a2f93c93ca88acc357ec77df6ce, #3501)
   * Fix: Allow hosts to pre-configure all team slot choices (commit:ceb8eb50d92c05b0ec7b5070c0cc6e2225b60594, #3509)
   * Fix: Sort loading players by position (commit:c879bbd610b8aee3b1de2a5485e5efb57d5a04a9, #3509)
   * Fix: Grey-out button for AI difficulty if not host (commit:c59b3081b3a7e249b5c02bc39cd2afd372482a27, #3509)
   * Fix: Adjust how pending disconnects are handled (commit:b55a09212d087ef26c4a59059d7cdea3f31e3e8d, #3511)
   * Fix: Kick message appearing for map change (commit:daa37e7a2609ea6705527abf67be128b1a0374db, #3513)
   * Fix: Mod hashing issue (commit:72ae817f1fd671459411189a539883ef385e921a, #3517)
   * Fix: Refactor NETallowJoining, add async join approval support (commit:1d9fd6f97850689e2eb7ae99684dcc67e0db9e65, #3518)
 * Other:
   * Fix: Clean-up undocumented (and unused) eventKeyPressed (commit:b4cf7e25d65c24616d32966acf76666398fd688e, #3522)

2023-11-06: Version 4.4.0:
 * General:
   * Fix: Count units inside transporters for mission end results (commit:f19cf46a28ec98f0b474347423d845407d6acbd1, #3436)
   * Fix: Issues with intel map and saveload (too many commits, #3456)
   * Fix: Improve the VTOL Strike / CB rearming behavior (commit:6b9557a07c5019c937632c31fe931a53484311b1, #3449)
   * Fix: Fixup functionality when transferring a structure via giftSingleStructure (commit:31b4484b315019f3f0be0a9429f734994edec603, #3457)
   * Fix: Use SDL physical key codes (scancodes) instead of SDL virtual key codes (commit:5040443f70c03776f3d4d294b5c942f171c205a6, #3470)
   * Fix: Prevent campaign difficulty influencing skirmish in-game saveload (commit:e65aa099a74e1a9e7c7960ed5ebfe5df5e5da7e6, #3475)
   * Fix: Various crashes and sanity checks (too many commits, #3467, #3471)
 * Graphics:
   * Add: Add separate "Terrain Shading" quality setting (too many commits, #3465)
   * Change: Classic model fixes for scavenger structures (commit:ae9d4f1fb4d72011584133f3579c18120d7deb8d, #3473)
   * Fix: Various gfx_api / shadow tweaks, better first-run determination of settings (too many commits, #3450, #3451)
   * Fix: Vulkan MSAA issues (too many commits, #3448)
   * Fix: Tweak medium terrain shader to better match the previous shader (commit:74b4cc999a9153c3c41f4c721853ca20c49b7953, #3472)
 * Campaign:
   * Change: Obsolete some more tech in Gamma campaign (too many commits, #3447)
   * Change: Refine starting designs for Beta/Gamma 1 (commit:bc082d26baad8c5681250bcf6e4d2565959de810, #3466)
 * Multiplayer:
   * Change: Allow demolishing departed ally structures (commit:52c563f8e279b77709e51f06139dc1422cb87938, #3458)
 * Balance MP:
   * Change: Decrease Heavy Plasma Launcher effectivness against moving units, increase against stationary units and structures (commit:9fd8ec4801cd9e2903a5f5a5b4515f75f23a7e80, #3258)
   * Change: Allow transporters to gain bonuses from armor upgrades (commit:d5b7444d1634cb5249d5e4cb1809b2b47fd47805, #3252)

2023-10-29: Version 4.4.0-beta1:
 * General:
   * Add: Allow challenges to save replays (commit:2897e40ef22b64746d14b41aa77e68156bc79c1a, commit:6c307d0d783832656bb7eecf627047ee8db0e476, #3239)
   * Add: Add new repair droid suborder in the right-click menu to control if they accept retreating units--defaults to off (commit:c789e0c1c6e2d42d4ee7f5a0eeed97d87e3c824d, commit:b8e9ee3d36bb7f2f8228c25ee7c8e755f2a01833, #3229, #3402)
   * Add: Groups UI menu for group management (too many commits, #2828, #3363, #3387)
   * Add: Add UI Help Screen overlay (too many commits, #3363)
   * Change: Make artillery units gain commander bonuses, mimic the commander's orders, and take up slots in the commander's group (commit:faeaeede08316a9c847cbc1784bbcee1c748b173, #3177)
   * Change: Make sensors follow the Commander thresholds again for rank (commit:5d31891c18540ea28e74351e7cf27793d8b40258, #3259)
   * Change: Increase minimum vertical ascension speed for slower VTOLs (commit:b3c7788f7a58bf775bbddf1f8e98f29b80cfdaaa, #3279)
   * Change: Allow EMP weapon subclasses to do actual damage, add new stat "empRadius" to determine the EMP effect area rather than using the splash radius as before (commit:fa72ffe8c12d7c5030cbb6012c48e8d2c4c91ff9, #3343)
   * Fix: Properly update obstacle maps for allies (commit:7c3fc0f4369da3bff55a03aa6aad15abe26b2358, commit:e2f62965a03dc6ac97404ff6e009e232880d95eb, #3182)
   * Fix: Show the appropriate ready text in a Challenge at the right time (commit:f3b3141eab239acaeecd6dd02b5173140e28a3e2, commit:f6ca8d1a9e728d8260f8b5cbaa6e35e1c806192e, #3238)
   * Fix: Do not blow up allied objects for the "get off my land" cheat (commit:313793b8f738e7ea69f810766c5770bfa105fdec, #3275)
   * Fix: Various crashes and sanity checks (too many commits, #3273, #3284, #3301, #3311, #3344, #3346, #3371, #3380, #3382)
   * Fix: Preserve artillery weapon pitch after firing (commit:fd51e758d6cbba1d20372566cfbfc282c410152e, #3178)
   * Fix: Add exclusion list for terrain type overrides for builtin maps. 3p-Monocot tile behavior fixed (commit:50327484546bc45b4e4dca70696bf04845f872c8, #3287)
   * Fix: Improve map hard-coded id handling, fixes for save game queued droid orders (too many commits, #3313)
   * Fix: Prevent droids from sometimes moving towards and ramming into targets (commit:4129da71ba9f47673254a0d7df88e6a798438263, #3317)
   * Fix: Fix indices of baked-earth and green-mud in the terrain table (commit:ab2db156ce8b12d409fc4d720ede63e60bafef9b, #3396)
   * Fix: Fixing the suggested save names when trying to game the numbering system (commit:4cfce4d61b3f424bd73dec428592c4b6436cec0d, #3398)
   * Fix: Allied repair not working (commit:9529e46a8c3b5bb7d206747a591642db90bb2525, #3399)
   * Fix: Prevent repair units from highlighting their own commander (commit:cbce1ccd55b069848543fb5e04fccece07df6c72, #3400)
   * Fix: Improve scrolling in high FPS situations (commit:c936be8f1ad0be09efa067402a12f747b71ba113, #3410)
 * Graphics:
   * Add: Initial instanced rendering support (too many commits, #3114)
   * Add: PIE format 4 and model level enhancements (too many commits, #3117)
   * Add: New terrain renderer: single pass, terrain normal mapping, classic terrain, + more! (too many commits, #3127)
   * Add: Initial support for multiple render passes / offscreen FBOs. Minimum requirements for WZ bumped up to OpenGL 3.0+ / OpenGL ES 3.0+ (too many commits, #3290)
   * Add: Various terrain / lightmap improvements (too many commits, #3295, #3296)
   * Add: Add T and L shaped Nexus faction walls for MP (commit:48d5074fea313b768d90c32771ff76f9fdf80341, #3312)
   * Add: Implement initial cascaded shadow mapping support (too many commits, #3307)
   * Add: Split iIMDShape, separate game state data from display data, + initial graphics overrides support (too many commits, #3350)
   * Add: High terrain rendering tweaks (too many commits, #3368)
   * Add: Terrain water rendering / shader tweaks (too many commits, #3373)
   * Add: Initial attempt: use lightmap in the object shader (commit:06283eb385eae7d04c0f7ebdaee0fe793f600e57, #3375)
   * Add: Tweak high terrain shader (too many commits, #3379, #3422)
   * Add: [Vulkan] Add support for 10-bit color component scene buffer and swapchain format (commit:f5b9880fb9d04ec2e293d47568ae18c3c3dd40b7, #3429)
   * Change: Classic / normal model improvements (too many commits, #3347)
   * Change: Classic model fixes for the shadow mapping implementation (commit:2f2781b630526ea574b93472f12a4c52d63b2809, #3415)
   * Change: Refactor intelligence screen (too many commits, #3424)
   * Fix: Remove a sliver on the back of the standard sensor turret (commit:8af3d84ad19da331dabb1eb661d57d8f9ce58fae, #3263)
   * Fix: Close up a gap in the Mini Rocket Pod (commit:de84c71f068307c7325ee24d9e61c75ef37ece1f, #3277)
   * Fix: [Vulkan] Support different swapchain compositeAlpha modes (commit:2b43608c2d5683455f35c4ce52ffb7ce8d326a30, #3351)
   * Fix: [Vulkan] Fix pipeline rasterizationSamples mismatch with renderpass (commit:21db14c5d51a350d20c34a001ecf895afe818d54, #3384)
 * Campaign:
   * Add: New non-cheatmode chat command "rank x" (0-9) changes enemy ranks immediately, "prop x" (0-3) changes produced/spawned units to use type I/II/III propulsions (too many commits, #3328)
   * Add: Add unused NEXUS sound when absorbed factories produce units on Gamma 5 (commit:aa9f6d323ce87670499009c5df91ab3069740bf1, #3342)
   * Add: Utilize the transporter return timer on Beta End (commit:452e21bc50b79b9d854b974e4256d20ad96b56c6, #3421)
   * Change: Use Whirlwinds instead of Cyclones when starting Gamma from the main menu (commit:58cbe48710050fb71deeb7c478d761eb2477005a, #3228)
   * Change: Allow Hardened Sensor tower to appear in Alpha 5 research (commit:1258362793dfb110e8e5aa29a82649ed8cb6eac8, #3234)
   * Change: Move VTOL pads on Beta 8 next to the Command Relay instead of being behind a base (commit:4c6e98529e1c1b0c840d693859df207a150f46d9, #3287)
   * Change: Make New Paradigm use Hardened Sensor towers from Alpha 8 onwards (commit:20b0918d62606137a862fd7de8f74d53e5fc5a07, #3287)
   * Change: Route orderDroid, orderDroidStatsLocDir, orderDroidStatsTwoLocDir though network code paths like in skirmish/mp (commit:814435aa62b11698848b7fa393c91e036c1e5066, #3302, #3342)
   * Change: Use a randomized assortment of the best design components for Beta/Gamma 1 if coming from the main menu (commit:393faf4c7c72e010f15a761db2935ad7931c7408, commit:6bc54e69ad176be062c6e165f287201013365f4a, #3331)
   * Change: Huge var to let/const conversion for all data/base scripts (commit:6ff8bed4f1f450b4a18f3c9544d9fd4479c654d1, commit:5feefe20a4b92f1e8af238e8c5a0bd2acf92005a, #3341, #3349)
   * Change: Let research upgrade the mobile repair turret, set it to a baseline of half the repair facility (commit:f410d021436be8ace64a3927f02994d4528ef298, #3356)
   * Fix: Restore original northern NP base layout on Alpha 6 since obstacle maps are fixed for the scavengers so they don't drive into NP structures anymore (commit:ba046ab6f78563a0c27cc9c16699607e4b0becde, #3227)
   * Fix: Fix saved coordinates for newly produced units inside transporters causing units to appear in a corner coming back offworld (commit:183db154053bc477de47949e79b379f9110db8b5, #3264)
   * Fix: Show reinforcement timer for offworld missions after the first exit rather than immediately at mission start if they're available at the start (commit:76487add03a2e832a18aab9a5128d40a13da45f1, commit:4fee3bb360dbe2c923b8856e9c54595cefcde152, #3270, #3275)
   * Fix: Cancel in-progress/held research inside labs when changing campaigns so research results don't disappear upon transitions--like Mantis body (commit:2d92571b2187eb78b906209fee58230af66efa6b, #3278)
   * Fix: Force the player to bring a truck or factory into the Gamma 8 area of the map before winning Gamma 7 (commit:5a5270b76332f38f81739dbaa095ced3c75531a7, #3306)
   * Fix: If the player beat Gamma 2 with no built factories and no trucks on the home map they would fail coming back. Give them a fail-safe truck at Gamma 3 then (commit:de8cef477678b73e66f5b08fb96414067afd2577, #3314)
   * Fix: Fix libcampaign's camSetVtolSpawnState() when the stop object label is passed so that all spawners tied to the object get deactivated and not the first one encountered (commit:42d337bf7672f7236362ab68f68c839dea6f888f, #3342)
   * Fix: Transporters that dropped off units on Beta/Gamma 1, and are still flying back to go off map, would persist through the end of the mission and cause an unavoidable early exit trigger to load the next mission (commit:1371bcf4c89eb4fe2a88da411f0c6a647e77af27, #3364)
 * Scripting:
   * Add: New events eventTransporterEmbarked and eventTransporterDisembarked to fix Command/Build reticule edge-cases with units in transporters (commit:00ca99a53a61d9951fe94bce934b33b9996e8181, commit:19b0a8c108e56b617499dc9f3d5784ee5e52c87d, #3394)
   * Change: Expand addStructure() and changePlayerColour() functions (commit:6e5c9cf224578ca0d9c2f44ba6ff8b58821fd792, #3202)
   * Fix: If trying to use enumCargo() during an eventTransporterLanded the Commander was already removed from the transporter group (commit:88298709cdcdc38042ed6055b1739e7272005c67, #3331)
   * Fix: Fix moduleToBuilding / label mapping for loaded maps (commit:f9efb30305dc0a25dcfb8ff560f28fa3228e9a0b, #3427)
 * Multiplayer:
   * Add: Add options for handling player resources on leave (commit:6feff17279f410061d0ce56a7f8f2a0289b00967, commit:c82c37c892750c3179ef1d0642a0927893f89675, #3243)
   * Add: Initial attempt at verifying identity on join (commit:64f1834b8acaa078bb42bed77ebf1441b153b8e3, #3059)
   * Add: Multiplayer / network / lobby / chat enhancements. Quick chat, team strategy, pregame countdown (too many commits, #3401)
   * Add: Add overrides for name and color from rating lookup (too many commits, #3316)
   * Add: Various netplay, voting enhancements / kick restrictions (too many commits, #3430)
   * Change: Output all chat messages to command interface (commit:2635fcbcd5ed8d85cd0dc88f95b0ba03f11c3c56, #3274)
   * Fix: Fix default name "Commander" overriding player names on exit, leave, kick etc. (commit:23a66b04968fd72f33f8e11e9f7165ee9a352569, commit:26f2d66d00d24e596d03be437dae88433a11554e, #3152)
   * Fix: Initialize passive play warning properly (commit:e05925721d191effa24a8ba0286c576b36868d70, #3254)
   * Fix: Multiplayer stats and options improvements (too many commits, #3283)
   * Fix: Fix loadSaveFeature2 for spectator-assigned features (commit:8408aa2144fd8f89cfde73b4a29431d0e3bed8f5, #3310)
 * Balance MP:
   * Change: Increase Super Transporter base HP from 500 to 3000, Cyborg transporter from 200 to 1000 (commit:e7623112976ed37b5c6a9865a41998cdcc7c502a, #3215)
   * Change: Remove splash damage from VTOL Lancer, Tank-Killer, and Scourge Missile (commit:6f91451a6d30aa949c011353dd491a842b4f7169, #3222)
   * Change: Increase range of HVC turret from 9.5 to 10--rollback to v3.1.x (commit:56d42a9d9bd2e2bcfbe7cb85975e6550f7223ee5, #3214)
   * Change: Rollback price and times for Stabilized Rockets and HE Rockets Mk3 research to match 4.3.3 (commit:e0838fdf7f09d94ffba6bb4e6f1dd6b2d9593bed, commit:6e46316f5da06e016a26fe84f632a7765c3f7787, #3219, #3249)
   * Change: Increase Sunburst AA ROF from 58 to 90 (commit:d302a36daf8dff148e2a996c9e7e2384a4c5d731, #3217)
   * Change: Reduce splash damage of HRA and Seraph, increase Seraph reload time from 135 to 150 (commit:889c85802f865d5d15ee9d22afd09ce30afd4ff8, commit:8960d228b8def34e90f8c7e08e3fc9f530f004a0, #3225, #3266)
   * Change: Various AA turret cost, HP, or ROF tweaks (commit:6b437e7e4acffc94e142277e62724c4b1e023aaa, #3224)
   * Change: Increase costs on artillery (commit:ae15ddb3c553b437b491a9b161b2dcd7123626db, #3223)
   * Change: Various stat tweaks to Needle to help fight Scourge Missile better (commit: 1258362793dfb110e8e5aa29a82649ed8cb6eac8, #3226)
   * Change: Return various Tank-Killer stats to v3.1.5 to account for the appearance of HRA (commit:4f0778642f70123ae209491649f435d9bd554296, #3205)
   * Change: Increase build time of Fortresses by 25% (commit:d9ee0521362ddb44fdb895d8c2d8c098960c0a56, #3232)
   * Change: Reduce ROF of EMP Mortar from 130 to 90 (commit:dd0f030999404a077a636dcf9ba7ee6f42b4bd63, #3241)
   * Change: Increase ROF of Cyclone by 10%, Reduce range of Hurricane from 16 to 14 tiles (commit:073f69e7cdf70b5f53788c7fe85708f2abee20a1, #3244)
   * Change: Reduce weight of EMP Cannon from 10,000 to 8,000 (commit:8bd50fe17b40d2e7dc4932c3d89ef33829b6d0cb, #3245)
   * Change: Make Leopard and Panther come earlier, reduce weights on red bodies, and adjust stats on Leopard, Retaliation, and Retribution (commit:86fc2f9cb39ed2849d8c51dbb40b7ec03ab3e771, #3056)
   * Change: Reduce weight of Heavy Cannon from 10,000 to 8,000 (commit:78564b7174a0f01b5e550bee6a3adcacd0336223, #3246)
   * Change: Required research for Gauss Cannon changed from Hardened Rail Dart Mk3 -> Rail Gun (commit:6b7cc905ff8ce716996400f5c460944cf0a935a7, #271)
   * Change: Reduce Cannon VTOL weapon hitpoints, increase rockets (commit:ee1a232e130973d27f1c2a937dc00b3deca4cd23, #3303)
   * Change: Buff Robotic/Advanced repair facility research bonus to 100% from 50%, and let mobile repair turrets and mechanic get upgraded by repair research (commit:6567ce3f4778f23f58d5bd2e6e2f62a822ed7a80, commit:3118a6dcdce487bb3daeef54db890c590f7ee6de, #3391)
   * Change: Bump VTOL bomb weapon HP up by 10% (commit:806f503494f505ab2fc6c1dfe1c7f3a62dd2e189, #3395)
   * Fix: Replace NavGunSensor with the default sensor for Sunburst, Avenger, Vindicator, and Stormbringer AA sites (commit:bb82a7a76208e818bfedda9f79e9677859a37201, #3257)
 * Other:
   * Add: Introduced scope-based profiling instrumentation. Current instrumentation can use NVTX and/or VTune instrumentation (too many commits, #3285)
   * Add: Support cmd interface with unix socket (too many commits, #3345)
   * Change: Improved performance for looking for the best nearest target (commit:46d3d9223a989a87b6e0ce74f4552cd3e75b1fa4, #3144)
   * Change: wzmaplib updates (too many commits, #3236, #3240, #3313, #3321, #3330, #3334, #3335, #3380)
   * Change: Increase maximum saved designs viewable in the design menu from 40 to 500 (commit:b55b8cf58b96126e127d1d077846903d8c0411d0, #3261)
   * Change: Simplify faction IMD display (too many commits, #3348)
   * Change: Flatpak: Update to 23.08 freedesktop runtime (too many commits, #3369)
   * Change: QuickJS: Replace tl::index_sequence with C++14 std::index_sequence (commit:30d32697dfe05906b6979c9d42f73c7ff8a4f0b8, #3404)
   * Fix: Don't hardcode port number to "2100" in some console text message (commit:ac014411d560d9e05e06e2eed05fafb9d9fcdfde, #3175)
   * Fix: Mod loading / cleanup improvements (too many commits, #3282)
   * Fix: Reduce performance impact of the draw sensor range code (commit:60d4ebc06b4337d61b3ce730c5720a390238d818, #3297)
   * Fix: Thread-safety improvements for debug() (commit:dac2b6476f121f3ac6e924361b0323249809a3be, commit:e816b67568d42db9d81ed4da1ec094d4dabbe87c, #3309)
   * Fix: The "Unit Destroyed" sound wasn't playing properly (commit:fdc36c97727bc3ddfef3d9cb6b007a0973de0b90, #3336)
   * Fix: Show total ranks/units correctly for LDS_MKEEP_LIMBO missions (commit:3dbedc98eb3260163fa6104515588e033c61b84d, #3339)
   * Fix: Display remaining feature object HP correctly in the console (commit:56e96515d2a42d671ae51e4c2540f914182b4f0b, #3340)
   * Fix: Only attempt to play outro if user has videos to begin with (commit:588bda8a5e26aa97600b229524ec86dd0a04fca1, #3342)
   * Fix: [CMake] Update IncludeFindCurl.cmake - better OpenSSL v3+ handling (commit:b21dd483e31cfb2c4e6fc2c29ab2c54904b364ad, #3354)
   * Fix: Snap improvements (too many commits, #3355)
   * Fix: Fix WorldToScreenPSO draw call count (commit:0b7e44ea7e21461a2313d89b4d1cebcb95d20317, #3407)
   * Fix: Fix the intentional crash tester function (commit:0d8853e6a7318abb5b1ea4968c60e8e5ef3d5c78, #3411)
   * Fix: Various netplay message tweaks (too many commits, #3414)
   * Fix: Prevent Commander reticule widget list scrambling on save-load (commit:9423ce1482820a4099ad70f84fc6a6cc6197d9ab, #3403)

2023-04-16: Version 4.3.5:
 * General:
   * Add: Display kills and units in spectator stats UI (commit:b1c52e8be428e7b239e9e845288e7a968a017551, #3186)
   * Fix: "Get off my land" and "kill selected" cheats (commit:f51f234ef5902d4033d6b58a93049e03239c8072, #3171)
   * Fix: Don't assign trucks from factories to commanders (commit:f04e2d3932910213f67f82759b2005c86ff8dd0e, #3179)
   * Fix: Repairs: Reset secondary only after "go-to-rally-point" was triggered, separate RTR logic from RTR_SPECIFIED (commit:15c6fc7ae57ccc2d4dc8fc205eac14c83fd3eb71, #3194)
   * Fix: Various potential crashes and corrupt config issues (commit:fe7ebfa2bd406ee73c7363afad3a4e26e9297ce9, commit:d07b94e924ad247aaa27df5305e5aee85552da60, #3208, #3211)
 * Graphics:
   * Fix: Properly render unit resistance bar (commit:099580bc88e5443ee9f76c043102b97055e11866, #3183)
 * Multiplayer:
   * Add: /hostmsg lobby chat prefix that sends a message only to the host (commit:c563170c7eae67af799e7b8ba19a66f2241fb26f, #3204)
   * Change: Add Heavy Rocket Array to all skirmish AIs (commit:7c62ce1ddabe5925c75f5e85722fee54b449118f, #3196)
   * Change: Improvements to Nexus AI (commit:86ef42d5f8419f88f96d53a2aef69b18eae77cfc, #3196)
   * Fix: Desync with losing player-turned-spectator when certain defensive structures remain (commit:b15ec308db501988b1f8b0fb5c6e18eb1aa16605, #3189)
 * Balance MP:
   * Change: Slightly increase the build cost of Mortar1Mk1 (commit:0b4bfc612121d2c5bad91908a54900aeb9323581, #3190)
   * Change: Return Tank Killer reloadTime from 160 -> 180 (commit:3ce486735df52445042add20897de01679d3d75f, #3203)
   * Change: Increase HRA production time from 800 -> 900 (commit:d5f5fb28d95f6c285932bc40646bb0fcb3e6d4bd, #3206)
 * Other:
   * Fix: "kick identity" command should only kick, not ban (commit:da1d8770fc77e34272c4a4b7529f2ea64855b551, #3210)

2023-03-26: Version 4.3.4:
 * General:
   * Add: A separate Ban/Kick activity, allow removing from ban list while running game, and fixes for spectator mute (too many commits, #3163)
   * Fix: Various potential crashes (too many commits, #3100, #3101, #3106, #3108)
   * Fix: Let some older maps show up again in the map lists (commit:444a637345a3578b327d278b7328ebd4d0ff91db, #3109)
   * Fix: Always cancel research when starting it in another lab (commit:5f7eb0e172fa52c2e443220a5370ed88a7345216, #3150)
   * Fix: Persist Snap config data by using SNAP_USER_COMMON (commit:6366d7b51ba697351abe430a402c9e5a77a837a7, #3160)
 * Graphics:
   * Fix: Fix missing sections on Tank Killer super cyborg (commit:3e7b9d5382ab09b24a7793eb2826327f8f1382dc, #3092)
 * Campaign:
   * Change: Gamma 4: Remove middle tank traps guarding team Alpha and remove the repair units to account for new repair micro-AI (commit:e70f636345f71b02cbed9d25628ef2a260809fa2, #3058)
   * Change: Always blow up walls and tank traps during Nexus transfers in campaign (commit:8e7e7fdad4ec3ed5059163eeb0f36a699964fa23, #3118)
   * Change: Improve difficulty differences on Gamma 9 (commit:e396fdf9f45a7d681d1b9b477717f52d1bcec48b, #3118)
   * Change: Make Alpha 1-3 missions flow a bit more smoothly; Increase player flamer ranges (commit:31f18cc2478dcc1a62f72c171a627088ee059be4, #3132)
   * Change: Make Gamma 1 easier by activating factories depending on what part of the valley you exit (commit:a4dc62af69db6ebd77ff4f506b7a1c2241828bbe, #3162)
 * Multiplayer:
   * Add: Add lobby command: makeplayer (commit:64f50bdbb74053c8752197c634ed6642af6f0754, #3107, #3108)
   * Add: Add a join message (commit:d48073c810ac385449b275132449d1c82fdbab1e, commit:dad97d406c539399d4c1d519b59b8cbad314620d, #3105)
   * Fix: Do not truncate spectator labels (commit:66fcbeb22decbd06b49252580e8df91d5b1867b6, #3149)
   * Fix: Stop Mission Time and store it when the results screen pops up (commit:5bad9826b739252b1ffea5b72b7bcb27823aeee1, commit:8a23639e683c4d1fb5696fd23d4c961b4080e66c, #3151)
   * Fix: Preserve player identity on rename (commit:13a21a13c07983745327b8ee1e1653b516d92e76, #3155)
 * Balance MP:
   * Add: Add new Heavy Rocket Array weapon which depends on MRA and HEAT Rocket Warhead Mk2 (commit:ca9dc06f0ee3a86f29940a7a15038043292321f5, commit:d9d9d3e54df4b5aeb41fba8bb322ae71c73beeb8, #3103, #3141)
   * Change: Reduce effectiveness of artillery modifier on bunkers 40% to 20%, Reduce effectiveness of artillery modifiers against Tracked 40% to 30% (commit:46cab7cad2adbdb80150588852480eabac496510, commit:669fb3abf708662cbd5d3dd3be6cae1c94d24605, #2894)
   * Change: Make Heavy Repair Turret and Repair Facility appear at same time, improve facility repair speed by 10, and make light repair turret cost less and build faster (commit:5ba9b81f4a88546d462f8dc13f35fb3ac0ba6201, #3022)
   * Change: Buff Plasmite Flamer HP to 125 to match the HP on Twin Assault Gun (commit:bf10dfa807e30f25410a576eb26373a8a0a2864f, #3076)
   * Change: Move Pulse Laser to around Seraph Missile and drop Sensor Upgrade Mk3 requirement (commit:b3062383eaab33c26fb3c9b08cd8ae04ad9d23c7, #3075)
   * Change: Increase costs on later MG research and on (Twin) Assault Gun (commit:574b8d65c00080b400d1f9383093fde31bc53de3, #3113)
   * Change: Pull some Rocket damages in earlier, Reduce Tank Killer reload time to that of Lancer, Improve Rocket Pod long range accuracy to 50% from 45% (commit:06ec3db15164fee44ad3016df52d7951bf9607fb, #3080)
   * Change: Needle reload time matches the latest cannon weapons, nerf Super Rail gunner damages and range, nerf VTOL Needle/Rail radius and radius damage and increase weights (commit:589b226e512e6e667f481c54bd4e852effc1b378, #3081)
   * Change: Pull Mortar into Advanced Bases by removing factory module requirement (commit:93cb444ef71260981cae61ded29d146bd1ce5cd3, #3089)
   * Change: Reduce time and cost for Command Turret research by 50% (commit:e8465be7fc6c044ffd72e7aad9dba0c1f865022a, #3121)
   * Change: Reduce research topic time and cost for most defenses by 50% (commit:bf408ac0b59c56b51fceda8e9cd54fcd62cdf089, #3122)
   * Change: Increase reward for some engineering upgrades to 30% (commit:96e6878d33c4e2d13665051e08a7915ecdec6bde, #3134)
 * Other:
   * Add: Add autohost and autorating documentation (commit:2ab6c37eeb684f6b1936eb49a263f3412a92dfed, #3138)
   * Fix: Fix building with GCC 13 (commit:e872db579ec2847de29d1e3a96b35902f643b9fb, #3090)

2023-01-01: Version 4.3.3:
 * General:
   * Add: Cursor scaling implemented (commit:41f1cc5329d483e659b6b1c345ba8913692336a2, #3016)
   * Change: Prevent loading old ~pre-4.x series saves to curb strange and invalid bug reports (commit:b199936986337e9d043bcb4d5a793ca33e49d5fb, #3038)
   * Fix: Various potential crashes (too many commits, #2996, #2999, #3009, #3017, #3019, #3025, #3047)
   * Fix: [Audio] Improve stream buffer exhaustion handling to hopefully avoid occasional music resets (commit:88349c6665af2e0c7845798995efe393f4c6e70d, commit:01655ee90c558a6a149365e94192b795a6f1aab0, #3010)
   * Fix: Don't override orders with guard behavior when done repairing unless explicitly ordered to repair (commit:42cceb79ae99a0b876df022a1c2d79dbb08f6c5d, #3030)
   * Fix: Load structure and droid limits before loading droids and structures (commit:8dd23535c3118ea02ccca9effc2e4baa73cea3ea, #3064)
   * Remove: "Go Back buttons in options menu" due to causing keymapping instability (commit:40ae5a753b5fb3bba2faa3afbc8e8b1c17ec1ab4, #2998)
 * Graphics:
   * Change: Make light/medium half-tracks a bit more distinct (commit:7df11d7121c312bb51039fe7c9c7e938b1ff28a7, #2992)
   * Change: [SDL backend] Windows: Workaround for Nvidia threaded optimization (commit:4ac78c353d2f61320d81630428664db640c4dc97, #3001)
 * Campaign:
   * Change: Rebalance FastPlay to better fit the new campaign balance (commit:3dbd1ac1c7b5465d18e487d4766b459253905b20, #3057)
   * Fix: Default initialize the NP artifact group waypoint on Alpha 11 so grabbing the artifact first won't interfere with their movement (commit:2a6cd3f2c318d7847de2b381378cebb5a5972904, #3012)
   * Fix: Fix config file not storing the correct color variable when selecting a flag color in the options menu, thus reverting to green after level exit (commit:74511d2de80d387902cdcb375b87c0fb1233bd02, #3037)
 * Multiplayer:
   * Change: Allow setting up to 20 research labs in the limits menu (commit:f3a182db2ac6709fb8350915c77c4ef4f84cbd0a, #3064)
   * Fix: Attempt to improve slot/identity behavior (too many commits, #2993, #3023, #3043, #3044, #3068)
 * Balance MP:
   * Change: Use a new set of experience thresholds for unit and commander ranks; Make EMP/Electronic weapon research depend on Command Turret Upgrade (commit:f4e8da794584cf71265dd203b9422e46471b2fb0, commit:3a1a066cbe438c52bfbc55c73340b37b4884cb56, #2958)
   * Change: Reduce splash radius of the EMP Cannon to 1.5 tiles from 2 tiles (commit:e10289c37a30b7cc33031d85a8af4ed705d681a9, #2975)
   * Change: Reduce build power of the little scourge cyborg to 233 from 250 and increase range by 1 tile (commit:a12aab815f46a42abe4d573e5818e32901b1bfb4, #3004)
   * Change: Reduce Assault Cannon research time by about 1 minute, Twin Assault Cannon still appears at the same time (commit:0487d72ac323fbe311fbdb1967f144288dc81a19, #3000)
   * Change: Make Twin Assault Gun come earlier by about 1 minute so to appear before Twin Assault Cannon (commit:45f75861a0f16e7debfadbc1047d82112087aa09, #3029)
   * Change: Push Whirlwind further back into the tech tree and depend on Dedicated Synaptic Link Data Analysis Mk3 / move Depleted Uranium Bullets after Dense Composite Alloys Mk3 (commit:9550bff61b047628a55c238bab3b9d0eaae50207, #3066)
 * Other:
   * Add: [GitHub Actions] Flatpak: Initial publishing support (commit:92fc8bb3ebeb300eba603c8718896918ce9f7129, #3006)
   * Add: Attempt to create an overview document on micro-AI behavior (commit:c3a35955b2b3bdded07462750d5f567cb37a4b0a, commit:4dc1dfff0bc157f62e3e651cff4a002e4e35b27a, #3024)
   * Change: [CMake] Add -uastc_rdo_m to basis universal to improve reproducible builds (commit:27218d78258d852a2ea2604c7aefa41b202124cc, #2997)
   * Fix: Improve notifications and exception handling for them (too many commits, #3026)
   * Fix: Do not play attacked sounds from friendly fire (commit:d81a9ad2a3c931b18f4c310186a9941f21e33915, #3039)

2022-11-09: Version 4.3.2:
 * General:
   * Fix: Various potential crashes (too many commits, #2973)
   * Fix: Restoring window sometimes shows black screen in OpenGL mode (commit:24eacb55a39abb0a9540a4dbc9e046b769c3a6ef, #2981)
   * Fix: Possible high CPU usage when minimizing window in Vulkan mode (too many commits, #2981)
   * Fix: Default fullscreen dimensions should match the current resolution (commit:09fd7ee9400b5935854271f691a63df2448aa3b6, #2981)
   * Fix: PNG files should take precedence over KTX2 files, to support mods (commit:380c0fe645562ad3e82d9e3c4ca6e5a8375dbd05, #2981)
 * Graphics:
   * Fix: Missing top section on cyborg repair turret (commit:2157a83881212c0710c5796d75e3cbf0893dc40b, #2977)
   * Fix: Update generic design tank (commit:1fb78f9571d8fe48fa23ae0182803fa4baeec2c5, #2980)
 * Balance MP:
   * Change: Buff Flashlight for tanks, increase HP 100->180 and add 1 tile of range 12->13 (commit:faf8d361f18297dad37066dcd0fd4d6f05d01333, #2889)
   * Change: Reduce periodical damage on Incendiary Mortar 26-24 (commit:fe7924177444f967e664a7d8acc31b60b3f314b9, #2908)
   * Change: Remove MGAA specific research, Whirlwind requires all MG ROF upgrades and Hurricane, AG and Hurricane need MG ROF2, MG ROF3 require Assault Gun (commit:ebdf66ec4ec448191052f5a81451209239f3f021, #2922)
   * Change: Reduce price of Hellstorm from 450->400 and weight from 20000->10000, Pepperpot price reduced from 200->175 and build time from 900->800 (commit:ee0ea7fac774e54676f29fb43c5dc840f83e13ce, #2893)
 * Other:
   * Fix: 32-bit (x86) Windows build doesn't run on Windows 7

2022-11-02: Version 4.3.1:
 * General:
   * Fix: Crashes caused by certain old config file settings (too many commits, #2960)

2022-11-02: Version 4.3.0:
 * General:
   * Fix: Improve classic ("exclusive") fullscreen mode switching, additional Video Options (too many commits, #2936)
   * Fix: Give Hardcrete Gate a research message (commit:7e1599fcb1b640ee6e4f90a5d622f3b5cb4ddffd, #2940)
   * Fix: Add missing terminating entry (commit:55fb14b73486700ca8437f67527e36ccc7e16643, #2944)
   * Fix: Truncating audio streams, buffer leaks (commit:25f1944c7ad0c1ff9c6017f88fce0d974ecb1502, commit:bc82e2cd1c5fcf02b1266911a8cdd7f446a593e8, #2943)
   * Fix: Move favorite structures to a JSON file (too many commits, #2935)
   * Fix: Mobile repair turrets prioritize distant heal targets over closer ones (commit:87a729e5d0396ba6bc55dbe32e580656cafaaa12, #2954)
   * Fix: Improve fixed hotkey display (commit:6025f4b5f78230d8ffa61320b8c3a02d7bef8bba, #2952)
   * Fix: Redundant components becoming available (commit:4663d22b589c65f53daab33e4625cca1cfcbce47, #2950)
   * Fix: Autorating tooltip requests (too many commits, #2955)

2022-10-23: Version 4.3.0-beta3:
 * General:
   * Add: "LOD Distance" Graphics option, to adjust texture sharpness at distance - set default to "High" (too many commits, #2897)
   * Fix: Nickname selection in lobby (commit:3b6895150af9ee7cd12cd5a346e315f598d81eaa, #2900)
   * Fix: Cancel RTR when fully repaired, and there are no repair stations (commit:969eb3cf048c623c8ce39cd4502ea485ab6b611e, #2891)
   * Fix: Build status for trucks in helping mode (commit:cbd84aceb6455182a6bb89790a8d734c73f588db, #2929)
   * Fix: Various potential crashes (too many commits, #2890, #2899, #2907)
 * Graphics:
   * Fix: Keep aspect ratio for sequences in full screen (commit:8123696900228fafafb76466ff14ec365890747f, #2888)
   * Fix: Garbage first frame of video (commit:b5ea1149d13114824e62449a1184b6f7fadd94bc, #2902)
   * Fix: Auto-adjust menu item font size to better fit long strings (too many commits, #2905)
   * Fix: Properly render multi-level structure models (too many commits, #2911)
   * Fix: Faction model lookup for multi-level models (commit:3f6574c78b64a165460b032b78883f07766b4f03, #2911)
   * Fix: Retribution body clipping into Hover propulsion (commit:41576b8f415d1cf2a0d32b4e052cadebe0809d31, #2898)
   * Fix: Flicker with VTOL Assault Gun (commit:32e54c7b3b62f1ceb5658f9cef46b7a7c3d11d23, #2898)
   * Fix: Returned and redesigned classic models for wheeled propulsion, light and medium half-tracks (commit:0737083a93f4657c3c103725d175e676a06b9b39, #2910)
   * Fix: Update VTOL rearming pad model (commit:c8318809e291868a0fab0df03d3ad1622e2f098a, #2912)
   * Fix: Tank factory model fixes (commit:6de3063bb19e8852a3b744995393f91b0136010c, #2911)
   * Fix: Combine propulsion models (commit:b45bf836f8af7d73351c38f0cba041ff30861879, #2918)
   * Fix: Add warning for outdated propulsion models in stats files (commit:82f202e39cf7569a08a094ec40da6fe50f8bb594, #2918)
 * Other:
   * Fix: Always update the base.wz and mp.wz when building (commit:19e926077ebab5e485fea4182b2d5d28a82162e0, #2901)
   * Fix: NSIS installer: Add warning when running ARM64 installer on x86/x64 (commit:e8db52a82c9668f7a69b9ee3f5be360455ed6b7b, #2903)

2022-10-14: Version 4.3.0-beta2:
 * Other:
   * Fix: Release automation issues
   * (See 4.3.0-beta1 for everything else)

2022-10-13: Version 4.3.0-beta1:
 * General:
   * Add: Add console message when limits change (commit:33087b712596d913a6265b204a982f0b7999ac88, #2600)
   * Add: Convert language selector to dropdown with flags (too many commits, #2079)
   * Add: OPUS format support, convert all music tracks to opus format. New "Aftermath" soundtrack added. (too many commits, #2680, #2723, #2728)
   * Add: Add support for bidirectional text using fribidi (too many commits, #2628, #2731)
   * Add: Basic per-script font support, add CJK font (too many commits, #2735)
   * Add: Show the rank a unit will have if it were produced next (commit:28dfe21e26a8f24f60235ca7fcd5d184d279b62b, #2727)
   * Add: Various refactoring / prep-work for future Emscripten builds (too many commits, #2792, #2815)
   * Add: Basic texture compression support (too many commits, #2807, #2815)
   * Add: Go Back functions better by backing out 1 in-game menu instead of going back to the initial ESC options menu (commit:14d3139d2b1bf5496908ae0115f950b09c98873b, #2834)
   * Change: Make save name suggestion easy to understand (commit:7e66a34746f3a2947d5de5b5e9f0897c6d7ac00c, commit:2e9d8447a968da7cb9562197cadde95720648ac8, commit:2c74538adf5949e409ea729c5829208bf6cdb1f8, commit:782b8b8989e476c6ec675b0a74ad41e942873889, #2761)
   * Change: Various Vulkan improvements (too many commits, #2824)
   * Fix: Various potential crashes (too many commits, #2424, #2665, #2842)
   * Fix: Disable the auto button in the replay load menus (commit:995ae684df3c1cc24870a27813ac4c4f3fa9da21, #2772)
   * Fix: Fix longstanding save related research state issue where incomplete research topics could disappear (commit:61d937123b0b2375c7a38ccc136a77e082a7d2ea, #2782)
   * Fix: Speed up headless replay loading (commit:4fb265ae26a884d907a73ba87481e4c0105a26f2, #2816)
   * Fix: Make artillery fire over walls (commit:46446c9736ff2c97b9c47d0feb0656a841c43ed2, #2819)
   * Fix: Direct weapon: Don't fire when blocked by defense hardpoint (commit:c44de5fc0f1e97d6c4defd8a69aa40e3723c430e, #2822)
   * Fix: Simplify repairs logic, prevent "stuck" repair stations (commit:1c812bdb52fef29263a9f9f0b105617a5fd5d322, #2840)
 * Graphics:
   * Change: Make sliders a bit slim to look better (commit:05ae22acc976c2cb1438ecd5cd9868a75a51555c, #2748)
   * Change: Fix team chooser being off by 1 pixel, and merge factions into the color chooser (commit:21046e5e4c2e869a79663d9269bf0c9ee49742ca, #2747)
   * Fix: Fix vertex indexing on cyclone flak (commit:b6a44f65f9b4bc30992e5a7c4416277e72a7a0d8, #2649)
   * Fix: Fix OpenGL antialiasing only working at 2x (commit:8bb207d1fdb29c34906edb96d2efb146ec6709d3, #2662)
   * Fix: [Vulkan] Prefer integrated GPUs over CPU device types and ensure llvmpipe is selected last (commit:b9ae0b5dde3deb698fefbc60b14750f4d85ad350, commit:e9c6ad8aaf2e816d5c8b0e5f45ab76c45d096596, #2720)
   * Fix: Improve one of the scavenger cranes, fix model errors (commit:42e3a854304ba33b58bceb391258072f425d4eb0, #2800)
   * Fix: Make the wrecked tanker cast a shadow by correcting its type (commit:835a38c945121be3586675884858900f904a2754, #2802)
   * Fix: Fix some water pipe feature models (commit:461ed8e3c2ba440a8286354e663a59f361963dcf, #2806)
   * Fix: Prevent Howitzer/Mortar mount model causing glitchy rendering on the back of the tray (commit:5092bda811700078e7c58a78d05ec27b90628804, #2806)
   * Fix: Overhaul all mortar models. Fixes missing backside of Pepperpot, missing top section of EMP mortar, centered hole texture location, smaller mount model (commit:af9eebe058ae270a82e13d2c2cd13b987d2eb0e9, #2811)
   * Fix: Change Cyborg and Super Cyborg model to fix shadow issues (commit:180ab46a28b8d78d3d49f9bf3a4f97d698acf94e, commit:53c91ba9a7451ce23ff9d2572c16193c66eb097d, #2817)
   * Fix: Improve a bottleneck in shadow calculations (too many commits, #1633)
   * Fix: Rendering improvements for text and translucent effects (too many commits, #2860)
 * Campaign:
   * Add: New Super Easy difficulty for campaign (commit:31cf33ea85397a3c8665bf0f4639502c9638644a, #2776)
   * Change: Increase difficulty of later Beta missions (commit:0b6d08c6e037a8c41ba980099e5eb32635efe0ec, #2681)
   * Change: Improvements to campaign library script documentation (commit:601d74da4a1daeb043485c0884efb2771538442f, #2715)
   * Change: Make Beta-end even harder to survive in general by only choosing powerful VTOL weapons (commit:702bd6ac51b53836712451d1af29b636a92d80d9, #2773)
   * Change: Start the northern most scavenger factory upon triggering the 2nd LZ on Alpha 6, for this ever so elusive scavenger base (commit:6910b3bc8069f708561714defc9bf6a079f357eb, #2789)
   * Fix: Fix the balance of FastPlay since the merging of camBalance (commit:761dc4fa275487047e1ee148805c1390af598390, #2655)
   * Fix: Prevent building something on the future LZ of Gamma 9 on the couple missions prior (commit:71c7919ad0ca3e76c99d32cca5ef7acd6199f6cc, #2683)
   * Fix: Transporters when starting Beta/Gamma from the main menu no longer block structures an extra tile more than they should at the LZ for the player (commit:d50cbfac5f2f07ab509f1e560a20ab53fd8ffd40, #2716)
   * Fix: Prevent warning about removing timers related to enemy trucks before they exist(commit:28c8b9a2775d9c9f74e3a626ca9ed1c0c970f377, #2722)
   * Fix: Make the western scavenger factory in Alpha 2 use a patrol order to prevent amassing units in one spot (commit:84e7f8743ef0ba4f9544f77489e3b61390d233c8, #2757)
   * Fix: Make Gamma 2 factory use patrol behavior to prevent tanks clogging up the base (commit:08142542b107b21cc448b5aa8808b2316745629c, #2773)
 * Multiplayer:
   * Change: Push back Ultimate Scavengers Helicopter appearance times (commit:90e684c5911d2637a28346a71222bb8ca888f475, #2736)
   * Fix: Fix names sometimes being set to "Commander" in multiplayer (commit:9632000bedf9e8ce720bc80a8828d9c518c51fea, commit:dc63f22abae21204a5c50271d4da7f568fa3f7f8, #1983, #2772)
   * Fix: Do not form alliances with scavengers when starting games (commit:b1171458c1b134a31004e349c713c2d8bd259d0a, #2693)
   * Fix: Add a research message for Stormbringer, fix auto-cannon cyborg research message (commit:0d77bd7cc0e4ad9d99cdcbad02ac9d2d45902e96, #2712)
   * Fix: Merge skirmish/multiplayer score/kill structure; Save/load recent score/kills for skirmish saves, and prevent this skirmish data showing for players in multiplayer too (commit:c23d0437e2baceabec3af4cd45b73e2eb08470bb, commit:56f41e5ec64fc51febd42e8e00cff91f034fa3b9, #2769)
   * Fix: Prevent 32-bit builds from appearing to freeze if a really long chat message is entered (commit:ebb8363ae979b8c28583344e8f385c88a982585a, #2791)
   * Fix: Check human player designs to be legal during MP and desync the modded client player if they try to circumvent this check further (commit:1f9ba68d9d600d4009928a0e8429e765c259f680, #2788)
   * Fix: Chat message is sent upon clicking anywhere outside of chat widget (commit:6283f6a1bbda5e179ecf63ac24454e1902c52ae5, commit:004444abd4d47c073c3f414eca36dc96849de61e, #2855)
 * AI:
   * Change: Improve Cobra AI yet again, balances against defensive/system research when 1v1 on high oil maps (commit:01e03323a449db3d7eee92380500a05ad77c1fda, #2801)
 * Scripting:
   * Fix: Use unit propulsion for pickStructureLocation() (commit:69597eb4cf1b6f241fed3ea5102233a180fd2c01, #2603)
   * Fix: Make derrick positions unique (too many commits, #2618)
 * Balance MP:
   * Change: Revamp machinegun AA weapons to use machinegun research requirements instead of cannons (commit:19787dca8ee5b6051dde1f57b1e71781e5eba142, #2654)
   * Change: HVC ROF Rollback for tank and cyborg (commit:76d6fdb1666352a50022e09d7688753e70915f74, commit:6417812ca6f1bf4454cdbfe66ba709987fc7780d, #2763, #2820)
   * Change: Boost flamers: add 1 tile of range to Inferno, 0.5 tiles of range to Thermite cyborg, and reduce Plasmite Flamer weight 5000->1000 and give it a small increase to HP from 75->100 (commit:87febfe32004f180abc6f009b4a761f6dd9c500e, #2714)
   * Change: Make Needle require two cannon accuracy upgrades since Scourge Missile requires two rocket accuracy upgrades (commit:0e402df6869898dd78d804579f178a10ae613482, #2784)
   * Change: Make ~T2 MG damage upgrades take less time to research to help keep MGs relevant before Flashlight (commit:e8053e07cd66b774d31272a3a0a3f5c0b60091e8, #2784)
   * Change: Increase Heavy Cannon long range by 0.5 tiles making it reach 9 tiles (commit:6417812ca6f1bf4454cdbfe66ba709987fc7780d, #2820)
   * Change: Condense Reinforced Base Structure Materials upgrades into 3 upgrades (commit:5f615440fd67debaf40c4c77aa6fc21da4442e85, #2835)
 * Other:
   * Add: Flatpak builds (too many commits, #2839)
   * Add: Add difficulty selector to debug menu AI attach option (commit:c1cb494d171add05d98feab5df664092affac4c7, #2170)
   * Change: Chop off the ".gam" extension when showing saves in the console area (commit:b11da1ea2d4a607aa8cb1834aa89bc7e4966f001, #2738)
   * Change: Allow game speed modifier of 2x outside of debug mode (commit:b9351222991628f099327e4f710e1cbecdcecbb7, #2767)
   * Change: Make use of sequence factory.ogg in the tutorial when a Viper Machinegun Wheels is first manufactured (commit:9584ad4bf442bde738b700c8d9bb44bce7a9cf9d, #2795)
   * Change: Improve metainfo / appstream data (too many commits, #2836, #2839)
   * Fix: Fixed hotkey doesn't count selected units correctly (commit:1b0e4654a04d292acb5466005a9713df35cc9b7d, #2670)
   * Fix: Disable ground retexture after destroying skyscrapers on non-Urban maps (commit:3d50d518c87ec4a4c23c6d424b946df085cbab12, #2692)
   * Fix: Tweak autorating level field behaviour to show a correct image (commit:00152b0e2699b59feaa4554b7b986446c6cbdd34, commit:7cb2cf95d836a55527ac6950e6faa667e449ddcb, #2703, #2711)
   * Fix: Major enhancements and fixes to wzmaplib and the maptools CLI tool, new "flat" map archive format added (too many commits, #2705, #2706, #2707, #2708, #2709, #2710, #2724, #2741, #2743, #2749, #2751, #2796)
   * Fix: Work around Flame issue where ScrollMin* > ScrollMax* (commit:119e89d0d07487807dbd6b17a336dd7b16d8d81a, commit:fb4212f93fde09d9fecdd17647f8a2f95cd8c35a, #2742)
   * Fix: Make the Command Relay intel message accurate yet again (commit:d7591ded017c58f132870d0b5b13566323a9d234, #2770)
   * Fix: Do not ever skip loading droid save data (if it ever did at all) (commit:a9783accd80d5a2220b3ed3060f200c1d252d898, #2779)
   * Fix: Improve autorating requesting and attempt to put data into tooltip (commit:3cc487708c6eb41e3729bccd355ba22accd197a1, #2750)
   * Fix: Make Blender PIE plugin work on Blender 3.2 (commit:2fd0140f2a9d4da22c115fae59a7f60b56cf80e8, #2781)
   * Fix: Prevent (potentially endless) "over-shooting" in ValueTracker on low-perf system affecting blueprints, rotation of camera, etc. (commit:e418aa6040adffd049921fcb7d423990443b2d2d, #2821)
   * Fix: Improve autorating request policy (too many commits, #2838)

2022-03-07: Version 4.2.7:
 * General:
   * Fix: VTOLs occasionally land to attack (commit:579eb5ce08eba4274fbb68620f49e310fc83f8bc, #2616)
   * Fix: VTOLs may attempt to "attack" when empty (commit:4a10d3ee09f798cca2e2a203af8264d72dd7cc6b, #2616)
   * Fix: Optimum range not moving past long range when clicking a target (commit:7e5079670ac4605d51c01a6e3d51983be54902d8, #2623)

2022-03-01: Version 4.2.6:
 * General:
   * Fix: Potential crash due to reinitializing default fog color (commit:1a3835ebd2558901d239f9f1353418297ae54dc9, commit:9310e24f3bf7f2c0816792c3aa04b28b6abcf808, #2612)

2022-02-28: Version 4.2.5:
 * General:
   * Fix: Do not make units move unnecessarily when attached to commanders and ordering an attack (commit:41f7e8adba087177fc05aa154eebb98e6e53dd40, commit:157491c232f36714051033d4acbde114b993f8b1, #2518, #2533)
   * Fix: Fix Autorepair not working on units waiting to be built inside a factory when the research is completed (commit:7d5ea8f5e71571aa906e26ef1780ffa7ced2dd12, #2529)
   * Fix: Headless spectator performance improvements (commit:83a82a4bf573e9208dfc9eb99b97a709880cb367, #2524)
   * Fix: Prevent the drawing of the Command Turret from crashing some systems using flatpak versions (commit:acc46736452cf10cbb94b414818d1669c1d5fea6, #2542)
   * Fix: Various potential crashes (too many commits, #2578, #2579, #2589, #2590, #2591)
 * Graphics:
   * Add: Allow modding fog color via the palette file and move the fog start/end distance to the config file (too many commits, #2548)
 * Campaign:
   * Add: Restore a new early finish feature on Beta-end like in old versions for Easy/Normal difficulty (commit:d96c6bfabe28e07e1bd87ca35b68cb6c20bb87a4, #2536)
   * Change: Bump Easy modifier to 1.5 for numeric values and Hard to 0.85 from 0.80 (commit:00a88cd9426952be9735d514b56ffffc2a1b6fd8, #2523)
   * Change: Decrease the base cleanup area on Alpha 12 to remove a lone bunker in the very NorthWest part of the middle base (commit:3783ba59347ea27a2bb40808351a5128da49c106, #2525)
   * Change: Give generous experience to all transporter unit loads on Beta/Gamma when starting from the main menu (commit:f4d081db414620cbe982efcc03bd7e024c156049, #2536)
   * Change: Make the southern scavenger base on Alpha 5 also trigger the transporter reinforcements for the player (commit:fcf9c5ccd00deda1b04c71d7a0df75daf4917f89, #2536)
   * Change: Upgrade a few campaign maps with better defenses for camBalance, add missing modules on some buildings, and add oil drums to many Beta maps (commit:856feca473f3bc725c523663cb2eac6156795303, #2532)
   * Change: Move Whirlwind research later into Beta campaign so Cyclone gets used for a bit longer (commit:3d64d9443a859f2d256c99fc9da3f2188f797b8b, #2532)
   * Change: The Collective uses Whirlwind tanks like in previous versions again (commit:3d64d9443a859f2d256c99fc9da3f2188f797b8b, #2532)
   * Change: Clear console when displaying automatic victory reminders (commit:07d2e3702bb83f9c98c922643d629dc107b5b108, #2592)
   * Change: Allow campaign library to handle multiple VTOL spawn systems. Fix array out-of-bounds access for the "alternate" VTOL templates option (commit:81b40b61f96016fde12757c33070ae16895c4916, #2593)
   * Fix: Fix campaign HMG tower structure for Flame map editor and on a few Alpha maps (commit:92e3273fb688be915b4a9fa9b5f9da55d7cecd37, #2519)
   * Fix: Make Beta-end fail if the player finds themselves with no units, factories, and just a empty transporter (commit:4359220d50762ab63aed36214a8e70a907749b9e, #2536)
 * Multiplayer:
   * Add: Add in-game "Mute Player" functionality via right-clicks on chat messages in lobby, and a button in the Intelligence menu in-game (too many commits, #2601)
   * Change: Spectators: Make F9 work and clicking on droids/structures for information purposes.
   * Fix: Fix the Ultimate Scavenger weapon "Scavenger Mounted MG" not having a short range (commit:b0889915c3d51608239b881ab9a954f17205082b, #2555)
   * Fix: Ultimate Scavengers not building a few vehicles due to components not unlocked for them (commit:a510b42bbe9d66c3c2fc92ae9f6bd22d1e5cbbc5, #2570)
   * Fix: Remove extra propulsion models on scavenger helicopters (commit:3560692fbe4ad54bc5f7e3f54d91bf637641d96e, #2586)
   * Fix: Format the netplay log file better (commit:54e1ff90d20570f55755e153842f5f4ee1f491c8, #2574)
 * Modding:
   * Fix: Modding gamedesc.lev no longer causes a crash anymore (commit:e20ab7b7d92dde4d5ed828ee3f20e6e223d56176, #2541)
 * AI:
   * Change: Small improvements to Cobra AI and allow it to play cyborg only games (commit:757a5399fb1ce1db30f9eb3c36a3ba4e9a0e81bf, #2539)
 * MP-Balance:
   * Change: Balance Mini-Rocket Pod against Light Cannon better by reducing Mini-Rocket Pod cost from 75 to 70 (commit:2f06bec04a9e5b2a2efd07df71fef0783a08d785, #2531)
   * Change: Increase cost of Cannon Fortress to 1000 from 900 as it was incredibly cheap compared to other fortresses (commit:7963c4319ad0bc69dcc4afd0df2567bf4816974a, #2535)
   * Change: Make Bombard unlock Ground Shaker instead of the Howitzer, Remove Ground Shaker requirement for HEAP Howitzer Shells, and make Howitzer Autoloader depend on HE Howitzer Shells Mk3 (commit:b5acaba550959116dfbb4da000845339863dd766, commit:fb1c07f5db37457b0c0634b1497e6c636be092eb, #2534)
 * Other:
   * Add: New maxReplaySaved and oldLogsLimit config options (commit:d0eedf739c9948db12a9460af32084a7abefd441, commit:a18639d6643ecb2b62fb5706f580a0ab1b6645ce, #2580)
   * Fix: Prevent truncating time in the Intelligence menu in skirmish/multiplayer (commit:39f0b9bc7366f524adb33ca56104cb88d0ebc7e, #2527)
   * Fix: Discord Rich Presence displaying the wrong host when host is a spectator/autohost (commit:10128b2402980c45536a64554bf84b80fbaac134, #2543)
   * Fix: Fix macOS-specific search path priority (commit:12185fa159b82c5d60ffaf3d184b664eba1d737c, #2541)
   * Fix: Add Arabic to the list of available languages (commit:65bf0f28aa1203f1b5e261d4028cecb9cc726331, #2584)
   * Fix: Check for electronic research rewards already researched (commit:7c887108aaea2814d291d941fb640fa7e10b7427, #2604)

2021-12-20: Version 4.2.4:
 * General:
   * Fix: Prebuilt ally gates not being passable (commit:428d0b70ff9af2a58a27bcfdade12ffe7fc062b4, #2484)
   * Fix: Cleanup old log files (commit:d5ed1a5164b50fadba5f0ef5bcf03c619aa2b62f, #2501)
   * Fix: Various crashes and resource leaks (too many commits, #2480, #2493, #2494, #2499, #2504, #2512)
 * Campaign:
   * Change: Ignore VTOLs when a campaign enemy group unit can't hit them (commit:d1fd63899890de6f9b43b4080581378acf631a89, #2475)
   * Change: Better target selections by sorting targets relative to group average coordinate (commit:b538fb562f55ffd3abd92eea1774ac0cfe98cc4f, #2475)
   * Change: Add a time range to cam3-1 launch / detonate sounds (commit:c64ca3afdc989a885d12b530647bbd308221c037, #2476)
   * Change: Make the winning requirements for Beta-end more clear (commit:d89391d05026d8e940bca5ccd507517349965153, #2491)
   * Change: Make Gamma 5 a little more hectic on Hard / Insane difficulty (commit:f467e476951b89dab56404e68913662734ba54e2, #2502)
 * Multiplayer:
   * Add: Additional lobby chat slash commands, cmdinterface event output (too many commits, #2500)
   * Change: Set default AI back to Nexus (commit:a4f7b6b6d678a25ef76d738779eed00bf8526d69, #2487)
   * Change: Make some AIs easier when using Easy difficulty (too many commits, #2486)
   * Change: Remove old Cobra Hard / Insane weapon perks (commit:9c245da200648745d17bee0dc3f200872b7d7b94, #2489)
   * Fix: Repeated game over message (commit:3e4a146bc6f8d52bddb98634aafc48e1be20b049, #2485)
   * Fix: Add campaign Collective and Nexus structures back into mp stats file, fixing old maps (commit:3c60e5f9428136de5f494ce5857d9be6008b7701, #2506)
 * Challenges:
   * Fix: Specify specific AIs for "Back to Basics" and "Hide Behind Me" (commit:f2e6edabb1fad7193c611800180145faedc60611, #2487)

2021-11-28: Version 4.2.3:
 * General:
   * Fix: Unable to demolish structures at full health (commit:baab23227e5deab3579e313f50f5a7238286a8dd, #2430)
   * Fix: Properly remove old QuickSave data when quick-saving (commit:c0e4bcfbf9809eca8ac33210a019a194851f9c61, #2442)
   * Fix: Drop pending structures on first click (commit:ccdff9e9bf241d3d0f53cd675c40c0de86f02d88, #2452)
   * Fix: Play buzz sound once per interval (commit:69a9de00c819dc9ef0b94946d3cdbdc02f527a16, #2456)
   * Fix: Ultimate Scavengers freeze on certain maps (commit:e56a5cfb27fa739dd528a8786ba7e6e892b973e6, #2458)
   * Fix: Improve OpenGL context cleanup on init failure (commit:eda3996d2efdd80d6e848fdabbc1b2ceb7a4161a, #2462)
   * Fix: Various crashes (too many commits, #2433, #2434, #2453)
 * Multiplayer:
   * Fix: Game doesn't end when autohosting if all players leave simultaneously (commit:0dc476077676e4642c3ebd0fe572b0989d805203, #2455)

2021-11-22: Version 4.2.2:
 * General:
   * Add: Multiplay Options menu (too many commits, #2415)
   * Add: Hotkey to "Select all land combat units, with health >50%, not assigned to any group" (commit:b7ff3b346e1b9c07c257f8084b6b3d9a99995485, #2329)
   * Fix: Reject certain crashy OpenGL drivers, and fallback to other backends (commit:c71c0c9aae85dec46f94124a2a11e941e2699dbc, commit:720ccab774c8df4e8581f3ccca27f721460544da, #2400, #2427)
   * Fix: Handle exceptions creating Vulkan device (commit:1091109a0ae3a59ba864c8864188183d7b34f75c, #2421)
   * Fix: Repairs & Builders: Don't move needlessly (commit:df8997b5f08afa26cc69b93ab8279db04e643e3d, #2391)
   * Fix: Re-ordering construction units to build something shouldn't cancel it (commit:5a106269f68d9d1c708114853d0da20cf442843c, #2395)
   * Fix: Don't reset attack range under commander (commit:7ac86b51bc9ff96d1881544799d620d267e45de0, #2394)
   * Fix: Ignore rearm order when already rearming (commit:e9fef35ea95c95df6e78df8e95a2b378b4ccb5b3, #2399)
   * Fix: Don't show green overlay when impossible to build next module (commit:24b570d887275d685ee944570d05f07bb3339dd9, #2398)
   * Fix: Don't show modules in build list when unable to build more buildings of that type (commit:af3f237f0f64ac3da11dd0a83a46a89e41d0afbf, #2396)
   * Fix: Don't retreat repair turrets (RT) to other RT (commit:d4cf74d30ff79fad6d0c4c5cffe3129b7310b959, #2389)
   * Fix: Improve resource cleanup on shutdown (too many commits, #2405, #2423)
   * Fix: Prevent DIVIDE_BY_ZERO in displayBigSlider (commit:0979c692f941689505e35c782040fe80f1f29d86, #2408)
   * Fix: Various savegame / autosave issues (too many commits, #2409, #2419)
   * Fix: Remove Command Relay structure requirement for Command Turret research (commit:0248233152c341fcd36a6f14c94c4a2bb57aa5e1, #2414)
   * Fix: Partial UI soft-lock with certain in-game menus (commit:b429ffe3d146baf04b8e55b279ef5a3b6543f4f2, #2418)
   * Fix: Preserve ordering of sync msgs in MP; fixes Factory set Hold Position bug (commit:cda0183a1abf868103e67649aedb73768e7ba521, #2397)
   * Fix: Toggling debug mode in skirmish as spectator (commit:ca936ba49bd3473472ffb095614de4f0cab88dac, #2420)
   * Fix: Ultimate Scavengers building an absurd amount of factories (commit:f0fce501741a7c2075452abb8b77c8fa66e10b19, #2417)
 * Graphics:
   * Fix: Missing parts on the Nexus Link turret (commit:06a8600dfde844bff1bc3c70a08c32a1d574e07b, #2392)
 * AI:
   * Fix: Rip out mobile repair tactics from Cobra AI (commit:3fc79370c16b597009040e06fc5439ec030168de, #2387)
 * Scripting:
   * Fix: Use constants instead of plain numbers (commit:70e03ad9790be91d009f9e73d11aa1492868a37e, commit:dd815aeae262f3d955b8828073e64c407d8fa774, #2406)
 * Multiplayer:
   * Add: Add 7-player map "Thales" (commit:a927e712eb5fecfa7bda7d946291e8a1c7375ba8, #2404)
 * MP-Balance:
   * Change: Adjust Heavy Plasma Launcher: Reduce damage 250 -> 225, increase firePause 300 -> 350, reduce periodical Damage Radius 128 -> 64 (commit:b8685b5df12091ace6f5590e80984eecbcbe2fa0, #2386)
   * Change: Adjust Incendiary Mortar: "researchPoints": 3600 -> 4800, "researchPower": 112 -> 150 (commit:1d2976ed52d4365e0ae8b4aae31d23333247dea6, #2407)
 * Other:
   * Fix: pie_import to handle filepaths properly in Blender 2.9x .PIE plugin (commit:97427c87d4ceeaea436c1dd52418f3db60579b96, #2412)

2021-11-08: Version 4.2.1:
 * General:
   * Add: Replay v2 format: Embed downloaded maps, store "end of game" info block (too many commits, #2347)
   * Fix: Improve replay saving performance / behavior (commit:e4e604aa55f229ce1f9ac582388a4c3b20f9409b, #2345)
   * Fix: Handle frontend.img / intfac.img load failure explicitly (commit:5ea99dd6ebe1bfd9e8efd94ac25fa841d3600913, commit:406956ad1f197925f20b8e638e49432554af0c6f, #2355)
   * Fix: updateChallenge() crash (commit:2f912f7bf6588752ce95cc010df916b30c85ec9f, #2348)
   * Fix: loadGame() crash if map load failed (commit:45fbedd4b67de805246d0a95d2ea9f75b8766a31, #2352)
   * Fix: Various additional bounds checks & error logging (too many commits, #2359, #2373, #2374, #2377)
   * Fix: cursors_sdl: Null checks, cleanup order fixes (commit:bf0b642306c34f0a73806715eb2e11e30ccaa4f4, commit:8bfc6ae13b03b1beb99ce4421d62dde5a31d641d, #2360)
   * Fix: showUNITCOUNT should only apply to player slots (commit:340d5ec8fd9a9c87ced84953a33493ad0bda2955, #2366)
 * Graphics:
   * Fix: Further OpenGL init tweaks (too many commits, #2350)
 * Campaign:
   * Change: Alpha 09 tweaks (commit:120cb3ddf03ddf31c0de67706cf0073ddeb33df5, #2356)
   * Change: Alpha 06 NP reinforcement tweak (commit:5485ebe25147f8f4d1e8a95afd6502de5d4cd249, #2357)
   * Change: Update a Nexus Resistance Circuit research item name (commit:04d1692b7ba96cb6dc03c1636fc548c9f135c9b5, #2369)
   * Fix: Account for the transporter in campaign unit limit (commit:dbf34209c3c8b8b8a14e286c4265223a2e80b47b, #2369)
 * Scripting:
   * Add: Provide a native fractal value noise generator for use in map scripts (commit:469df2d69f137183aef3e2413fa285db3e83908a, #2341)
 * Multiplayer:
   * Add: Add specstats button (commit:12fffa2c845b2a3c48262a23078fac9a30ce7238, #2370)
   * Change: Host: Remember number of spectator slots in MP games (commit:33b9c498f333952e849dbb3619d667b5fad7daa2, #2372)
   * Fix: Improve spectator lag / fast-forward behavior (too many commits, #2338)
   * Fix: Do not reset ready status of players on spectator leave (commit:30cf5a2003e86eb8fe7b22fa97bda04907dcbb45, #2353)
   * Fix: NetworkTextMessage::receive() crash (commit:a63e016f2faa562292437591e7e958caea1d9440, #2354)
   * Fix: ActivityManager: updateMultiplayGameData on MP replay load (commit:4c36ed5934077962370316b3e057e5242bbaca53, #2375)
   * Fix: Revamp WZFiles cleanup (commit:13849b065378d830f55771e35878670f38a544b2, #2376)
 * MP-Balance:
   * Change: Rollback "ALL ROUNDER" damage value against "Legged", Increase the accuracy at long range of all MGs from 50 to 55 (commit:e00eff60500ec59ef25c6ac90aa1397fe366f819, #2361)
   * Change: Increase the weight of HVC, add 0.5 tiles range to HVC cyborg, and reduce ROF of these weapons (commit:6e4d2561de3f5e6f6f90adae04a96fbb8591c26a, #2363)
   * Change: Increase the research time "High Temperature Flamer Gel Mk3" so it is no longer included in "Advanced Base" (commit:2745499133bd237924df03e1e416ca1f6f2ab2ca, #2364)
   * Change: Faster Bombard and Pepperpot production, weaken Incendiary Mortar burn radius and damage, and earlier access to mortar accuracy research (commit:27bce204cd198f4bec1d23a48ea31a5345792f08, #2367)
   * Change: Required research for Howitzer: APFSDS Cannon Rounds Mk2 -> Heavy Mortar - Bombard (commit:06e5b5ca3b0d4ac2267314d8aff0932582a55bad, #2368)

2021-10-26: Version 4.2.0:
 * General:
   * Fix: Handle repair point choice better so it doesn't pick less than ideal ones (commit:4a3d528b6c70fd5763ad1ebabf181e2e6fc7f321, #2313)
   * Add: --loadreplay command line option (commit:19c59750c55d74b15f65ee3551ebd08b5777f32e, #2323)
 * Graphics:
   * Add: Update Ultimate Scavengers button image (commit:51c535432c1777e4a002e5d41f9865928734dd17, #2305)
 * Campaign:
   * Add: Increase oil drum power in Beta (150) and Gamma (200) (commit:211e0a72a0e886e79651e776384f7fe64c5c2a28, #2310)
   * Fix: Fix fastplay video not working since 4.2.0-beta2 (commit:55b656f1a9c660a5a521a35f2e5de28b41e85824, #2311)
   * Fix: Prevent old transporter issue on Beta-end where it can come back and fail the player due to little time left to send it away again (commit:2dab78359b0ca05157c73b52d13aa160108c8ce3, #2317)
 * Scripting:
   * Change: Update JS documents (commit:1b50d7040c70e4b5c4bab6a1e21f27c58dd4d1f6, #2290)
 * Multiplayer:
   * Change: Display team chooser column at all times (commit:8a6b20424d55e5acac0271ef56d82a7cc157c25f, #2302)
   * Change: Make inactivityMinutes / idleTime configurable (too many commits, #2307)
   * Fix: Fix a desync in replays due to structure limits not being the same in the replay (commit:79f1580e36b96584616a94d680b7eb09325d9e94, commit:d8f3f8cdcf1550e9680658fc3ff070e640c66b08 commit:c317fc92036952e3bffa90cc7819ce8b1be7e99c, #2288)
   * Fix: Fix a crash/assert when players were transitioned to spectators (commit:0720478249555a965a1c117d9148816aa6ce4ccf, commit:844afd747987c525c5bfc7e12ad5fd394f426c00, #2293)
   * Fix: Fix order of players in specstats window (commit:d7ce7f65234011c17f791cad03bca2681d7c5136, #2299)
   * Fix: Crash on autogame with spectator host (commit:eeb74a0c83be8de18f7645e4f7f5accb763a9a5b, commit:a1d025bd4b6d8cc846eb9f8cb908f97145405e9a, #2323)
   * Fix: Joining new game after quitting lobby with spectator host (commit:e5e5b3cea4252fd602e0877f251ca373eace39a0, #2323)
   * Fix: Client sends invalid command to host if autorating URL is enabled (commit:b42006c4295a70554d4c61e53e567a43721c754f, #2323)
   * Fix: Spectator host autorating URL requests for all clients (commit:9ad707ba27c39aea19e73957a36a9b4e89d5c6dd, #2323)
   * Fix: Unable to refresh lobby after being kicked (commit:d0b29ee4d0adbd923fb23eae5b4c535998c2f7d1, #2323)
   * Fix: Replay desync at start due to replay spectator (commit:41142f9dc15dbc139d1155335819c559e73a717d, #2323)
 * MP-Balance:
   * Change: Reduced effectiveness of all-rounder weapons against cyborgs to 60% from 65% and make HMG come earlier (commit:37fba9ff657d29ad9e044b447cd1c2063cbb0c35, #2306)
   * Change: Slightly increase Super Auto-Cannon Cyborgs damage (commit:c8664187f722e2af756a4da7670248c0c7caac68, #2324)
 * Other:
   * Fix: Mingw / Clang compile warning fixes (commit:4a4106d59d1ca54938fdc64fb24934b75e38fc86, commit:495ec740a314894aae325c69e9923a11c617edb3, #2291)
   * Fix: Fix a potential chat related crash (commit:86ea2a27214fb47cbb55fd40af07ec9dd388bf98, #2294)
   * Fix: Fix potential crash due to 0-sized decals VBO on maps without decals (commit:641b57f61eebb1b860e63eb382b96811ebb72ed2, #2303)
   * Fix: Crash if transporter is recycled (commit:33bf6b41dab41a583202588aa3aa45897eec5021, #2308)
   * Fix: Suppress and log wzDisplayDialog in headless mode (commit:aa91f8ef280c52b01a90ccf0149a5f014f544a52, #2323)
   * Fix: wzapi::gameOverMessage: Trigger a graceful shutdown in autogame / headless mode (commit:3891ec232e85537b71164c8bf838b1f92ba0a84a, #2323)

2021-10-16: Version 4.2.0-beta2:
 * General:
   * Add: Make selected structures and units blink on radar (too many commits, #2260)
   * Add: Power per second to power bar tooltip (commit:dbaf846580c5300ad994eeb2b913bb6699b72d39, #2283)
   * Fix: Command interface fixes, documentation added (too many commits, #2255, #2266)
   * Fix: Crash caused by crash-handling provider (commit:9eba84b42b2d9b5491a641cb42ccb81ef8387a13, #2257)
   * Fix: Always release sequence resources at shutdown (commit:c8db2e117f9116e2b5412edc42281a0cd7f37db7, #2258)
   * Fix: Additional null checks (commit:c9822b47c630b71d4e8308b2f4c5365985f296c8, commit:5c84be3edf87fdd4daa37b8e2cdb3e8338a9e1cd, #2259, #2280)
   * Fix: Repair: Return to HQ as fallback (commit:c2c8a1b455c931eef8a892d71136b4022d407ef1, #2261)
   * Fix: Improve replay warning / error messages (too many commits, #2263)
   * Fix: NETSendNPlayerInfoTo: Only assert when multiplay game in lobby (commit:a554be6214cf75b0c958a96ea7bd6de4f730b5fd, #2274)
   * Fix: Struct stats lookup maps tweaks / refactoring (commit:259a0af9cebe5d3260fd3d965e147724c99fecbe, commit:b1947b59d491623588f1e28e3250f2037fe32fd3, #2275)
   * Fix: Add a missing break for attack orders (commit:899e32a7aaaa2b11d07bc58ceb843098543e315e, #2277)
 * Campaign:
   * Change: Decrease the player return LZ in Beta 08 (commit:aca3f4590f08753e81edec46995c4dd1f9f43af5, #2271)
   * Change: Add additional research messages for Nexus Resistance Circuits (commit:4f62603de92be6e9857de86ed73961db8f21da93, #2276)
 * Multiplayer:
   * Change: Ignore allies' attack to determine activity (commit:145c7667baa776cbfbb0764db6f177fe3b7151b7, #2262)
   * Change: Limit Ultimate Scavengers' Helicopter usage times on T1 technology (commit:ae2031af9e109d71fe3326c7c60f76c43a100af1, #2268)
   * Fix: Desync when moving to repair (commit:49f3a398d6746fa66d377cd218e4511572b5f06e, #2267)
   * Fix: Don't load map preview twice for the host (commit:20f2ac22f03f779e2c183067377a1c973657c4b9, #2282)
 * Other:
   * Change: Add video install information for Ubuntu in README (commit:980a222986fd6876891051b2d51fb68a4815503c, #2279)

2021-10-09: Version 4.2.0-beta1:
 * General:
   * Add: Add Ultimate Scavengers to the game (commit:21f7935791a9816815dc69c95bebe91b6daf3328, commit:9c7fc3569d11fbdb1e840f3b4901a6863090aaad, commit:71f1b17794ca5559eefbbc172539eecbb728da97, #2211, #2131, #1995)
   * Add: Implement remove from group shortcut (commit:c12d3798a173bd5eb942a6905ea20935ebc24dee, #2197)
   * Add: Use a stable config directory for release builds (commit:d3b10cd790aea97335149ac352c129c21ec1058b, commit:47d27df891caad7f0f21051eb4065a8cd53b2aaa, #2248)
   * Change: First steps at moving savegame format totally to JSON--now converted the .gam file (too many commits, #2191)
   * Change: Return units to mobiles turrets & randomize repair points (commit:5910fc43e3381ec4e06ce51dad0e4e72dd6d47f2, #1829)
   * Fix: Fix orders from Commanders after loading saves (commit:2b04681dd54e65d10ff8d80d94bcbdfb6dd16d31, #2113)
   * Fix: Don't reveal artillery unless the CB tower is completely built (commit:960adb4e6fd78735f337b7a7ae66636aebc47ce7, #2139)
   * Fix: Fix sensors logic under commander so attaching them isn't useless (commit:13f0587dd56600097d1180511fb1d8d7844a7437, #2146)
   * Fix: Prevent lobby refresh and filter buttons from disappearing unless invalid data gets sent somehow (commit:2ae01399210fcf59931fb2060db7240561fa53c5, #2151)
   * Fix: Only play "assigned to commander" sound if group is not full (commit:b2d5d011d3f40dbd806987298b52ecaf4e4b4390, #2156)
   * Fix: Don't block ready status button when player clicks ready too fast (commit:6125af3677ef918c03b5c1d7cd1ebf9be54892ef, #2152)
   * Fix: Primary AA turret units not attacking things if the Secondary could, among other fixes (commit:85145678baff20e9a9b111be195f2aa19346950b, #2172)
   * Fix: Improve ManufactureOptions/StatsButton clickability (commit:c21187897b41a1213c8911c2b460c2fe79d130d8, #2166)
 * Graphics:
   * Change: Major revision to the Blender 2.9x pie addon (commit:344b5d327455b96a949ee6a71a8ae5c338a55056, #2180)
   * Fix: OpenGL init resiliency (too many commits, #2121)
 * Campaign:
   * Change: Update Beta 11 mission objectives in the Intel menu (commit:cff3b7808c2082667467afb706466a21ac02bd21, #2181)
   * Change: Increase default message duration times for campaigns (commit:d7a2c7a7bb876846b8cc9bf8064fa6ee141d3370, #2200)
   * Change: Improve the Alpha 7 Intel objective text (commit:49a643ca287f2da5dfae8a2811581ca77b2ff55f, #2200)
   * Change: Update camBalance for Gamma. Campaign rebalance is basically complete (commit:db7ed93ccd2ce2186b48c7e5dbaf9136ccc33b15, #2231)
   * Fix: Allow mission objectives to persist into offworld missions (commit:bf4407e2ec8e33a8712f8264931908fa8327a98d, #2185)
 * Multiplayer:
   * Add: Spectator slots for multiplayer games + replay functionality for skirmish/multiplayer (too many commits, #2143, #2243, #2247)
   * Add: Support non-0-index hostPlayer, configuring "spectatorHost" from autohost json (too many commits, #2212)
   * Add: Headless / autohost enhancements, spectator stats, lobby chat slash commands, netplay bug fixes (too many commits, #2223)
   * Add: Add new random maps "DustyMaze": one 2-player and two 4-player maps (too many commits, #2237)
   * Change: Make lobby games scrollable (too many commits, #2155)
   * Fix: Fix double host exit screen (commit:003d69fd8f665c8baeac1363bf6c3035294484f6, #2122)
   * Fix: Properly load ttypes.ttp for script maps so water is shown and more (commit:33c0ec4d8f9863b765505b100cf54b3ef935e8c7, #2199)
 * Scripting:
   * Add: Add a way for scripts to determine if games are a challenge (commit:dae3c3fd9dfaf39301859cde8a2cff4aeca665f7, #2137)
   * Change: Cleanup and improve JS API documentation (too many commits, #1872)
 * Balance:
   * Change: Make Machineguns less powerful short-term but not as to weaken them long-term (commit:1b0d9889dc0cb8d4cc7dcd27abd4066412145685, #2136)
   * Change: Make phosphorus and thermite bombs less strong with only 2 bombs and a flamer modifier instead of artillery round (commit:072569f92526b34050a8de493e80e9f97de75f2b, #2147)
   * Change: Tweak timeline and research cost of Bombard, Pepperpot, and Incendiary Mortar (commit:ca750cae70e865a320118311f89b793a8944be79, #2153)
   * Change: Tweaks to Anti-Air research costs and timeline (commit:d096c058a0dbd51d7dccd13b32d4effb82367fc7, #2162)
   * Change: Change the required research for the Nexus Link Turret and Nexus Resistance Circuits. Balancing weapon parameters (commit:ed2de106d2ab6935bdcdc6ac6720ba728023bb83, #2168)
   * Change: Heavy Laser weight reduction from 20,000 to 5,000. Restoring the playability of this turret (commit:76ba3222ede7798a2d37c7a1d649c8cf51478a7c, #2171)
   * Change: Additional reduction in the cost of Tank Killer and Super Tank Killer Cyborg research (commit:f406e7ad25ecbddf9d748a0a665056329df0048e, #2184)
   * Change: Reducing the cost and time of producing black and red bodies to increase the relevance of their use (commit:643d39073e5b9562eb490ca499f000854b6ad170, #2194)
   * Change: Increase Super Rail Cyborg range and reduce damage to maintain relevance (commit:0393afd4e8f3961fd129eb6788c6bc0f34472899, #2198)
   * Change: Make the VTOL MG parameters more balanced by reducing damage (commit:2fc3c33e0e7ae1d87bdf0c00ff38b87c9c07d35a, #2201)
   * Change: Change Howitzer research to not depend on Cannon Laser Designator, Bind Hellstorm Emplacement to Howitzer Emplacement, Increase Ground Shaker production time, reduce periodical damage on Incendiary Howitzer (commit:1720a7ec7000a0167f5b6848198a6063b3ee133f, #2202)
   * Change: Improve accuracy of VTOL HMG (commit:2d21b6407e6a382bd8a61d36ccf72153c177f6de, #2204)
   * Change: Swap precedence of VTOL Factory, VTOL Propulsion, and VTOL Rearming Pad (commit:726b2b9f83d292980c82a24819a7a32321e1fe25, #2213)
   * Change: Nerf VTOL Heavy Laser range and damage, VTOL Pulse Laser damage, and VTOL Scourge Missile splash radius (commit:368d33e94c8bb1f37e965bb47a46564229d9a075, #2216)
   * Change: Reduce costs of Anti-Air structures, Increase Stormbringer range, reduce weights of Tornado, Vindicator, Stormbringer, and Whirlwind, reduce build time for Whirlwind, and reduce total held rockets in Sunburst AA before a rearm (commit:9ea437be616ad1f9eef47f19208f66cdd8d78117, #2215)
   * Change: start time Base 4.5 -> 3, AdvancedBase 7.9 -> 6.4 (commit:82c55fb6572874e10b17ca923af5507696e7e7e2, commit:d72f367913da71f948fd6f0d83665154405567dc, #2218, #2229)
   * Change: Nerf Super Auto-Cannon Cyborg damage, improved ROF of HVC Cyborg, improved ROF of Super Tank-Killer Cyborg and Tank Killer Rocket (commit:8513682c3efa8f318d61475f28de048dc94634ee, #2220)
   * Change: Increasing HVC turret range from 9 to 9.5 and decreasing weight from 4000 to 2500 to make HVC playable on light bodies, Slightly improved ROF for Super HVC Cyborg (commit:f6226b76ec0ab5d3887003a4400da307560876a7, #2221)
   * Change: Balancing and rolling back to version 3.4.1 of some VTOL weapons damages and accuracy (commit:b2daf54b0ff3a378e45b694ae7255b18a90fcb4e, #2222)
   * Change: Move Tank-Killer so it comes a littler earlier and only depend on the fifth rocket damage upgrade (commit:9dbecb0f75fc7628f12b5dc54cec7db09ba83cee, #2226)
   * Change: Slight Incendiary Mortar research cost and timeline reduction (commit:e923492c8bbf2b55c072db1b34458b102bff1f51, #2230)
 * Other:
   * Add: Add autorating url in config (commit:242f322bce687cfa84c8ffbe6a25dbebb006e1fe, #2165)
   * Change: Don't show enemy building being repaired (commit:fe1bfba7a6f9865b5378b3fa9c2705928afda954, #2141)
   * Fix: Don't crash with JumpToResourceExtractor keybind after level reload (commit:0b8e502586507b74c45bbbc194501065a624e2dc, #2178)
   * Fix: Don't double load a random backdrop on a connection cancel (commit:7e47d9779a3ed376ea569d4926725d25a0f6d9dd, #2239)

2021-08-09: Version 4.1.3:
 * General:
   * Fix: clearLoadedMods(): Clear mod_hash_list (commit:dbd3921a02df1f45579c77b22706b0ffdc7b93bc, #2096)
 * Graphics:
   * Fix: setBarGraphValue() divide-by-zero (commit:8b99babe058824b21ac9efc8a345147c154dc819, #2089)
   * Fix: WIDGET::detach(): Check iterator before erasing (commit:2e5436dfedb8aa4d68c77680e9c7ba335b4d663f, #2101)
   * Fix: IntMessageButton::getTip(): Add null-checks (commit:e1a51965749a9330f8ac370de9fc80959525e263, #2102)
 * Campaign:
   * Fix: Crash caused by saveMissionData() (commit:0cd0bc53cae655e79f3a5e3c6a4892c16617dd52, #2088)
 * Multiplayer:
   * Fix: Fix order of players in alliances screen (commit:dba9b4d252609047185a0449a88ac76189f7473c, #2105)
 * Balance:
   * Change: (Multiplayer) Reconstruct Howitzer branch and adjust artillery parameters (commit:2c6c4c9fbfae1d92dad194018f84ba73d896217a, #2070)
   * Change: (Multiplayer) Make Mantis more accessible (commit:311838ff1e35057ecbc0fbd84aaefb8f8e74f5be, #2095)
   * Change: (Multiplayer) Earlier access to Assault Gun, improve MG (commit:169f4637ead8885caacb22cd098543ba60af9268, #2094)

2021-08-02: Version 4.1.2:
 * General:
   * Fix: Various crash / cleanup fixes (too many commits, #2037, #2039, #2041, #2045, #2058, #2059, #2073, #2074)
   * Fix: Reduce log-spam (commit:d92641fe8a207ed05b2b196c13cb6d709a68f447, commit:ac98d677f5f1c7db7650df850437ffcab0a48fa2, #2048, #2076)
   * Fix: Wrong names for HVC (commit:35f68f6a9d3dc29f829939dad34ef90a4fad919e, #2054)
   * Fix: Don't deselect droids when pressing RMB over something (commit:4bb8151efdeb1f7534fbb128d767f22a7ccb33d3, #2052)
   * Fix: Various memory leaks (commit:a08b23f040b1d84398c40168c33f3eac008c458f, #2019)
   * Fix: Do not play audio from assignments to commanders from other players (commit:ad91ba5193d5679ff370697b158dd35a1bcfdb05, #2063)
   * Fix: When editing keymappings, ESC should unhighlight the selection (commit:afb112901ce8b205bf38c2033ed2b4916f1e4052, #2072)
   * Fix: Correct minimum OpenGL version check (commit:d974dcc14cd2256e1698c57d10be89a0415d9182, #2082)
 * Graphics:
   * Fix: Vulkan: Crash due to late release of graphics resources (commit:3accfde52c96d48e804417e2f29d07666603e8f9, #2038)
   * Fix: Statistics table overflow (commit:3ff4440bc45da4d2ce24c0ccea7b397b08e6ae97, #2029)
   * Fix: Various widget improvements (too many commits, #2071, #2080)
 * Campaign:
   * Fix: Add new Twin MG Tower to transitionTech.js, move the second Cannon damage upgrade back to Alpha 04 (commit:d945b9371a9affb80264a6d08056955c3dcb2896, #2044)
 * Multiplayer:
   * Fix: Map request logic improvements (commit:843dc47dccd5c2a91eb6869c8bb33aa80087325c, #2043)
 * Balance:
   * Change: Additional editing of VTOL Rockets and Plasmite Bomb parameters (commit:f10e1582813fe1a067accd9418a656446705e2e3, #2065)

2021-07-25: Version 4.1.1:
 * General:
   * Fix: Fix chat cursor position (commit:10f32bc6fc8e22e1046bb5f37ed5e5fda72189d7, commit:042e4c2276aa4569bf1687c00bd72d2834f02bc5, #1979)
   * Fix: Respect Hold & Fire at will better (commit:8de662f45b6b0f88ab03f852e8cb089bdd0f41ca, commit:05f5f1c71c7fcd0d79d5a448432e0e4c2d9fb90e, #1987)
   * Fix: Refresh order buttons on hotkey press (commit:ddf25c084007b2ead4beee698f62dece6f1df447, #2010)
   * Fix: Make other hotkeys override debug hotkeys by default (too many commits, #1931)
 * Graphics:
   * Fix: Fix structure limits screen lighting and hardcode sun position and lighting for 3D buttons (commit:d2dbcac2e29e2128ba9660ea0e3b77f466a6b448, commit:e198438b00a51fe49fa09fbcf532cae6334c1dcb, #2001)
   * Change: Use faction models for UI buttons (commit:f477d76a5a6ad633c4926241304632e6447740b3, #2015)
 * Campaign:
   * Add: Add a small delay for allowing video skipping (commit:37828b78f46f1c292bb1b55e88358c31fd54fd18, #2011)
   * Change: Merge updates from camBalance to encompass mostly Beta campaign tweaks (commit:4268f4426e62226092c1cbc58e254a42ecc9aa21, #2027)
   * Fix: Do not show transport button in objective achieved screen (commit:6f0e7f0beaa436edbfe71d9e97a040c1c674ef68, #2014)
 * Multiplayer:
   * Fix: Fixed obsolescence of machine guns Technology (commit:26918596ad2670d49178ffea121b36ed9f20b759, #1989)
 * Balance:
   * Change: Make Heavy Plasma Launcher more useful with an "all rounder" role and reduce price of Plasma Cannon significantly (commit:0b4f37365ed551efc14fc70b4e9b58a8a3043f0d, #2009)
   * Change: Tweak mortar research paths to decouple Bombard/Pepperpot from damage/ROF upgrades and Incendiary Mortar and reduce Pepperpot weight (commit:e0c17f814747dade806ab64e533feecd9ddf1a67, #2021)
   * Change: Rebalance HVC and HVC Cyborg to have more ROF and 1 tile less range (commit:2edbb1b34a51eab38427ead1f4be21374febf9d3, #2022)
   * Change: Tweak accuracy and splash values on Sunburst and Cyclone anti-air weapons (commit:0ce8587c47e9c2dc0643a47eb1d04974d5b63819, #2032)
 * Other:
   * Add: Add weapon info into debug window (commit:0a626c31e7dc82f9095e22ee0484111188e3c94c, #1998)
   * Change: Replacing the abbreviation HPV for the Hyper Velocity Cannon with HVC (commit:d9794c0e23f342ec707f5c3bd2b31353569eca4a, #2005)

2021-07-04: Version 4.1.0:
 * General:
   * Change: Move research upgrade code to C++ away from Javascript. May fix a late-game desync (commit:7b4e1d110ec9427ea070ea3395db252ef8547127, commit:3ddc0356b0de20ccee34727dec4f96677e02eb1c, commit:b2da3338db951361a20969e2a55542e310d299c9, #1925)
   * Fix: Prevent crash when resuming game from the Music Manager (commit:757db8dc266eeddbe1a47f36d0610d93070ae5df, #1913)
   * Fix: Fix vtol collision with ground units (commit:614a62f9eb5df8eec6a32a214559b37885a45626, #1917)
   * Fix: Fix updating certain key mappings making the keys unusable (commit:f493fa8fe521a37c81623edbe565ef3f6b07b654, commit:0859366c77e19b4f0944987b04706cce772c75ed, commit:7355f730e3cf986217e1f409669a6aca47a09dbf, #1922)
   * Fix: Update unit speed when researching engine upgrades and when reloading saves (commit:4db7674c093acde144cad384edaca9633d243868, #1953)
   * Fix: Stop heavy CPU usage on the Intelligence map (too many commits, #1958, #1962)
 * Graphics:
   * Fix: Fix floating turrets on Heavy Plasma Launcher and Tornado Flak (commit:c02c5e198cd74ea153ed769c9085e5a92a9236ca, #1932)
   * Fix: Fix and show various muzzle flash effects for Gauss, laser, and all kinds of weapons (commit:c99cadf51a280e565979ad8dc3f74ad92e20a915, commit:453d69d3b805a833ae56bde33aef20cec73a3128, commit:0d4b8b5e04b5a27ae87358b7c63b6707722c518c, #1935)
   * Fix: Normalmapping of 3D models in menus / buttons (commit:32fb024c9d261fc35a1018a893bba78704a648d4, commit:e536d1f639f3fd8b9e63042b33def23c2d5ab09a, #1930)
 * Campaign:
   * Add: Add warning when selecting Insane campaign difficulty (commit:4ac34dbbfa89d1954859686c290bbb94cfd0d6c8, commit:37402723cef4da511d46644f9fd02a91f4787933, #1938)
 * Multiplayer:
   * Fix: Don't incorporate ally losses into enemy kill count (commit:5b5114083ed232ff6b0d36e61988b9d3b5a32e9c, #1916)
   * Fix: Improve handling of corrupt map archives / delete partially downloaded map files (commit:bc18010d044c9ac211c5d364c72578575ab4d257, commit:7850af11528b0e94ababf5c4065d3b7e0e05a683, #1919)
   * Fix: Implement editbox placeholder for password box and can set password by clicking icon (commit:eca46698c0acb9b0d69bddcc24c0c90c18f48695, commit:1c1fc3a7b5609f069b7fec037bd81e822b83fcb7, #1950)
 * Scripting:
   * Fix: Prevent a crash if passing in no turrets to a few API functions (commit:ad082fb475f465de53286755dee892971998ac09, #1929)
 * AI:
   * Fix: General improvements to Cobra AI / accounts for new balance changes (commit:1c2b422c88f28d78bc85e6ff951e06724cb4488e, #1954)
 * Balance:
   * Change: Make the Heavy Repair Turret come earlier (commit:7465e1b97da4a3c2ffbf4b6968f882898268efa4, #1927)
   * Change: Weaken the VTOL rail weapons so they aren't overpowered (commit:ba6cc666178fe28cb0832dbf880a9054a6d05ebc, #1928)
   * Change: Balance and move EMP weapons to come earlier (commit:405c4ba6eb13e860919925db1671c7704c465195, #1939)
   * Change: Increase cost/buildtime of Howitzers and Archangel Missiles (commit:9b26877e1aa73129e23f0cdd2fe0a03a074b0371, commit:dd4360fa2b0e36a550451ee1daa77ef92ad284cb, #1952)
   * Change: Balance VTOL Lancer-line to be less overpowered and remove splash damage from Hyper Velocity Cannons (commit:8a423d54c53465f3701314ef14876da416ac4a3a, #1915)
   * Change: Make Leopard and Panther have higher engine power output thus move faster with more weapons (commit:8786263d96ad0168969e10029e19e596e9d790af, #1955)
 * Other:
   * Fix: Make "help us translate" message translatable (commit:cf697c6896d56d6e761621d8e14830d6e6ab2fb6, #1961)


2021-06-18: Version 4.1.0-beta1:
 * General:
   * Add: New design menu stats delta system (too many commits, #1781, #1790)
   * Add: Add a single player quit confirmation screen (commit:bc46a4287b0d6047ceb4ba5a40819421cb55205b, #1792)
   * Add: Allow building modules/derricks in a row (with drag & build) (commit:931fad8bd5cb5730a6e0c4883c4fa45e9fa0b737, #1797)
   * Add: Provide a self-contained map loading library that can be used by outside tools (too many commits, #1807)
   * Add: Allow scrollable menu options (too many commits, #1823, #1851)
   * Add: Add support for binding same keys to multiple actions in non-conflicting contexts (too many commits, #1508, #1852)
   * Add: Add selection without group hotkeys (commit:afe1da9f777d2da726a4eba391bb3b35470735b9, #1893)
   * Change: Allow assigning key bindings to mouse keys / huge keymapping refactor (too many commits, #1745)
   * Change: Move the whole group to the target location, not only the command droid (commit:2f964fc01e6e168ef1063c0eac00e9081a5514be, #1831)
   * Fix: Refresh tooltips every 500 milliseconds (commit:de53db956aea1bdcf1b509a4db4a8b9ea486c45e, commit:6675a64216e7dcfc57bc3be7108fe43604a0e3b5, #1735)
   * Fix: Fix crash if dead object is in a widget menu (commit:4be967fe914b18a07932eac592998942311a9f55, commit:18b04b8501a6d8f1ddff8997f0f5065a8cb129e3, #1819)
   * Fix: Fix droid health values sometimes restored to maximum after loading saves (commit:a2ee458b3fa08993ed614608a297d156ff72d9ec, #1816)
   * Fix: Do not handle RMB click while panning the camera (commit:da4321625e83b2a78c676807a98c3d1666895357, #1822)
   * Fix: Fix unclosable panels and flicker when using the Intelligence map and Design menus (too many commits, #1763, #1892)
   * Fix: Clean up option menus that are open when a host quits to prevent softlocks (commit:628bcf2149d26fe1630fa247b54a265d03b3c53d, #1879)
 * Graphics:
   * Change: Use a single-component texture for the tcmask (commit:df2dffffed30ede55b71c4b64c2876b2994fceed, #1854)
   * Change: [OpenGL] Provide GL_R8 fallback for OpenGL < 3.0 and OpenGL ES 2.0 (commit:9f88111e845c8ed584634d66971099d12a56101a, commit:79637a5bdc67cbadae6b10001d81004d40afa016, #1864)
   * Change: Use a single-component texture for specular maps (commit:023229ba3d49aa146ddd1b7735ee828a2d367f98, #1865)
   * Fix: Fix fog and add menu option to toggle it (too many commits, #1275, #1851, #1870)
 * Campaign:
   * Fix: Set transporter speed to zero when moving to away mission maps to prevent flying backwards (commit:71d884c9d3c546041e4d0e667f635160e1bb6681, #1881)
 * Multiplayer:
   * Change: Revision of some visual effects to distinguish kinetic and thermal weapons better (commit:b71b1ab2c509a0488aeb9f3b7dc98275cde665f2, #1874)
   * Add: Chat messages when players vote (commit:8866b0f651b8bb1f0f6ce5c84568137167ee41b4, commit:a9686c74ea8ee08ef592ba5d3ddd651ce696f79e, #1572)
 * Scripting:
   * Fix: Fixes for uninitialized values in labels (commit:870043f8b6f63e32bacdb3d3caeca1d4792ff8b1, #1821)
 * Balance:
   * Add: Balance and add Heavy Plasma Launcher to multiplayer (commit:3426158b3e454786baac86cb036fef2441d83a60, #1871)
   * Change: Revamp multiplayer anti-aircraft weapons and add Tornado Flak cannon (commit:fc6104a28d3a9bbd8017ef5ce8549de878e22b22, #1804, #1842)
   * Change: Campaign rebalance aka "camBalance" merged (commit:ecd1a1612e73883b0d43169c169a027849c2ac1b, #1857, #1882)
   * Change: Make howitzers less overpowered / rework mortar and howitzer tech tree (commit:eeee16c751c2c5e33a4981cca7511842d7d2e023, #1842)
   * Change: Fix Wide Spectrum Sensor production and cost (commit:85963f5d9c68ef512a6f4782910d1a754892ee0f, #1842)
   * Change: Improved combat parameters of weak VTOL weapons and removed obsolete (commit:97f70c2f0d77f702b13887c35dbbceafc58192fd, #1868)
   * Change: Improving the parameters of the obsolete Super Auto-Cannon Cyborg (commit:0ad20ab65fc85f32699fc040b71e41651f5c7ce3, #1875)
   * Change: Moving the obsolete Twin Assault Gun to come earlier (commit:a11a1010c7d1336be6c303eb5deba87a9afad404, #1877)
   * Change: Raising the potential of Tank Killer Rocket and Super Tank Killer Cyborg (commit:712fa7b710bc7ad61f5f01b5dd8b25ff6d56c382, #1884)
 * Other:
   * Add: New cheat "makemehero" makes selected units hero rank (commit:e49a9f950eaa0bc3e6235013365f1d46d0a312d9, #1820)
   * Add: Initial MINGW/Clang build for Windows x64 (too many commits, #1891)
   * Change: [CMake] Ensure WZ-specific internal libs are built statically (commit:edb455fb8ccf6ee6848a7601e2af2bbd62fa0d88, #1805)
   * Change: Fix various compilation warnings (too many commits, #1818)
   * Change: Performance improvement when saving (commit:73937e2905a6e3c0c49ee27dea5bb30c623dd254, commit:05359b406f216e7a3eb09e05ef012691fe299b26, commit:3371524dcbd018fe03ee2b85d2f33a4574beb5a6, commit:2b47e9a55d21d7fb630ec395c77d059df8ed8b37, #1726)
   * Fix: QuickJS Patch: Fix NetBSD compilation (commit:65d9993304b496478701fb6048167f7fe0227e91, #1827)
   * Fix: Fix deactivation of research/manufacture buttons / GUI warning (commit:53efc73af592b13e2a81b7e81c70e43ef08167db, #1848)
   * Fix: Many Mingw-w64/Clang compatibility fixes (too many commits, #1846)
   * Fix: CMake packaging improvements for Windows (too many commits, #1888)
   * Fix: Fix odd name placement with empty elo autorating string (commit:2b4830ef5af8c37a1e7fc3c8c4bf531fc8377555, #1900)
   * Fix: Format json indentation (commit:40be939910ca7e44a5ec3cb6de769f95173d1303, #1901)
   * Fix: Store more required save data into the main.json file (commit:6ad788d2c4de402e0b9ea962b33380a2f7d85272, #1902)

2021-04-18: Version 4.0.1
 * General:
   * Fix: Fix broken map zoom cycle and repair bad config settings for some numerical cycle options (commit:825a07d3f237befc194e62e2de29ef0eab3defbb, commit:6037803287f1c9d3cd26820cc863d47ec16d5852, #1707)
   * Fix: Improve water performance (commit:154ff47cb7a470879f716a9e9e149e6345742b40, commit:efee2d8c4a8f78aac944f7c5770909fd26e90b17, #1724)
   * Fix: Prevent crash related to flag/rally point positions already existing (commit:db2b23da5c49cdf95140160b31ad8cb922f8fbbe, #1752)
 * Graphics:
   * Add: Additional Collective faction textures (commit:734bfe4336abf4489420397ca28f15a977fa16fa, #1768)
 * Multiplayer:
   * Change: Change multiplayer super transporter research icon to show a tank in the corner rather than a cyborg (commit:8b9d3954880eac94ac14ebe8439196d2405e7036, #1721)
   * Change: Some improvements to 6c-Entropy for easier modding (too many commits, #1756)
   * Fix: Reset ready status in lobby when a player leaves (commit:d7f125d51c89614f4705aa17ff94f8bbe589a6c4, #1744)
   * Fix: Fixed incorrect player positioning in procedurally generated maps (commit:d9fd9a7888d05696641c28e54f8b9c0bec0a3796, #1755)
   * Fix: Fix skirmish power modifier after saveload (commit:847496e22df5fa6283fa90a9ab0cd9b81014fd71, #1764)
 * AI:
   * Fix: AI messages wrongly targeting players (commit:5aca61614f66a8c9554b6ba482a730ae880e0f10, #1770)
 * Balance:
   * Change: Start splash damage at the center of intended droid targets and increase splash radii of such weapons (commit:cb34127ba35bf0fa9d85398e6c4ddf1103ff8c4b, commit:3b833e1a52cb3ebd4ef8a6e436c931708f6a266b, #1474)
 * Other:
   * Add: Add config option to toggle autosave feature (commit:c8008672f926fc9143eb5477865dd7b64f8f2abe, #1727)
   * Fix: macOS ARM64 / Apple Silicon builds (SDL2 cross-compiling issue) (commit:f0934ee4e84418b583e204c595383581c12270cc, #1720)
   * Fix: Don't crash when closing the game if the music manager is open in the main menu (commit:93094e8a3e3334ac9109b8be27a83dff695de641, #1761)

2021-04-04: Version 4.0.0
 * See: Version 4.0.0 beta1, beta2, beta3 for the full list of improvements since the last stable release
 * Changes since Version 4.0.0 beta3:
 * General:
   * Fix: General improvements to address UI crashes and issues (commit:d7288f4c2f0c130889db4d7ea4e8229d920dc3f7, commit:5639a187f069677476ce2eb2af532d70368faf58, commit:484ebc432fdfb91f1ab0619ba46be2170f7a6e9c, commit:fe0ed076f92c6eb44aa483849eaf8046b22240cd, #1679, #1686, #1689, #1695)
   * Fix: Fix animation system not letting scavengers out of the firing animation (commit:319ef65c7acd01111ce9d83d6b394b10343be09a, #1690)
   * Fix: Shooting through gates after they lower (commit:aedce4ceb6059926d9bfa19fd29c522e3c81b16b, #1692)
   * Fix: Lock UI and do not accept option changes over the network when everybody is ready (too many commits, #1701)
 * Scripting:
   * Change: Update QuickJS (too many commits, #1682)
 * AI:
   * Change: Update Cobra AI (commit:a216a60a03ef8f76817dd31f287a86801e71203f, commit:c6a22faa9253758ca489f68cbc0233b3e8e30d90, #1697, #1699)
 * Translations:
   * Change: Numerous translation updates (commit:f04c085d018b074d8268ea57d7eb04485c34d4dc, #1705)

2021-03-27: Version 4.0.0 beta3
 * General:
   * Fix: General improvements to address UI crashes and issues (commit:7534e6c1f6df8778e337e51d460de6aeb8f2309f, commit:046b98065e5ec8add67c31e62384c75739d07103, #1653, #1664)
   * Fix: Fix crash when using Alt + Tab (commit:82847e3dab405d1ffef7954c7df25be747dabff5, #1661)
   * Fix: Mouse not responding as expected after multiplayer games (commit:f4672c5e24f9dfe3cf469d1cab0c4ad01c8cd998, commit:67f7bfafb7620dcf745e74a6286a3ce3882c7d37, #1666)
   * Fix: Fix crash when backing out of save/load menus repeatedly (commit:fb27eb4e0bb0285e399dd5739e065f72f4cf96ee, #1670)
   * Fix: Fix incorrect display of production cycles (commit:43b9b4d220da607c5c11558a63908edb1c5dc130, #1671)
   * Fix: Fix UI crash when a factory gets destroyed (commit:17c3fb5627c175bf34b7afa0da99979b1c5b3039, #1673)
   * Fix: Fix commander overview not showing factory modules (commit:af9612abac8959a1ee34fb9859046a6efbc28452, #1675)
 * Graphics:
   * Add: Add new optional .PIE sections: SHADOWPOINTS, SHADOWPOLYGONS (commit:cbdf25c8f48f45a2284ff8976b3634f6ffd9d57f, #1630)
   * Fix: Various bug fixes for Blender 2.9x ".pie" addon (commit:ef06b7c6ce0ba449beee918a9379665dfb83fbca, #1651)
 * Multiplayer:
   * Fix: Fix player slot issues when switching to maps with less players in a skirmish after hosting (commit:07eb7f5a700561c1b855001aaabf2b965954f8d, #1674)
 * Scripting:
   * Fix: Unboxing issue could cause buildDroid() to only utilize the first turret parameter (commit:32f61a8c5cbd07bd1c4996f5bbf1b6d42f1e5828, #1676)

2021-03-20: Version 4.0.0 beta2
 * General:
   * Change: Return previous camera rotation behavior as the default. Improve the locking version and set it behind config option "lockCameraScrollWhileRotating" (commit:5b893cfc6a725a78d5b86699aad75b7b2d59ba79, commit:f2d68e5fb40dbd3f8f6f172d9f92f3de32d77799, #1640)
   * Fix: Fix medal display which caused a crash (commit:9aa49ea227c0dda727f992737dc5d2b01d681b7d, #1584)
   * Fix: Fix profile selection list causing new profiles to not display (commit:9ebf1ce5bcfa5223168a17156f395f801e73291f, #1585)
   * Fix: Fix UI crashes and issues (too many commits, #1583, #1590, #1608, #1637)
   * Fix: Close options menu, when other menu is opened. Disable reticule menus when options are open in multiplayer (commit:a6da62e419bd822f889d79cb5b117a8c153bf3f9, commit:37cffc421280f36bfb534944ec25ea03f2373aa5, #1589)
   * Fix: Disable quicksave and quickload while option menus are open (commit:de516624eb7e8f94a6247e8e1b333d87711f7951, #1632)
   * Fix: Unload level data before loading any save data (commit:12b64bc0e790bea88dc8d1878a82d4c1329e0bb6, #1639)
 * Graphics:
   * Add: Introduce the ability to specify if a model wants to interpolate frames (commit:ba731f3e43a67686485f8fcd5c3de1a8eb19a8ec, #1593)
   * Add: New Blender 2.9x ".pie" Import-Export add-on (commit:73602cf27b1c46508b18469ab08a0928c311c1b0, #1601)
   * Change: Minor shadow-related refactoring, imdload sanity checks (too many commits, #1623)
   * Change: Optimized light calculations. Cleaned up shaders to save a few fps (commit:a63f76eeb215aaab672d5cf500bb7ae276db4dde, commit: cd6c32a3f30c88e487e490725e39c69d2981507a, #1628, #1629)
   * Fix: Improve flushing in headless mode + don't initialize video subsystem (commit:cd9df7e0485c23c8eb03ab1a313eafa561be18fe, commit:5dfaf18901d4907a58ff3f2bb0b03ab1d496e877, commit:2b00ed61bf8f737b95c07e990c62af2e6e221995, #1618, #1622)
 * Campaign:
   * Change: Widen a sub1-d base entrance and replace MG bunkers with Assault Gun bunkers in sub3-1 map (commit:8b9a32690d7a0e1e44f0d0de9709b2d6101f6bd9, #1643)
   * Fix: Guard against compromised timer bringing up the reinforcement button (commit:d059fdb44cd7a524bcded199fedf6e2f06a5322f, #1613)
 * Multiplayer:
   * Change: Improve lobby performance by not loading map addons as much (commit:bcc790b37255cda79d4007d444916899efc88b09, commit:3cea0447f5e0d7b0e7c235eb1e0839d9eedf33f8, commit:a6011af7318795f222e1b4db9ef156178d7c5ab8, #1588)
   * Change: Improve obsolete weapon redaction (commit:edd7d1185cb01209e24bca70fab78f717c9a4894, #1634)
 * Scripting:
   * Fix: Prevent a potential double free with QuickJS backend (commit:19157334b5ae645017d33f0e4df7268034508b4c, #1642)
 * AI:
   * Fix: Add more weapon data into the NullBot standards to prevent ruleset warnings about undefined weapon info (commit:013d3a0eaf500aa5c100adfffa24c7a902f99885, #1602)
 * Other:
   * Change: Lock key inputs when the in-game music manager is open (commit:2a1cb3c520449b91a89692e286929129316ca87a, #1631)
   * Change: Changed "High-Velocity" to "Hyper-Velocity" in HVAPFSDS to fit in better (commit:c6305216d09a458b373df676e6df362c543e73bb, #1636)
   * Fix: Fix -Wnull-dereference warning in structure.cpp (commit:4b4cfe36b2f3038e895e026a21ad933fd1d5b2de, #1567)

2021-02-28: Version 4.0.0 beta1
 * General:
   * Add: Tweak build and line build to allow diagonal building and more (commit:4b99c8f20f0c202b5b2bc797580f2a8b32361db4, commit:337103224cdb69262938b5614c0e972de87b4baa, commit:95cf4a8fe90752df809f19d5fc3537d4cec520a2, commit:b72b642757117cd11fb91b06fa39fbb3a774a51d, #996)
   * Add: Add "Add to group #" keyboard shortcuts (commit:d0e9cffa1235277cdb89abc75267cc54ebcbfc70, #1102)
   * Add: Add hardban list (commit:ecd5041efe3ffa19d8a48e39c0c84ef75bf53c6a, commit:68a4b0115527d31f6644327a919616bd114b2e3c, commit:dafed3a03f06c400737746ee98d08b8c0fdf5188, #1079)
   * Add: Add Hotkey to rotate building during placement (commit:c13c54d769a445d23b5a1594f8b94e43d92b56ec, #1215)
   * Add: Add indicator for unused derricks (commit:8fd7e3b9bb33eb29e553c8ea843f4ec670802824, commit:4f20b0cd2a21386e11155e870ab94c781b7b4123, #1216, #1230)
   * Add: Add configuration directory link to Options menu (commit:043167772d2780ed2983cb1fc28964545d1b1eb3, #1228)
   * Add: Add Music Manager menu / in-game options (too many commits, #1280, #1288)
   * Add: Add additional info to the pause screen to improve user experience (commit:fff00dac37d36c9aa79d69e7306b0f5cec1bc778, #1403)
   * Add: Improvements to multiplayer lobby widgets / screens (too many commits, #1425)
   * Add: Bring back screen shake option (commit:138d83c5ed03359aad83bbf65cf9c1c56f9a8d6c, #1434)
   * Add: Support "Desktop Fullscreen" window mode, better switching (commit:2605e343add09d6fff89a2c8a01c6884d7120d8d, commit:762928abc6351c9a93277d092aa356aac9708943, commit:79976323cfa7bfa84cd7fa2c81b1171c5bec6703, #1445)
   * Add: Savegames now have suggestions (commit:ec4dadcb5cb020473e989fb22842ccc3d9511a70, commit:796e1ab7d1a4c33bebbd9bd9d9bf4fda2529a41c #1468, #1515)
   * Add: Add "Go Back" to in-game pause menu and submenus (commit:d05ad5273c2e702f961bbd3f9a018b328b050365, #1477)
   * Add: Implement research cycle detection (commit:266d281a715f61ab65d34de055e7ab9e1f183309, #1535)
   * Change: Lower threshold for automatic firing against blocking walls to 33% damage minimum (commit:5c39fc0b1039ba55552170bd38b3151bfe2a6b23, #1060)
   * Change: Fix weird cyborg names (commit:ca808469bea7241c10bee5b07e1a7580769d01e0, #1056)
   * Change: Remove radar jump bounce / camera code cleanup (too many commits, #1177)
   * Change: Use buffered file writing for binary save game files to speed up save times (commit:5d7d9e779acb85c7618095c665b716211d78f3a9, commit:9f5d29e166503f2919618eb94bb9a6fe483d1cbb, commit:30baabfb18c73eb50fec54970a6d0b94346897a0, #1194)
   * Change: Load terrain textures earlier during game init for better load performance (commit:b975725b29f9d26ca293046953c16fe39a26754e, commit:f65c4b690aefe37ad94fad235f1dde2eb5da1b9b, #1206)
   * Change: Show research names instead of "research completed" in the console (commit:71be6a9cd0b40bc9d9de07847b35cba6df0baaca, #1374)
   * Change: Widget improvements, Replace Qt-based Script Debugger window (too many commits, #1452)
   * Fix: Remove hard-coded limit on number of tiles seen by objects (commit:a115e05813a613185deab8a55c640d3e7afa495c, #986)
   * Fix: Fix initial delivery point, droid orientation and puff effect for rotated factories (commit:b41c23b1d5b75f8d77f0bfa3baaca647ef1dbdb4, #1098)
   * Fix: Next building hotkeys improvements (commit:ef20ec2ded05e7e2e64a0020e721044f7669dfc9, #1164)
   * Fix: Fix droid stacking from factories if using hold orders, for example (commit:aa0f9d4f6fc651e4a35543cf2a05304662a6b4f2, #1172)
   * Fix: Fix crash when loading challenge saves from the in-game menu (commit:65f438def257f7d761d3d2c3580ecbd3238d6ede, #1186)
   * Fix: Improve droid transfer function (commit:cbf5d2bf2560d8cd3f95b283120ed668765c6098, commit:bf7ebb11a0d0a031370a3a10b46ab640c1574ef7, #1242, #1322)
   * Fix: Use voice volume setting for intel button sounds (commit:023156eca1b3ef77af6b0e18ab4b9197ef453895, #1356)
   * Fix: Fix Map Zoom config option cycle (commit:3d57d20fa240e20f66af84076fb6b185620100b9, #1364)
   * Fix: Fix Continue Last Save always doing campaign init (commit:84af4e19473e7b4adbb2e464c3f6023963aa61ef, #1370)
   * Fix: Save the file name of challenge files so the extra scripts can be loaded again (commit:2343e666c4464d2766f489da691ade8cd61824cb, #1373)
   * Fix: Add new key-value pair to structure stats to determine if walls combine to them (commit:9b82d3c9cbfb6f4f1b4de34649343aa4d9136787, #1388)
   * Fix: Fix reticule button init so F1-F6 always work when needed (commit:1764e27328b4b4625244ce2f5e0c7ed7feb80513, #1422)
   * Remove: Completely remove the last remnants of Qt (too many commits, #1465)
 * Graphics:
   * Add: gfx_api: Remaining wrapping, + Vulkan backend, + OpenGL ES 2.0 / 3.0 support (too many commits, #489)
   * Add: Supports optional vertex normals so that models can use tangent-space normal maps (commit:fb300475d15c29c6a6903ac89723781d895e2aac, #489)
   * Add: Use higher-res terrain textures, and upscaled HQ backdrop images (commit:75fcf1f7c84b4b5df39062e2a96abb62be286df6, #1188)
   * Add: Implement scrollable list widget (too many commits, #1224)
   * Add: Add position interpolation for blueprints (too many commits, #1260, #1294)
   * Add: High resolution reticule icons (too many commits, #1233)
   * Add: "Headless" mode (for --autogame, --autohost, --skirmish) (too many commits, #1395)
   * Add: add factions to multiplayer (too many commits, #868)
   * Change: Implement dropdown widget for resolution picker (commit:63b4ae9080a050d232f8bc7728b3bda9fdc35f78, commit:c2f008c22de006e0e1b193639fee7eab3d915ae1, commit:f56f0148370b7bebb25f2e3c88049e5c29e3715d, commit:132f69d47efc0cb8362327eba7b56aefb1b3fafe, #1441)
   * Fix: Fix skybox wind (commit:fb05d770929aa927c231ec9fbc2376c9948dd56e, #1285)
   * Fix: Fix in game buttons refresh (too many commits, #1488)
 * Campaign:
   * Add: Add improved victory condition output to campaign (commit:001c1f9610f12d2c494ebe4b3aa04f52b6c501cf, commit:ab7d93a2f58e9c763395e657458e9c0fb1102444, #1072)
   * Add: Unlock the Thermite Bomb in Beta 7 for the player; Collective uses Thermite bombs from Beta 7 onwards sometimes (commit:e73405992e8116997603ba2dc997ae08a7ea6026, #1170)
   * Add: Add Improved Bomb Warhead upgrade as an artifact in cam2-7 (commit:7d632fb3f455b7001f04836ab0aadd32438717d8, #1406)
   * Change: Prevent cyborg groups from over-protecting an area in Gamma 1 (commit:3df1fbdee6362e03a7ba0a75d7f7548a3e92f789, #1093)
   * Change: Prevent giving electronic rewards to players in the campaign and thus some Type II propulsions in Gamma 6 (commit:eec8462cce9bfd1f080dd17d7f4095234db31654, #1156)
   * Change: Allow destroying transporters in campaign (commit:d94464085f39d405352cef7ec68761d28c8f9a16, #1333)
   * Change: Remove useless cyborg/vtol production upgrades from campaign (commit:2ae61c183a65cdf9fe8d94269b16db4ce5d3ffe0, #1336)
   * Change: Use SUPERTRANSPORTER for campaign scripts (commit:1183132cb351ed824ea5e359e7c2abe91bb1eb24, #1346)
   * Change: Lower the console box on campaign games to not conflict with the timer/transporter buttons (commit:e196747a5ca8e267f39ad9d8ad8a63b728232940, #1366)
   * Change: Slow down cam3-4 truck build orders (commit:283c45d42a8678a319c2cb3f0695c57e9f594056, #1394)
   * Change: Change factory activation on cam3-4 mission to happen only by trigger or after 5 minutes (commit:777fb7eea4ff99a9865e066c714ef303330ebbb8, #1430)
   * Change: Hard and Insane use new damage modifiers (commit:cddcd9f191e7bccadaa1300d1547c2ce688fa2b8, #1547)
   * Fix: Drop artifact from gamma base factory in the cam3-b mission for cannon rapid loaders (commit:b9614e025f7fd43f74ad978e4534b53e32983ded, #1116)
   * Fix: Fix campaign research for the Alpha research upgrades being available for the first time now (commit:24f81743eb895b10c4e0efdeb6dc92a6d06f3243, #1130)
   * Fix: Make campaign Assault Cannon research also grant the VTOL version (commit:63102b1870fed0d62a3cca6d8e2cf171d6404533, #1135)
   * Fix: Fix appearance and strength of produced campaign Nexus cyborgs (commit:4f21fdf23aae83f2fd906f81ba4752d4fe53da47, #1147)
   * Fix: Use Collective structures for Beta AI when it builds defenses (commit:f5c55f0a7063bbc88c29f37e3cf22c5136a826f5, #1148)
   * Fix: Prevent a tick-perfect pause and save execution breaking campaign library/mission functions by using timers instead (commit:6ce06b14db11dfb5e4c7edfe18fa11dd82d9cbf5, commit:aaa9daf3f6486971462ea0537fd5f11cb51763e2, #1166, #1169)
   * Fix: Fail the player immediately at the end of Beta-end if they did not send a truck in any transporter rather than in Gamma 1 (commit:d3b68999a5eea527ff1b5aae99e4d697460e12ac, #1207)
   * Fix: Fix names of campaign Assault Gun towers (commit:26162d8f7629c861ce9463a889ccf8ce0cce3a80, #1362)
   * Fix: Assault Gun Bunker research fix (commit:5fc5dfb4dcc2a352f8a13f0458f00555866f7e93, #1402)
   * Fix: Reset libcampaign cheat mode var on loading saves (commit:1e3c6de3a41c0b8f12cf53d6f831c3d0eee9ebd9, #1404)
   * Fix: Show the Nexus base firing a missile video in the Gamma introduction again (commit:e1eaf8daaea7d6c22b1ced44888b1ded9aa2425f, #1499)
 * Multiplayer:
   * Add: Improve direct connect dialog to a specific port (commit:b657f8b14f70afd819dd4dc45a9785d6441f8ebe, #1120)
   * Add: Add port parsing for --join (commit:70682c7f5c772148351d9e7617b32348c3999dd9, commit:137cb43f4930d1a4a651dbec4b23b6a56c591503, #1289)
   * Add: Scrollable room chat (too many commits, #1269, #1297)
   * Add: Improve chat style (too many commits, #1326)
   * Add: Show kick reasons (commit:93226dcb2b9aa2592a5cbb164c96859c161f96fe, #1348)
   * Change: Share partial research progress in shared-research games (commit:93459b30a87adc1b9b7ece602f05d8e3a331623d, #987)
   * Change: Reduce explosion counts for most weapons except for twin-barrel weapons (commit:b7ed713d374a2d2e501706c312c38266a2aa02e6, #1171)
   * Change: Refactor medal display and allow more variety. Autorating support (commit:058bd02d510debf06fc695a5cc9a06e7aa9a5094, commit:94411e0745df505b9ce8eb0459fcac95adca194b, #1141)
   * Change: SQLite database for KnownPlayers, Replace micro-ECC (too many commits, #1390)
   * Change: Split up rules.js into many parts to improve mod support (too many commits, #1463)
   * Fix: Fix dropped artifacts in skirmish being unobtainable after loading a save (commit:86975daf1efb0351a1c39cbf7b32bd54e5e0c9b7, commit:8c4de95e55f1525a4b82976a3b0515a83390337f, #1107)
   * Fix: Fix map selection form alignment (commit:51bd1fb6c39598c92f7f0a8ec01b35ef24888ed5, #1328)
   * Fix: Prevent map selection button list from going off the form (commit:aea66eb1aa557c73d97b8019e5e66fccbb79f66e, #1347)
   * Fix: Fix odd EMP mortar pathway; Add EMP mortar to designable weapons (commit:bcf93b7fe640c09e8b1239fabfd901fde9760259, #1535)
 * Scripting:
   * Add: Can write a script to generate maps. 6p-Entropy and 10p-Waterloop maps created by Cyp (too many commits, #1019)
   * Add: Add MapTiles global for static map tile information. Expose TileIsBurning to script API (commit:d85030c7d9c22c28dcd1cd8956a7acca91a6953e, commit: d72212cf7e340a44f7222bc138f941c08cc5e94a, #1375)
   * Add: Various JS API enhancements / refactoring, `includeJSON` (too many commits, #1496)
   * Change: Initial wzapi refactor + quickJS support (too many commits, #1261, #1371, #1380, #1412, #1433, #1470, #1484)
   * Fix: Event eventPlayerLeft should only fire while in actual games (commit:27e2b565fcd279ded5feb2efa14417099f5b5b1b, #1090)
 * AI:
   * Add: Let Hard AIs get a power bonus (commit:3ab6a996f5e97bb5e564add171ef3710591a0563, #1149)
   * Change: Update Cobra AI (commit:d76c4b7f3962cd36ea191ceb5fc376ffbca62249, commit:ec0a24a331fd28f91e8c8cbc4a355b9603ce8075, commit:a591d706ebf738ad3c69212fe0098bfadb6684c9, #1117, #1231, #1555)
   * Change: BoneCrusher! v1.1 update (commit:2a3f6794cef49db1f81bb2f7ba55d9c868ee2599, commit:0e12640826bad5af11858b257e649aa104a859d2, commit:93306e214c6c5c9313495b4c35045e9e5bbfad6a, #1442, #1461, #1483)
   * Fix: Fix Nexus production being broken after saveload (commit:72639831c1d5a05e3feb885e2225976b7695a6d9, #1071)
   * Fix: Stop NullBot from attacking its derricks after winning games (commit:19931574d0f640cd7bc0bfddddbbf8c5623671c0, #1096)
   * Fix: Make NullBot AIs manufacture combat units if the enemy player has trucks if the required "target" structures are not built by the enemy (commit:07c358e64fda07766c599541aae3ff4e3276ca46, #1287)
 * Balance:
   * Change: Decrease multiplayer HQ sensor range 24->18 (commit:04053a4dd17065df144ffb9c0550e8a0cd7a1908, #1157)
   * Change: Stop projectiles from penetrating after 125% of max range, make borg needle gun penetrate in multiplayer (commit:8d058d40cc10caee5935187bd0a5c00062082138, commit:3cf54519b91e26a7f892f7277383d667fd40ade1, #1243)
   * Fix: Use module buildPoints for module construction and set their buildPoints to currently match the buildPoints of the parent structure (commit:872d3f4deeb7bd03f262eb4f24b5cf494ca44c8e, commit:084bc273104689fabbc7b741487c2de86a1359c7, #1212)
   * Fix: Improve VTOL CB, VTOL Strike, and Radar Detector behavior. No longer rearms full VTOLs and/or trigger artillery (too many commits, #1363)
 * Other:
   * Add: Auto-orientate delivery points (commit:0c4bdbb2d34874eb1ca0ba9b2966da8a72cbda1f, #1124)
   * Add: Add counter for droid's number of kills (commit:8f21aa0d318214936f9a07ae7e57550bbfbf3456, #1144)
   * Add: Implement mouse pan (commit:52e45c9069be5c6f930e79169059e43d1d3659f2, commit:0022557229fb4301d261bf17975a005a754de4e5, #1257, #1304)
   * Add: Godmode toggle minimap without CC (commit:daf8c7ba6416c43379e29134c8d23e294d6e9b79, #1393)
   * Add: Override the supplied terrain types so old maps can use the new values (commit:1296265b0544f94ddaaa4bbc381d4f3479625148, #1414)
   * Add: Add gameport command line argument Sets gameserver port to custom value bypassing config entry (commit:ca1421af0c79d17ede13d048825494478127c497, commit:dc35f3cfe6e61dabcb0f08be1c6bcb39660f512f, #1450, #1462)
   * Add: Non-default gameport support for lobby (commit:fb9bb3e314e6988e854d12b4a2d839ebbc2630b4, commit:fec20107eeda65b7a18f68bc96f3af03d929fdef, commit:b9a56ab62bfb3b063ec07c729bdf1c4b5fd94376, #1506)
   * Change: Many map config loading improvements (commit:2b3312e3b55714d6fc6da626baea785b4faf15a5, commit:37f4eb11d352e30b57665a94cf4a7dbba4619e38, commit:3dcf9351fc0e1cb11f85bce837b2f96dfe9a9012, commit:e8ce4f94ea4a76ab363a28c1f99381b9cadf69b3, #994, #1078)
   * Change: Make logo box transparent (commit:25d5661d2a5ed9b9fe81817edf1216a3384a54d3, #754)
   * Change: Faster mousewheel zooming (commit:3265c7e41643470519269f97ca8208f8a7111dc4, commit:0c38284e68e027db043ee8ec7f962992a4698006, commit:4256f1540dfff5bab697db91ac94bd30afbecddf, #1209)
   * Change: When in Intelligence or Design mode, ESC keybind should return to the game (commit:7fb11cb906075e377b69f3bdd445e45ec6d3065c, #1467)
   * Change: "Go back" arrow button in load/save menu now returns to pause menu instead of resuming the game instantly (commit:a4ed26b05b3505216b5ca72905e983a1d5c483ff, #1501)
   * Fix: Fix mbstowcs compilation warning (commit:97eab649079db35eec736fa4adcd4f4d29384cde, #1052)
   * Fix: Fix some `-Wformat-overflow` warnings (commit:fe56ce35469502c5dc8578b56a5a79b5b3f5b7d3, #1057)
   * Fix: Prevent players from changing positions in the current challenges (commit:3b725ad59706a530a94f1e9d79ad70f6e503f322, #1076)
   * Fix: Fix a big list of tiny stat visual bugs (commit:cc39e586f17bf8370c61b9fc69a57c99bb514f10, #1126)
   * Fix: Inconsistencies with exp gain / code refactor for droid.cpp and design.cpp (commit:176b96dfa793124ae2ea1d1e3b8a0b6a1c9eba19, commit:0694fa7aaf6532bf15caef27e0120ee4e5143cb4, commit:71779d88613614e88ab3557b865a33b41cb822a1, #1121, #1258)
   * Fix: Can now deselect units if hovering over structures, foreign droids, and features (commit:a9f1ed88b3e226b284f75b0f85ab0407ffcafb80, commit:eac012d37f0e960f37a0281e07e785622f29d427, commit:267412911df889b0246fb936772ea57ce056b2ad, #1204)
   * Fix: Performance issue when in-game options / menus are displayed (commit:87fdc75e7cb1e951e91708a9e20f9b01b21d84ae, #1217)
   * Fix: Turn off sensor range display cheat on game init (commit:ee0632a38c5a2cec02105cd20512dac7ed3c8957, #1223)
   * Fix: Fix timestamps with single digit (commit:f35ea74d11e818ccc30d8ca124af1c48da53b351, #1249)
   * Fix: Better reflect VTOL bomb upgrade names in the stats (commit:f5f899b5bca355cb6d4f95e0b0cbef73cf870db8, #1331)
   * Fix: Fix spelling of "Incenediary" to "incendiary" in the stats (commit:96d1ed401c9eb0cb1de15534d34b0b32254e1359, #1332)
   * Fix: Fix hyperlinks for missing videos not linking to the website (commit:93983f21b658345b60c9eb9ce93c972f22029cd9, #1339)
   * Fix: Do not change the tileset texture of water tiles on the edges of a map (commit:49140d80389dd969e31bddd4d846e7cedd5d103d, #1350)
   * Fix: Only show component tooltips for valid stats (commit:16a53447e0b45ac7dddf2c6c27f2f94a70223685, #1348)
   * Fix: Prevent crash when selecting the "add droids" menu in the debug menu while the game is paused (commit:2cf897386a0a3e7d3ad59a2c6440dbb06509474b, commit:917e52c160278db240aaea4bd3f2aa40a69d3248, #1369)
   * Fix: Fix truck build status display icons (commit:e33fd2013e92d6b40db6210fc172cab76b943236, #1379)
   * Fix: Handle PHYSFS_enumerateFiles failures (commit:7b9cc4d50de171305ea46061e518ff077cafabfb, commit:28e81a0ac8e9afc7a3630c417ee80e3957238f40, commit:d88838256547f4ae668ded3f1139351cb5b6c601, commit:ca2b5c33ef46d2e4e8426ee1676bf9f3ce62aedc, #1378, #1384)
   * Fix: Prevent menu related overflow in kf_BuildPrevPage() (commit:c1bbb2372fda3aa7cc6c70b2deca51d22bf63eff, #1451)
   * Fix: Remove tiny blue line where console "active messages" appear (commit:def829940c2facd044f6faea75b7b2b5e7b3f7f5, #1492)
   * Fix: Fix loading progress bar from in-game load (commit:933376d05aa3c496f4b288883025e2cab931effc, #1525)
   * Fix: Mods cause a crash due to component type mismatch (commit:6e7374aba65a2abf4f44ca9420b4799e48214429, commit:36d91b1b082bb5e615a157e506fc9fbdcf2fefe2, commit:b05889d71199039e7f641688d134809fd28f4a57, #1529)
   * Fix: Fix Nexus link flash and shimmy effect (commit:9580252970365320b6ac33237b328490926819dd, commit:8bcdd22a7bf7e418551b76f976bfc899625b562a, #1542)
   * Fix: Fix Assault Gun Hardpoints being built way too fast (commit:277f19295ca5e22045998e8fc88007fbe682fbdf, #1552)

2020-07-19: Version 3.4.1
 * General:
   * Fix: Zoom speed tied to game speed (commit:22a7855b4ca5262f75b48625ea1a2fd14e6e3d2d, #939)
   * Fix: Chatbox text drawn over tooltips (commit:605969d3196d56d7fbcc9057b776d168630a9634, #965)
   * Fix: End game stat bars having an off by one error (commit:ef02b1256619e15b0b08a7d8fbe36b4a60994204, #973)
   * Fix: Improve keymap default logic (commit:79518b0b19396c48ffc607183353dbe252578291, commit:8d764e53c31909f12d46ab8194d64be460988618, #977)
   * Fix: Chatbox related softlock (commit:a12b1a9cf305054317630664492dc8816acefada, #978)
   * Fix: Fix simple keybinds not firing when a meta key is held down (commit:92979bab768e0fba7666c944883885017e8ddcc8, #993)
   * Fix: Refund factory power better with queued templates (commit:43b48a7a8552615787a07ee808a9693e0f8bf7b7, #990)
   * Fix: Minimized/occluded window causing a huge spike in CPU activity on macOS due to vsync issue (commit:17fb3cc2db07cd063886ef6d180a5b8be65e7654, #1020)
   * Fix: Prevent softlock when opening reticule menus while keymap is open in multiplayer (commit:7a268d18fbff99ff09eb639db2b6cb940fa33dd7, #1030)
 * Campaign:
   * Change: Victory condition "eliminate bases" now triggers a last attack from the AI like the other conditions do (commit:215f6f255621138b745ef364052d2890282f41f0, #988)
   * Fix: Failing at the start of cam3-c if no trucks were present at the end of the cam3-1 mission (commit:46fe92bfecbed112af1bef5f0ade117039650ff7, #1021)
 * Multiplayer:
   * Fix: Changing flag color should not reset ready status (commit:cd1c0be79a6698d8db6e2110a8899239e08e9a91, #966)
   * Fix: Fix map preview sticking to kicked players (commit:a411fddbc629829c7010503e0c85ca274006b98d, #974)
   * Fix: Player stat "played" not representing actual completed games played (commit:ca27273228e8f04df5e5c7e1bde45950b3be1e8f, #1013)
   * Fix: Reload palette file after mod downloads (commit:4a8f98d4b5f9a72b0dd09b4241a7d60646d69505, #1015)
   * Remove: Prevent ability to change to smaller maps after hosting has started (commit:c56ad15e34ed1cdd52d885b1b3b6d751a2c1a1ff, #1027)
 * AI:
   * Change: Improvements to BoneCrusher! AI (commit:e02323c2665da6f6ce09f7417c47f00e71439498, commit:9902035e1d4600c246b553f52e526f8a126bb2f6, commit:38a44a163ad2af9d628f0a8875f5eb8594d3ad95, #1007)
 * Balance:
   * Change: Make Scourge available at start in T3 (commit:ab9a5f3d5b861c84023df8cc3bc19ca548b61557, #999)
 * Other:
   * Add: Account for Repair/Demolish construction queue mid-way stopping (commit:588c84c9a42f9de8e841322468b9574c0d4a7811, #989)
   * Add: macOS: Video sequences app bundle packaging (commit:880352481ad60c61b120a3f59893b3d8c2668eec, #1018)
   * Change: Set new map zoom rate limits (commit:5d212ce31693585cae5f0c68331d7eae7e7f6dfb, #939)
   * Change: Point revisions use the same app configuration / save directory (commit:22dab1a7069bc86acf5a1c161bd3f18252d29c56, #976)
   * Fix: Damage calculation must always return at least 1 thus fixing Nexus Link damage against tracked units (commit: 7b41dd69c63cbdc3c5ef53b89a3ea717e06ad9c8, #981)

2020-06-24: Version 3.4.0
 * General:
   * Add: Frontend "continue last save" option (commit:54536b3bb2f919de5250698ea00317c0b174c797, #408)
   * Add: Shortcut to quit to main-menu after victory (commit:9beabb55a7444c5cb02ab9992f22dd51ded7fe43, #518)
   * Add: T4 technology level where all research is completed and addon.lev change (commit:c0f8f1ddef9e38948a9fed5aa300f9a4b5698a1d, commit:e50fac0423492ca8180e42507fe0db6c51c9a282, commit:1cfb90a05efc7f7135d5b659b434a6381aee71a8, #396)
   * Add: Option to enforce structure limits on maps and disable most research related to limited structures (commit:ba06ee18c99b04f3cd46a81e2eed1a251f2d05f3, commit:55d627faf623ec07663701165ab4efe3d8044408, #409)
   * Add: Quicksave feature (commit: d130d5cf8f510dbcf6a3680d5ef436b18d761669, #464)
   * Add: Way to change most game settings with the in-game pause menu (commit:905cc6ff2f659d6118ce13285f2ddd341a17c6cf, commit:e821f2ed15765f0f0a7fe64df335f646bf61e93b, #469, #565)
   * Add: Autosave feature where the save rate is moddable in rules.js (commit:bff9eb56db0b0883156eb14bcd8add2327bc0f7a, #536)
   * Add: Favorite build items menu shown as a heart icon (commit:8241df0042cfaac75b2e1b192ffb8c31b220ec4e, #556)
   * Add: Right-click AI slot to quickly copy it to all other AI slots (commit:e7ff1e1d5fb956aeaa1dc721f3950dd0f2f4de2b, #551)
   * Add: Randomization of game options button in skirmish/multiplayer games (commit:f49ff2b8bbbf9b43bf80dbb2402507cf770cef89, #539)
   * Add: Randomization of map and positions. Not available when hosting games (commit:e821f2ed15765f0f0a7fe64df335f646bf61e93b, commit:c4fb21e2dfd02b48c353e0b2491d87728770569b, #568, #596)
   * Add: Allow pressing enter/return key when connecting to password protected games (commit:81a1a3790662ba3508b888d47929bf0011a6bc4b, #579)
   * Add: Add support for changing map, game name, and hosting player's name after already hosting (too many commits, #526)
   * Add: Support configuration of OpenAL-HRTF mode (commit:33c4d81795f8f98c103b2af81d4c1575f0f4abb4, #675)
   * Add: Support in-game notification popups (commit:0d9a0e6736ee830b29811bf27eacf79f693f8ab5, #679)
   * Add: keybindings for camera pan added (commit:6fb19e8a053a9a5de2138fe6afa6c1ea6d7e0c6f, #739)
   * Add: Discord rich presence / join support (commit:9c59dd3b15a7d14b4a11244daecaf9fa45d7aac7, #876)
   * Add: Unit / kill count gui feature (commit:ff8c56612a1e3afd597f88fb6cd2ae56142e5206, #943)
   * Change: Challenge layout updates (commit:93db639e1f83ea1819139bf6b85f70b1287a094e, #524)
   * Change: Pressing the key 'M' now shows the key mappings (commit:0bc1b68c862f85146b0693e9c29509ddf63fd5ad, #661)
   * Change: Sort saved games so that recent ones appear first (commit:2d35022fd58193fe6995c6df7806bf6d1a77bd55, #902)
   * Change: Simplify technology level selection (commit:e448c8a4f3b865957aab58d8718f6da1c2bf87eb, #949)
   * Fix: Not initializing the random number generators at application start (commit:925cb7ca4614930ad40d0932c6d957e7986090ac, #539)
   * Fix: Enemy hover units turning invisible when over certain depths of water tiles trying to be seen by other hover units (commit:8242c25a2436b817fdf0662bf295ac467ecde59f, #576)
   * Fix: Fast-play should not create net logs (commit:e2f3dc9e40247cf0065fb20fd080a00a0dbd9946, #599)
   * Fix: Production queue was broken after loading saves (commit:25f2970f5f73128df9ed0d87c0bdf032f7a10aaa, #664, ticket:2983)
   * Fix: Units dropping out of the sky when produced from factories (commit:6b869f9e02fa21cbc7f0f0902d5d7ee9f6d77d2b, #719)
   * Fix: Game falls into infinite loop when you load a damaged save (commit:10ca85b2ebfb86ab7dcbf14b16b461e8f3490312, #906)
   * Fix: Tile burning flag is not restored on load (commit:384c7228621c0f0b98910ffb767425e541d7123d, #912)
   * Fix: Trucks should stop mid-way if structure becomes finished (commit:312c7869f908f00484d6184221fa6ab0d37f1832, #914)
   * Fix: Moduled building demolishing power return (commit:91ce267100564a1d7ec0edb54294bd46a14d938e, #940)
   * Fix: "Cannot build. Resource burning" will pop up for each selected truck (commit:ee555f790f9e2363f71e1199aa99b3e2f072f145, #907)
 * Graphics:
   * Add: Allow shadows with these feature objects: artifact, boulder, and vehicle (commit:0e502341f099f78f2a0d81b158e0c0d225a54cdf, #635)
   * Add: Interpolate frames in animation (commit:b399fc362dcb202e341d7ddb73ea9e782b64e79a, #748)
   * Add: Occlude terrain ambiently (commit:ba0b8ce41712c146cab142c771fc796838ac0a96, #764)
   * Change: Replace little cyborg walking animation with super cyborg walking animation (commit:98582506106a76e6a1d11c0f874ea84c25f2a712, #819)
   * Change: Allow transparency for structure bases (commit:7a5a14c43ad83ba0eb0da56fe3301b9d921496df, #883)
   * Fix: Atmospheric effects should respect game time slowdown (commit:41c72f127d9b130c4fe9df901519728a7a1634d0, #913)
 * Campaign:
   * Add: Make campaign use dark unexplored tiles like before 3.1.1 (commit:15a032e9de9179f678dd3063151a040bd9e362c3, commit:5dd63b5fcd8dbffaea5087b5c89f88551b655937, #447, #529)
   * Change: Slow down factory production timers on Alpha 12 (commit:9fa9b8ca09e257cb96cc86a4ad937c3f8a1adfe7, #678)
   * Change: Increase Bunker-Buster ROF (commit:f0998eaad700fa88881e13d999d37c2261e14b63, #707)
   * Fix: Alpha 11 (cam1-7) failing to allow the player to win if getting the artifact too fast (commit:cd6d345eef01abf6343d7dc762ba6dfd4ee5ac05, #574)
   * Fix: Gamma missions 3, 4s (pre-away mission), and 5 did not game-over because of trucks stored at the end of the Gamma 2 scenario (commit:e0fb35b5a9ee445e5555482d58b37a97e95ce6c8, #588)
   * Fix: Prevent the ability to select the campaign transporter on Alpha 9, Beta 1, and Gamma 1 (commit:9e6e5bfd0b716f8f496710d5304cd15dd72a8ad8, commit:7e8c5deed1ae9351bf143a7bae6dab4ba6a5ea9e, #651)
 * Modding:
   * Add: Basic upgrade support for repair turrets (commit:3ae3006f67beb2addf9b7149becde6d2c132188d, #658)
 * Multiplayer:
   * Add: Remembers the last server in the IP-connect box (commit: feb25267030a0bf079a848f3cc232db8255087bf, #433)
   * Change: Consistent upgrade values for some research (commit:112122b92f0370b60a0e379ca4e93187540eff5b, #557)
   * Change: Scavengers no longer affect score (commit:f0cbddfcdd8dcf237c05c2b00cb624ac995da6bd, #666)
   * Change: Starting technology is mostly different on T2/T3 and based on time (commit:f7f33be120633e2382a505279390cd7f26b2702e, #720)
   * Fix: Melting map player 4 owning a player 0 derrick (commit:07c4fdc24cfe85c5649048a2247a8ccdec796dd3, #546)
   * Fix: resetReadyStatus() now actually resets ready status buttons as it implies when host changes settings (commit:ce1b60c3e9e5c17faa8f45d80fcc9fea2d5870eb, commit:31295dfcbbbb4aae3c67095980fc6ba2ae56f02f, #572)
   * Fix: Do not allow the exit-click for Map Preview go to the invisible widgets (commit:91194316acc451e3f1e4cbbaa38849a7d57aae17, #585)
   * Fix: Protect the status of map-mods when previewing maps so a warning about hosts altering the code doesn't happen, or, the red icon showing when it should not (commit:8d4a8c243e74b7ab8323fb0ceeba56147a53ee76, #586)
   * Fix: Fix saved template availability when loading skirmish saves without a HQ built or when immediately removing the HQ on (advanced) bases (commit:78f312d3ed33163639ee867837496cceeba2127b, commit:23497d673c9905e01d2d34f73755127fe8af21fc, #630)
   * Fix: Drum spawn logic should no longer show an error in some cases (commit:da3fc1f58c5d2da72e698375cc80f3f78650b834, #657, ticket:4419)
   * Fix: Beacons will now remove themselves properly when dropping another with a save already having one (commit:5286fb434f74536a7e690b7367730bb7bccda1be, #707)
 * Scripting:
   * Add: Prints some game settings on skirmish/multiplayer game start (commit:a087c51b467ebffe7cb0edaca14e8ebe9d4411e7, #615)
   * Change: Ignores repeated orders issued from scripts (commit:b2eb7f4ef4087b20c9dde1e4156e390e17485be6, #487)
   * Fix: eventGameLoaded only fires when loading saves, as it was intended (commit:6bcd12ccdf9f8a739348ed2406274a0351025720, #550)
   * Fix: Functions isStructureAvailable(), addDroid(), makeTemplate(), and buildDroid() no longer return false if they encounter redundant components/structures (commit:eee8025fc1f4484327a4bf5c2bfe0aa25169f74e, #590)
   * Fix: Script debugger impacting performance after closing it (commit:aaaf3ae796106a40cb005ace87de7369179fb766, #611)
   * Fix: LASSAT stattype could not be used with function enumStruct() (commit:442b0b00c76b3044dfc1e8340dda007c69f25d46, #613)
   * Remove: WzScript (commit:05d7814e4d15e5c46311ab91410a52546e83a49c, #512)
 * AI:
   * Add: BoneCrusher! AI (commit:60a369044b6d5f5e306a1969dbc81ac4782f1ceb, #532)
   * Add: Cobra AI (commit: 42adc8de34c018c3fc809bfddb59f288059c94d3, #513)
   * Add: Nexus AI ported from original (commit: 5aa27ef4cbcfd62cb97454b60580323663300ec1, #513)
   * Change: Rename SemperFi-JS to SemperFi (commit:ed9f4d0c59a7689d9d26c9eb3538a84b596aa973, #513)
   * Fix: Division by zero if one AI is available to choose from in the AI chooser menu (commit:020586f6bb15a97949f7a8986889862639ca7db1, #523)
   * Fix: AI communication channels were switched off after loading saves from a fresh application start (commit:5171d00e34814b53a85ca2131c83625695eccecb, #660)
   * Remove: Classic Nexus AI (commit:3fbe32bb8257c3cba27d8244769ebe8420b6936b, #511)
   * Remove: Classic SemperFi AI (commit:2612c2bce9470ac6c0a8e51f44b55382842e0226, #511)
 * Other:
   * Add: Autohost from JSON settings file similar to automated challenges (commit:aa1ba903c99ffe5dc41b2da6e57fcc072c7e592a, #502)
   * Add: Timestamp chat messages (commit:a68d5389c913d5a36d1c66b9135b383202c8b41f, #680)
   * Add: Fade effect when starting games (commit:b328ea78b271f931853cfe67500280fcbc061601, #751)
   * Add: Vary initial derrick animation frame (commit:b00e9f15de144b1e3c10814a282d6500f06ac765, #747)
   * Add: Vary initial radar dish rotation (commit:63b7a2c4f11c3bec2c532636284dba3165c0d69a, #741)
   * Add: Give half-tracks propulsion sound (commit:5614099a6cc7d40e5adf0328165b09d703f94438, #870, ticket:4181)
   * Change: Huge titleUI refactor (too many commits, #540)
   * Change: Display "global" or "ally" on chat messages for the sending player (commit: ea97d3202c0f342c5287fffb5bdd8724d9e4daca, commit:e065469b1e8f667222eb5548e685a159a8815403, #519)
   * Change: Behavior of "select similar units" improved (commit:bc5597071f7814c50f89c28895b4db61fdb1d9ab, #669)
   * Change: Deprecate autotools toolchain (commit:eca70df4a21492bd27b14b6e993d20bcbb375429, #695)
   * Change: Smoother mouse rotation (commit:7316d8103dc2390cd34ca95fdaf201a1d68f90d1, #734)
   * Change: Smoother zooming (commit:8a943d9470b8538599006fd5c067237e6595cc50, commit:3314483a92b9e595299df0ff76c45e3160242f55, #733, #751)
   * Change: Redo the drag box pulse effect (commit:524271d5f49c4811850019c319d4c3e86f56dc73, #749)
   * Change: Adjust height tracking logic (too many commits, #892)
   * Fix: Map zoom config limits are now higher to prevent the camera starting too far zoomed in (commit:098d2eb74640cf87f54736967102681a02330bea, #537)
   * Fix: Derricks now emit sound again (commit:e307e88e97ff05ef7a54139922b2247aa9763143, #543, ticket:4766)
   * Fix: Scanlines config option is no longer switched off if a video can not by played with scanlines (commit:4d4f955f35776d27f997ea90fe2d00125969c145, #581)
   * Fix: Display of debug menu items (commit:c91d6e7715a09c7e0474ed8e75dcc1396ac27582, #598)
   * Fix: Better crash log handling on Windows (commit:16b420cfbec50b1fcb9f552eb084c72c8f326e36, commit:d52958a62926a67d595fdd527b22040dd60f98a4, commit:2edb62ed9a457ed06a3a8ee0f107c3b3fe32f2a3, #619)
   * Fix: Enable HiDPI support on all platforms supported by SDL (commit:5e3387a1f5850fa3a60d3ac6c92722c01c484495, #627)
   * Fix: Fix negative score overflow in debug menu (commit:01275997ad7a76a91aa1d9d68a57729cadcee16e, #667)
   * Fix: Improve info message when losing a unit (commit:2264ed975f35b6ab5ab05fbf7321882cb947b9a7, #668)
   * Fix: Prevent duplicate projectile IDs (commit:0861c922d8891be1f1b878da617c8544810cd80d, #769)
   * Fix: Prevent some graphical responses from the reticule buttons when the game is paused (commit:234fe01a0f12c178689e2b3bfcf8f5e84c12bac8, #792)
   * Fix: Fix radar jump rotation bug (commit:2d5c88b7b61492c2edc117b27ddc7c255caaeb4a, #856)
   * Fix: Crash when upgrading structures without upgraded models available (commit:f4350b9becd0128b5a272dd8692897300e39a18b, #887)
   * Fix: Prevent the radar viewing window staying green when switching from Gamma to skirmish/multiplayer games (commit:35505527dd8d0571beb809f484f571544b76b372, #891)
   * Fix: Reset scroll direction / speed on new game start (commit:4626a62fbca70e50f093b5884ea8963b68f11251, commit:ff527f66fbb03738b2a73376f09b8600437fe657, #898)
   * Remove: Disable cursor swapping when moving the camera via keys (commit:284a168a90dba3b1aab288f8c661ecbe71157b65, #772)
 * Balance:
   * Change: Increase multiplayer Bunker-Buster weapon ROFs to hopefully increase their usefulness, according to mp community players (commit:58449ecb36f0283e9c31a68c6d35b0aafc31caff, #531, ticket:4861)
   * Fix: HMG bunker not being affected by upgrades due to sharing same name with another structure (commit:f27ae30a370266e1a09ce1d088b5906cbf7eaf90, #508)
 * Translations:
   * Change: Moved to Crowdin (commit:5b446f5c21e58941b5528ace991eac512085799e, #700)
 * Documentation:
   * Add: Alliance type ALLIANCES_UNSHARED now documented for script global variable 'allianceType' (commit:e030c3d0b2894343912a489167ecfd2a27b66495, #601)
   * Remove: Doxygen support (commit:540ce1948e055e9937383c052616a5e4dd5fb0c9, #316)

2019-08-31: Version 3.3.0
 * General:
   * Add: Reinstated secondary orders Pursue, Guard, and Hold (commit:29d3696dd62f034d02d51b9caa7d834cc84e13d3, commit:4b974e5761eecf7fc375f50d954779e4ac800786, commit:2fb172792014d8886a7411a2547b15030ead0152, commit:274fab1fe4f5a7f443f42b35211d95f949cd63cb, commit:cfa8ca695079df3d716a6eb7a2ed2f5729320bea, commit:8f611fe0f6ffb906bee0afd5de702f8b2de9f1df, commit:ff5ec8ca927c2d3353f58f7ac0ca17f965252234, #263, ticket:4303)
   * Add: Reinstated range orders Optimum, Short, and Long range (too many commits, #314)
   * Change: Pressing Escape clears chatbox if it contains text and closes it otherwise (commit:809dd2abdfbf97a88d74519cd4323d06ce8395d2, #294)
   * Fix: Processing of radar input after disabling its widget (commit:39f083ed0f0c29f071f9f528c9eeef5544373fd7, ticket:4867)
   * Fix: Saving of challenge scores (commit:e1b3eac0faeb7c39b769fee59920d066373d5c49, ticket:4868)
   * Fix: Crashes caused by missing support for mipmap generation (commit:a850fb5c887eb54a50f3a3f0f15ef0f1b6591a98, #260)
   * Fix: Improved window resizing and display scaling (commit:aedc207367c03a105f0ec6475250cdf0b3908008, commit:39aeb5132197a87e0c4207ae36c461eca7909522, commit:e1e991ce3edf9c68f72f3572ab8357abb930f48c, commit:c89a299dcf581c9362bf2461f291a8388c70c0e3, commit:aaf79eda0356eb0be264be65c640f19c12a17327, commit:924b98272140677cfde4955af84aee930d7c4b0d, #319)
   * Fix: Support for more graphics driver workarounds and platform compatibility (commit:d517b62e394c42a2b1e0b831a0cdc26156faca80, #331)
   * Fix: Units shooting through walls to attack targets (commit:4ed887ed1986840474281d8fd28fc0ea533c06aa, commit:5cbe6b9e93a0a9682996fc1edf3df43ee5f7096b, #271)
   * Fix: Very slow map/mod transfer when vertical sync is enabled (commit:1d1050f034e7c226d98e371598d2c2a105d24353, #392)
   * Fix: Do not try to attack jammed units before being in range (commit:b9cd1cd49eae103d4e95b3f14e84aed4492391b3)
 * Graphics:
   * Add: Hit-testing support for widgets (commit:405a59420918f903352c4a51be6822eb60d4066b, commit:9394cd5f6c5c1de666d34d56cc32a0d4dfbc83e9, #264)
   * Change: Increase click area for in-game options (commit:bb15fbaa10663d6ce540911d9890f733b75fd365, #266)
   * Change: Improved text width calculation (commit:f4a8c93c9012eb5424296604bd1a0fa56fa2bc06, commit:c27ad854669ee55834fef43f4a7b6fba0dc28b88, commit:0fcad70a72b44aaaf0b01fe425946cd0193f5216, commit:35e5a8d021dfcefa9b7bce7e846a7c2432a7a064, #287)
   * Change: Split challenge tooltips in challenge selection screen into multiple lines (commit:2cc667cbb8f3765a5b69e0c210ab5b1355db3ca6, #299)
   * Fix: Issue loading OpenGL on older Intel chipsets on Windows 10 (commit:8a755a5e6e4f0eb8c62cc51db121cc61c65da80b)
   * Fix: Flamer Bunker model (commit:400191c9c47a4e39aeb12240283f355a57e30290, ticket:4856)
   * Fix: Objects darkening when zooming out (commit:456a74edb1fa76e66bf8e0e2c888b54c0b5c6299, ticket:4375)
   * Fix: Layout calculation for unit orders panel (commit:67b64e6f4205b123e69d6973f2a524656a419c75, #261)
   * Fix: Layout calculation for mission timer (commit:d655de8573b8d781d748d5c53e7f46f39a402d82, #261)
   * Fix: Misplaced reticule area buttons (commit:6731c4ca5f1178e408d1cb22757793fe7ad1015f, #262)
   * Fix: Broken shadows with rotated structures (commit:b7e00616a5068ee0e3be03eb92df803044b2bb84, #285)
   * Fix: Horizontal offset of chatbox cursor (commit:8944aac22bdb43abb849302f158a2704bffb4dd5, #282, ticket:4796)
   * Fix: Alignment of right-justified small text buttons in main menu (commit:e6aa8792eac76c7c853df33ce8f5423f12cab4ff, #287)
   * Fix: Shader warning on some systems (commit:189b18dec1fc9ffe2381eeee1d89534112309601, #318)
   * Fix: Broken shadows with rotated features (commit:39021659101136e3cf4a26959daf7ea86335c13e, #368)
   * Fix: Broken shadows with corner walls (commit:33963b56adc0a7cfe29110c4cb6407b6ea069b29, #368)
   * Fix: Color cursor offset (commit:66322c966eb22c4ac65bfecf4e829e46a4cb4a17, #426)
   * Fix: Fix cyborg and scavenger leg animation bug (commit:123ded59aedc53dc2344be9807c321774613946f)
   * Remove: Flickering of blue/red laser beam when building/demolishing (commit:724750e92cb9884ab81ce565f4d007af817f16ca)
   * Remove: Disable PIE SHADERS directive support (commit:ca536c35fda80d23c3467e5d59f0fdb7debc3525, #380)
 * Campaign:
   * Add: Time conversion functions, for timers (commit:bfde3e18892345a39ad2a3e62f1af66ee17ee6bc, commit:b497b1fc06c9b3ec12eeefc9c2e9b44575f37ee0, #322, #411)
   * Change: Campaign scripts to automatically play the "reinforcements are available" sound (commit:33764ec247ad99ee7ea744ace0404cf16e40357c, #320)
   * Fix: Overlapping objects on maps (commit:f3a9b4d640bbf1662b3a297554083aecdd5401a1, ticket:4865)
   * Fix: Gamma 1 is instantly lost if first transporter drop contains no trucks (commit:e2dc5d7d50057e655c4d3e28411fd2d1b923a69a, #277)
   * Fix: Gamma 1 transporter drops being randomized after loading a save from end of Beta campaign (commit:58ac40f0a00c521eed5bad7cc55ba01a212ce4dd, #278, #280, ticket:3009)
   * Fix: Timeout missions not properly failing when player should be considered dead (commit:8042e44511b40b4821f4eccd993435479a4c08a3, #320)
   * Fix: End of Beta campaign requiring more than one transporter to start, unlike the original campaign (commit:9d1fc6fe7a51b0a17a6396d5e1d92546f6431b05, #320)
   * Fix: Laser satellite not firing at unfinished structures (commit:8b8653a82c8916783d9f8875b11f53250813cc25, #369)
   * Fix: Calculation of player power at start of Gamma 9 (commit:30fc938ae920eff5472a1578664f8539e2e2d625, #370)
   * Fix: Structures built in Gamma 2 save zone prematurely ending mission due to them being counted as units (commit:04a78c9fb676dd71594b6a6a68b4e8b4d9d8d064, #416)
   * Fix: Assert from destroying the Gamma 2 base during the nuke event if the player didn't destroy it themselves (commit:71b100563e6df04e690480ed267f46355ffd77c9, #416)
   * Fix: Alpha 1 area triggers potentially being triggered too early by the AI (commit:fdebdf51fba6fe8e0286bb9c8ef534fb629589b9, #454)
   * Remove: Ability to build MG tanks before having an HQ in Alpha 1 so as to stay consistent with the rest of the game (commit:cc6ea546e4e17800a1d29000689cadf92d9d13dc, #383)
   * Remove: Large power bonus given from starting Beta 1 on Insane difficulty (commit:3c7691cd4fd3113d42183532eeaa8160e2230b2b, #435)
 * Scripting:
   * Change: Function componentAvailable() returns true for redundant components (commit:0b535c8292ec70e113e1453ff472b79e07582be2, #321)
   * Fix: Group label ID and game object ID collision (commit:b63648f432c27043edcbe8af84613cc1e67a6b61, #304, #355)
   * Fix: Check for redundant templates with setDesign() (commit:370cfd6afa257065be4fbc41ac2bcdfe343bf5f6, #378)
 * AI:
   * Fix: NullBot gateway building function causing a good chunk of lag (commit:db51614e568660ef9f6704c385a98c316c4cd227, #313)
   * Fix: NullBot owned VTOLs attacking things they cannot hit (commit:43d5ee0ef8a7935390241536b63bf1acf0d22aa6, #313)
   * Fix: NullBot ordering non-sensors to observe objects rather than scout by driving towards them (commit:4b97f42aac1fc75b0956c6ab48d2c1212fe933a2, #313)
   * Fix: NullBot trying to assign a label to a dead unit in eventAttacked (commit:8fab71b2d37d58e9f98c36b7fabc83add1d8a140, #313)
   * Fix: SemperFi-JS not building its fourth research lab when it should (commit:6634148db34e21e4f05fc34291c596b0f76ba7f4, #429)
 * Other:
   * Add: Console message for missing Command Relay Center preventing Commander production (commit:c165d8c1d233b1c3051c21b19aaba669d9cd32e2, #327, #329)
   * Add: AI related tooltips and changes (too many commits, #419)
   * Change: Time and date representation to ISO 8601 (commit:224a92afc8a1848e13344f7104408ad2fcd1cc01, #343)
   * Change: Configuration directory of debug builds (commit:e9830ebdd1d359fa7197276ae2abb7a30f8f5c21, #335)
   * Change: AI descriptions and tooltips (commit:4b2c88fb84a92fd9733d73e72b6921b3314ed9a3, commit:c4b5f4d057d0ac48696ca5171322556dcec6510d, commit:a8cc35fe89b42ca055c00443f68633a993b9ea90, commit:db1a216fbc98e2ed7787e1dccb95c428075d48e9, #281, #419)
   * Change: Always initialize SDL before Qt which may solve some crashes on Linux systems (commit:ccb70cb68040976e6823dfc6483d5b89d0496aea, #401)
   * Fix: Truck getting stuck when picking up artifact in tutorial due to a cliff (commit:f4fa0a93e26103402e77e2072e3004b533029904, ticket:4866)
   * Fix: Throttling of production console messages (commit:3bb244b7a41237278a731bde7cc49626646a1107, #327, #329)
   * Fix: Undefined behavior (commit:41af29c6a58431042cd2649b8aa1984c8e53ef0a, commit:43a34a886c0c62f92065c0c9646bb3027d6b09b6, commit:fa02178faa1caefbbff63d82d9262ad5ba80703f, commit:070f0c8532007cc3f90d1124ed8d76ecf04d22be, #351, #353, #356, #436)
   * Fix: Tutorial issues (commit:18a0b6ab3f4053948534155b94acc02993e685b0, commit:d79c2a362451af725de5dce7a7cf7677041b9088, commit:f41f78a9cf7606286c4305d49ece5cfda583e1d4, commit:518b2563bf4c77a3391017523e9c401f33144c2c, #381)
   * Fix: Being able to use saved combat templates before building an HQ (commit:7d6210510ed6efc18694c352b00a66ebea1ccb5c, commit:9e22db301aa93182114d35bf298459ee31eec383, commit:15ec435836aa7fe906f77ed42e555b39789dc67b, #378, #394)
   * Fix: Debug menu crashing when trying to open it after loading a skirmish save (commit:f340d89f8b8ab3c978dc246a07210438da6e928f, #422)
   * Fix: Missing AI difficulty button when everyone is on the same team (commit:63c358c85b507c7382abc27785de3148578e41f8, #423)
   * Fix: Always make sure the default AI stays as the first list entry (commit:6b91d9e5019401eccbe1e23c2ed3d3321f2f0407, #419, ticket:4791)
   * Fix: "biffer baker" and "double up" cheats causing unintended behavior (commit:6f24a6ceb94ca4e2ec27d926b2c1f9bdfc5fcc4f, #438, ticket:4795)
   * Fix: Crash when loading a saved game of a challenge from commandline interface (commit:244fd2cbcb12465866191dcc7203aca7719fab8c, #439)
   * Remove: More Qt dependency from the source (commit:97cf508379fe7fb56ac8ecccbe3269783d3620f3, commit:ca9c1166e386f43ff76aa16d6971ca2ab2eb1303, commit:131e4f705888445aaa26643489d6a238a4fd3515, #276, #299)
 * Modding:
   * Fix: Desync when trying to use mods while hosting 3rd party maps (commit:7d6210510ed6efc18694c352b00a66ebea1ccb5c, #388)
   * Fix: Windows hosts crashing when clients connect and mod transfer is attempted (commit:2cddc2fc122ce531314bc7d47c6d279966d4ab04, commit:1b5fe86b6570a2454f189027bcf2fb65aa653db8, #441)
 * Balance:
   * Add: Restored multiplayer weapon range and accuracy stats of version 3.1, with small changes (commit:7f4c03ce5236611ba2c485b5a27f3a445ec47b48, commit:20345ce333248703a1198f84aaad974cf4c86c68, commit:b1d5f8e5885faa4acee9cc01191606818b7d3f03, #387)
   * Add: Restored campaign weapon range and accuracy stats of version 3.1, with small changes (commit:c8ecd75d7b426b325202f78ac30f9fa509f27b7e, commit:e6ebad0d3f62ff3d764a4922bb0ea39e82f20bce, #399)
   * Add: Accuracy research upgrades short range accuracy (commit:50a6d90a089c2bd1124b9ef3db7640a470e476e1, commit:1896ca1db6d2425d47e8703a540dab912af58164, #410)
   * Fix: Cyborg flamer and cyborg lancer not being affected by upgrades (commit:303b27f2ddf7eaf002145fdec7bc149c15ed26a3, #362, #363)
   * Fix: Weapons missing behind targets which caused higher accuracy than intended for all weapons (commit:44eb5e4201ba5fd63d1286bc0ea5a59030d1ec2b, #371)
 * Translation:
   * Add: Translation of structure limits screen title (commit:198215bbc09438e689db0eb2a4d0ed3de4a276f2, ticket:4871)
   * Add: Support a second line for translating the "AUDIO / ZOOM OPTIONS" message (commit:70739936939ad38f8df61bd3e7e56618406a4b23, #345, ticket:4629)
   * Add: Translation of commandline synopsis (commit:98cee005269cc03c9bc63e13ff62ff4c9537afe2, #425)
   * Change: Russian (too many commits, #239, #382)
   * Change: German (too many commits, #326, #328, #413, ticket:4845)
   * Change: Turkish (commit:b14f9bd574e36e0ec0db3d59ad14249c90747435, #259)
   * Change: Brazilian (commit:b00b17c5583c385a5518dcba412efab4765da888, commit:30a7855679645309bf290aad4780c80cdfa1c3df, #315, #402)
   * Change: Polish (commit:211574fdb0fa473a773d92969d654ae08d58c5a3, commit:40872630a98bf46253dbbc0651443f73bcca18f1, #339)
   * Change: Slovenian (commit:cac83e9e50d2adeea5b2b02dd0a6a0da5e23034a, commit:b33d1e3b9c8749e7d4546680369b2705f236350a, #357, #377)
   * Fix: Translation of research messages not being shown (commit:f1b170db3012f4fcd99335cd814180ea8d37e0d6, ticket:4843)
   * Fix: Mismatching format specifiers for singular and plural form of a translatable string (commit:db95329005c0e07329138c90a64a2cf43062c391, ticket:4872)
   * Fix: Version string being printed in the wrong language (commit:42368861607faf54af2acdeaea105533fd97a54b, #344)
   * Fix: Printing of commandline options for foreign languages (commit:9d3173613268214dd72e15aaedf33459d764c37b, #425)
 * Documentation:
   * Fix: PIE format documentation (commit:7a4fdb16de1558a86a48e1ef77df7e7c64155c91, commit:58e78a22f48375273f258e294ea8bc061fac7f48, #295, #325, #334)
   * Fix: Bug tracker URLs and wiki links (commit:06503bb0071eb781d4f33b1b9d234be40e612ac8, commit:d4af395eea5753319509744c63dc0d685976f9f6, #427)
 * Build systems:
   * Add: Folders to CMake builds to improve target organization in IDEs (commit:093aad3817dee2bd9b0090ec57adbbde1a56e827, #291)
   * Change: Disable 3rd-party dependency installation in CMake builds (commit:c40ff4b15996a59343b860827f49b2038c973866, #340)

2019-02-10: Version 3.3.0 beta1
 * General:
   * Add: Challenge "Two-Faced" (commit:2535b921a40afc0a760a54f9efe31494d95dcc7b)
   * Add: New save game file "main.json" (commit:6670ce187a559dbed0fcbd7a0b49ee61488801fb)
   * Add: Cheat "teach us" increases unit experience (commit:6670ce187a559dbed0fcbd7a0b49ee61488801fb)
   * Add: Cheat "showorders" for showing unit orders (commit:34383827cf7f2347b2545201e8947ffeededba84)
   * Change: C++11 modernization (commit:9d0f604d5ac7a5968d3b8582ed5934eb4117bee4, commit:8aa07d1939c8e66759828df7b524f9b4854cebb4, commit:4c4b2845f95901245d5d90153d55a5d3db7b3b80)
   * Change: Keymap format from INI to JSON (commit:a1721f37a5f79d195e44c4c9b361037f235ce138)
   * Change: Create all configuration folder subdirectories on program start (commit:2007f14910d36b4a05e1a308a0b2b720634d4c40, ticket:4664)
   * Change: Simpler minimap size calculation (commit:0752c2b00e1cd68256ba77e67178a7c0a0fa7a9a, commit:af9a96f042ce2067ce34f532280e4bb384dcf96c, commit:d3410d0b1bd20ebbe8f1910aded3c5cb68402ece, ticket:4689)
   * Change: Use custom WzString for string handling functionality (too many commits)
   * Change: Allocation of VTOLs to rearming pads (commit:e2a4e25aca48315af35f4156dcfd0759985e7547, ticket:4697)
   * Change: Location of configuration directory (commit:54901bcd1672c9e22db35c66741ec2eda123b491)
   * Change: Some messages are throttled (commit:5bd5c0aedbcc43746113f06cd95d14a5e8b747e7, commit:ab279747c2df87930109e277138e0412b016a7dc, commit:7729a2dc68e32e275204862fef058f3667ea7e92, ticket:4446, ticket:4448, ticket:4842)
   * Fix: Trying not to crash on loading unknown templates (commit:44a1e1085d4811a0ceeeac8406457098f190c4a3, ticket:4581)
   * Fix: Always show template designs (commit:20c70fd00a5f155a5ff465866841591e4a23946e, ticket:4440)
   * Fix: Being put in cheat mode on loading saves (commit:4b91398c86a8d3e1e9c05787768508ad5929dcbc, ticket:4612)
   * Fix: Player properties "name" and "ai" (commit:18ec97beb53fb5c0677e2ccaaec4686edca25fd1, ticket:4628)
   * Fix: Primary hold order working (commit:27460ef00625c9c2d8594892bd5263896f1afcfb, commit:561bbbc7653927d9326a43657648ccec9a2a34d7)
   * Fix: Try to store designs when they are created (commit:c693e7c11249692bd111c8d51acf024aa107c52e)
   * Fix: CB and VTOL sensor droids not letting attached units attack (commit:8cad813a7ff3421370d927942d2feba4ad7e0933, ticket:4657)
   * Fix: Missing CRC hash checks (commit:23b6efac541dbabee943c93a1dc27e3831650ed6, ticket:3794)
 * Graphics:
   * Add: IRC channel link to main menu (commit:6797cf4681ebe35f50785f08f54c4da8d42e432e)
   * Add: Texture object wrapper (commit:ac08585f245b1dd36bbd8d0a9f88b2352418f845)
   * Add: Configuration option to disable radar arrow pointing north (commit:c5db25a75ea34d263ce3243f04ba4110b936ac52, ticket:4638)
   * Add: Configuration option to quit a game without confirmation (commit:3c27440913dbd856b5aa3e98ec062b0e0a88ff19, commit:2e2c2a872ea85ff502aa1b160d5a0c955b4a27dd, ticket:4692)
   * Add: Configuration options to set default map size, map zoom rate, default minimap size, camera speed (replaces scroll speed), turn off camera acceleration, turn off delay when jumping to new location by clicking on minimap, functionality of the scroll wheel (too many commits, ticket:4629)
   * Add: Display scaling with new configuration option, live window resizing and high-DPI support (commit:619e84d56189f45138ff18b3aea733dc15d9ca0c, commit:e58b34a0ed5ca670bb8107343f8a01b96a5cfc59, commit:96b4866269ecd2c88bb260e282df830598642a0f, commit:aefd9c5b72c36f9ad78cf329b433e8cd083708a2, commit:f8cb54cdaa58dae77a2792875180b2f8e73dd75f, commit:a2e9cd19fa322f8bd4604a556693fe2983095541, commit:cbbf5f2a41b2929280d158035af245d14b0caac3, ticket:4720)
   * Add: Initial support for OpenGL 3.2 core profile (commit:37af8da9eb69ec042960324a24be03944c69d9ca, commit:b2f401ff1db1007897d78650534192b42ef38288, commit:80476d41d0919a0583124b4a06e8b7d120fcf160, commit:64576ba33cbcb9efd684c97e4b63b4d02d75bb5b, commit:886c94669d8acceed8f6068032f80a390e385c15)
   * Add: Wrap buffers (commit:a21b7f5695b28d4c2da0a8e51c3505594380797f)
   * Change: Improved debug menu (commit:19d37399c3fcb31fbb87cb1419125c6cb133aa16, commit:ec5c482bc03405506ff40ff0f36ce25eb8139b0b, commit:9765b31136f18f21eb11627a7a705260d3d70641, commit:c3ef25159a0e4eae0ba3bfa68d34d303b124d1a8, commit:ad70d31cb77212ec215b907bf8c46ff52b8fcc52)
   * Change: Clear information messages after game end (commit:9edf1e646ce99fd99a895b771b63678710d2378a, ticket:4621)
   * Change: Print console message when re-aligning direction (commit:e8718ea80464e8768c12261a06c277cf3d153dcf, ticket:4620)
   * Change: Address player as Commander in campaign and tutorials (commit:3a871f21d8bbc5a660d5ce996a56e65761905fe5, ticket:4612)
   * Change: Only scroll one tab when pressing Tab Scroll Left and Tab Scroll Right (commit:8bac137cf94252241e20f667b9e60639d19e5641, ticket:4643)
   * Change: Blurriness in minimaps (commit:d8b75113658a44a3489738429879c7c1a0a272e8, commit:4f6e988effdafc6de2f8c99c9e9c125842e83a9f, ticket:4690, ticket:4708)
   * Change: Increase default radar size to 32 (commit:a67a46ec55f5dafd069fda90a9d30848f0dee823, ticket:4699)
   * Change: Minimum map zoom distance to 0 (commit:b735b72bce093a8902878ad21ebf838cb1c945e4, ticket:4629)
   * Change: Reduce OpenGL state changes (commit:4d0dcae247c6d93b884adfbfc0046017b66d6abd)
   * Change: Stop forcing alpha on for structure base plates (commit:32568eb0eb597ef0831e5d0348207d9ef9fdabca)
   * Change: Reduce shadow CPU usage (commit:a928f6a286b624eff94dc94b0f8d18d042e8ea86)
   * Change: Repaint Jammer to same colour as Radar Detector and adjust the blurring effect it causes within its range (too many commits, ticket:4769)
   * Change: Icons for obsolete technology used in build and manufacture screens (commit:00de63c64ecd37183315f843b92d09b865c0e826, ticket:4770)
   * Change: Icons for teams with shared research used in host screen (commit:4028b46bd5bc0b467e24ede2354a192204fc84f6, ticket:4771)
   * Change: Icons for easy and medium AI difficulties used in host screen (commit:5d56aabf03536752c0b23568d61219c2fd617ce8, ticket:4772)
   * Change: Warn about setting antialiasing to a value > 16, which can cause crashes (commit:6c143786c0368ceec8053f78fd527a230da6ef17, ticket:4777)
   * Change: Only show confirmation dialog before quitting game if player is hosting a multiplayer game (commit:d41d0e31f3f3f49a9f7dd166567ab96bf22dcd94, ticket:4692)
   * Fix: Name conflict with shader variables shaders (commit:c1131be441afa534f9ec5be76baeb6137dc94844, ticket:4589)
   * Fix: Crash when texture is 1x1 (commit:d3b81130ae12006f54f7a8cd17846ff42ac01398)
   * Fix: Misaligned radar frustum after aligning camera North/East/South/West (commit:26fccd4c749c9ff11aba14bf277c9cecfa465337, ticket:4620)
   * Fix: Clicking on "Language" button in game options menu changes its value (commit:866e63b4dca2a9026b4b32cbb35f613ca7d54798)
   * Fix: Draw opaque models before shadows (commit:e7cb9372b2b8dfaa8736aee48aa5180c94db206d)
   * Fix: Superfluous pixels with the upgrade icons (commit:11fc00b329551893d88b8f837702c4af43d53240, ticket:4759)
   * Fix: Missing widget borders (commit:1a1b0750506b663055f71f856c1079ba576b8a14, commit:fedcb22aec21387ce4ea4c64bf9453e5183fc3ef, ticket:4722)
   * Fix: Inaccurate screenshots (commit:496581ae41c4357e787ff01babcb4b7c5b40f74d)
   * Fix: Flashing of button in manufacture screen (commit:996ffebdefa522e2fe76b57deab778fa4e3abde6, ticket:4721)
   * Fix: Misplaced crosshair cursor when targeting features and structures (commit:619cd66e4e2efbfb150f792f6902d34518e57ca3, ticket:4605)
   * Fix: Missing crosshair cursor when auto-targeting (commit:b817ab8781df8a65ba1753962ff4b9dccfd0b4e3, commit:fb354bd8c5d924c0a551de30af801f698508bda2, ticket:4656)
   * Fix: Show weapon stats for secondary and tertiary weapons (commit:d22da3db985d41069483dd78e748eeb0f7c4090f, ticket:4649)
   * Fix: Resolutions below 640x480 being shown in video options menu (commit:6000e5eac9e1de5d01c320568003d03eb130d1db, ticket:4623)
   * Fix: Terrain lighting direction (commit:ec8a386f1e65246de3807f15ec510236dd652597, ticket:4749)
   * Fix: Design shadow stat markers (commit:ae7b5cebe876293756386c87b82deb22beeb38f8, commit:4c57502708229ac58b90b8bda764a7fb25164b16, commit:7bed71112d2261e2d6683c54309459e2186e91aa, commit:d22da3db985d41069483dd78e748eeb0f7c4090f, ticket:4649)
   * Fix: Cyborg engineer and Cyborg mechanic having nothing but legs (commit:490b91d4420ba0985289955520229a1b8b022096, commit:a856dea5afb52fc4436304f66d1fa375293110e0, ticket:4521)
   * Fix: Radar map showing every object the player owned being red for a few seconds at game initialization (commit:ffb5b9bd3af2623b04a0e8434ab562527c73bb0f)
   * Fix: Challenge description not appearing (commit:64b7420366ed551777832b59c0e505ddd876b25e, ticket:4821)
   * Fix: Scavengers burning when hit by kinetic weapons (commit:eccff930100a5c4788883909a05cc6dd418ebd4d)
   * Fix: Scavenger firing animation (commit:dfde4a7664f75a6a7d99e9cbf90e1a09ed3e4420, ticket:4625)
   * Fix: Technology tree chart generator now works with the JSON research files (commit:e3be50a2ee8054a13aaf8bc4777835ac30c2497b)
   * Remove: Slight camera rotation at the start of every game (commit:c83236b788f3decae8843d3480f64ed91f14316e, ticket:4642)
   * Remove: Credits screen shown when exiting game (commit:cf1c3fbf4706f7a3657ba369db235af8b6f3e981, ticket:3322)
 * Campaign:
   * Add: Research file for transition missions (commit:aedca2d262e0d38d000089a4a831dd4638ec3059)
   * Add: The chosen difficulty for campaign has a much more profound effect on mission difficulty. Adds Insane difficulty (commit:cb19c7672fe915b95795e3af33c63c9d567faccc)
   * Add: Allow artifacts to give multiple research technologies (commit:6d3e99a809fa0389e0a0c3b996c8b9320b48a24f)
   * Add: Cheat "research available" to complete research (commit:a5a49fa4826751a5c8f941ffa4d136789bdd4ea8)
   * Change: Campaign mission scripts completely rewritten to JavaScript (too many commits)
   * Change: Do not store or load templates which are already saved in the save file anyway (commit:d935f57c26d48fd5b431075ac0b7c6bec1315da8)
   * Change: Research uses one file instead of three (commit:a696594896c9ec605d29bc58eb9b77af13e822f4)
   * Change: Enemy has more power in campaign (commit:3f94bb41dd40dea3b96371158d40337375f26fcb)
   * Change: Improved group tactics (commit:64081ec427a5c1aa825d87485444e4b874fdca18, commit:7e0baa0d793d1e443ccf00737ade363de2ca5638)
   * Change: Nexus uses more sounds in the home base defend mission (commit:acc508e0478558d0809d18f146b56d6f5a310ab6)
   * Change: Rename stats for scavenger weapons (commit:25de2991b2da64125c8c863aeaafe4bec50ad81d, ticket:4674)
   * Change: Transporter menu GUI (commit:6b7b1b68cd26fd0f59821a8e34ddf6a538be7557, commit:ccfbbc925ca96631603ccad70583bcb7b365f680, ticket:4652, ticket:4606, ticket:4653, ticket:4710)
   * Change: Map corrections for the sub-2-8 map (commit:8cc67d0c5ed0ed4b38d582fbb2a64abd3f95a2b6, commit:308bccdfc3352550b22310b754133fc65bd2074f, ticket:3772)
   * Change: Flamers and AA units can fire on the move, just like in multiplayer games (commit:4c06fe4bc12199a60df43eb21c12f47989329318, ticket:4832)
   * Fix: Overall script stability is much better than before (too many commits)
   * Fix: Being able to build Command Relay in off-world missions (commit:bb0ce5fd50a0a596e18895ef4955d31a0823d9d0)
   * Fix: Player units (that return in a later mission) lost when reloading saves after the Gamma 2 mission (commit:8125a4098d3e73990e69d8e8b0738e837d4ff2e1, ticket:4054)
   * Fix: Potential power exploit in Alpha 3 before building power module (commit:33bea183138c4836abd9342dc11dd03200ea2a45)
   * Fix: Missing player warning about incoming enemy transporter (commit:c39da0858ba7f1926b8633859e85ade8166610d9)
   * Fix: Enemy base walls exploding when loading a save (commit:1989e22d0ffdf4b179322981457693ab602ad1db)
   * Fix: New Paradigm plateau transporter not arriving if all LZ's occupied with droids (commit:bd752be52f1c4d8d755c7bad3c9953b4eac0af8b)
   * Fix: Scavengers in Beta campaign use the civilian texture again (commit:fa6e0cb16c7d2a1b08c3a94e25dcc191eb3e3c8d)
   * Fix: Do not use the Arizona sky texture in Beta and Gamma campaigns (commit:5f9aa021e8e719b1705f135b39042f22641b540c)
   * Fix: Mission backdrops (commit:9efc45a48b6ef906d628d80a2a57cae998d6f1e1, 860b59df982164911adbb6750e719d75b1099aad)
   * Fix: Do not share ally vision with player (commit:8c9e7260333d6388438a091aad493bd2e11a965e, commit:e36ebcf38e76a4992878dec18f040f7db41851c7, ticket:4673)
   * Fix: Show droid rank in transporter when not off-world (commit:4cfa002cecd071406a18dbf7046b9ebfd1466f83)
   * Fix: Droids placed in the corner of the home map when producing them and then loading a save off-world (commit:fc172d8338f16ca4ef79747c04625e5e2fb2751d, ticket:3907)
   * Fix: Potential temporary lockup on sudden vision field increases (commit:800c1b6df440670f45f595e49fb83ff7ee7f724d, ticket:4644)
   * Fix: Race condition with danger maps (commit:9f25071068dd2edefb0f9fc9e17873a7c5e7a230, ticket:4633)
   * Fix: Outro subtitle timing (commit:1e84aea6273d252b915bafbfc11d9ce2ed024dbe, ticket:4169)
   * Fix: Show correct options for mission fail in debug mode (commit:1595decca92330bd1c00b14bb884b23ae5c2b0d1, ticket:4687)
   * Fix: Broken "research all" cheat (commit:3484ea251d0a0aa250da6ef4811be7931faaab3b)
   * Fix: More visibility asserts (commit:530d67a8b74025187edf80139edbd40bbfc4293a, ticket:4743)
   * Fix: Scouting units getting stuck in infinite loops (commit:2c5fd8085352eadaaa55cbd1c12ada4d8d76da3a)
   * Fix: All features are now aligned (commit:185b9beb2132ebcb6e52851de33883a05cff34ee, ticket:4775)
   * Fix: Duplicate warehouses causes a warning on the map sub-2-7 (commit:820d5c64706cd5489c94fe4340f6d73bcf74efdf)
   * Fix: Incorrect tile texture rotation for the sub-2-7 map (commit:8ed8f44d54d0aa01261ef648e054b77cd7579714)
   * Fix: Droids built when on offworld missions not having the factory secondary orders set (commit:ce90222cc241edbca5dc0909ff2bc0524d8686bb, ticket:3334)
   * Fix: Transporters not removing their visibility when exiting maps (commit:dae53ba5af78a57c5f2204b14fadfdfb07c6b166, ticket:4670)
   * Remove: Unused mission sub3-x (commit:1a5b62296ee7946116db7c6ea09aa714f317c709, ticket:4776)
 * Multiplayer:
   * Change: Move technology level scripts to JavaScript (commit:d31f6a2c704ada8f46957a34279af78deafdeec7)
   * Change: Move structure limiting into structure.json (commit:924135c98d630d638fcee74b8ebf85d10af2dfa1)
   * Change: Increased maximum VTOL rearming pad limit to 99 (commit:be03e188ba4b2661e175b4875b2a0be9898c279f)
   * Fix: Do not replace cyborg flamer with thermite flamer for built droids (commit:8dca9a6bbabd0ff0923a088a9d0ee95d078d8ad3, ticket:4331)
   * Fix: Broken research dependencies for Heavy Machinegun Tower and Command Turrets (commit:64c1b8cd4b2ea1101cfa23fcd6012c57becf312a, ticket:3437)
   * Fix: Missing artifacts after destroying factories (commit:fce314d5ba58778daa80a3626098729c8488005c, ticket:4836)
   * Remove: Jammers (commit:6c5435de1fea4f4d3e5b2fdf2cadd7a0e6f623cf)
 * Scripting:
   * Add: Add a way for a script library to register a namespace (commit:19d37399c3fcb31fbb87cb1419125c6cb133aa16)
   * Add: Function useSafetyTransport() (commit:d511cad4d15ca7ae5ecefc678527bb0a253cafde, commit 969718b14de95849184e22b8325ccf605b9a71ab)
   * Add: Function cam_eventGameLoaded (commit:64081ec427a5c1aa825d87485444e4b874fdca18)
   * Add: Function restoreLimboMissionData() (commit:8109d46e619fd5ca5f1220a5858b513db4114d6c)
   * Add: Function setObjectFlag() (commit:6ea98200a90304a7dd54cdddb6a11910ad57cc39)
   * Add: Cheat "untouchable" to make objects unselectable (commit:6ea98200a90304a7dd54cdddb6a11910ad57cc39)
   * Add: Function camCountStructuresInArea() is now a library function (commit:e0f0a420dac828744c8f903dd4a85bfac7d6757b)
   * Add: Function fireWeaponAtLoc() (commit:3c907bd4e4cd6290b306e847c81c060656a45fcd, commit:1cdd7bdb91fd99c7a5c9db73333c29bb76e32ff5, commit 00731ba9762fffec94f292251650518a18f7d557)
   * Add: Function clearConsole() (commit:e26b9516d3e065527e41fe5006f9f94983653882)
   * Add: Functions hackPlayIngameAudio() and hackStopIngameAudio() (commit:e26b9516d3e065527e41fe5006f9f94983653882)
   * Add: Events eventDeliveryPointMoving() and eventDeliveryPointMoved() (commit:e26b9516d3e065527e41fe5006f9f94983653882)
   * Add: Function getMultiTechLevel() (commit:d31f6a2c704ada8f46957a34279af78deafdeec7)
   * Add: Function setReticuleFlash() (commit:2810c730e1733262b3ff27decfbb93c1db821a6a)
   * Add: A lot of events for menus (commit:629d43771b4ab621fcedb8403165f7557b235bdf, commit:b5f8a07af0f1cbad8379dfa11724ceacc9f50ce8)
   * Add: Events and functions for alliances (commit:3670bbdb5b193a8ff59342e171810fe44415d9bb)
   * Add: Function setCampaignNumber() (commit:b016f609d704ce4df022e3a89f4f70f6eaabbee7)
   * Add: New global variable modList (commit:6cca64d99609123f9248dadff3e8cd24152512dc)
   * Add: Function showReticuleWidget() (commit:42db8f72193b348ea16f942c8bda4a40cb11cb23)
   * Add: Function __camScanRange() (commit:6a6ce7449fe0ab6c69562f37a2ff4904bd5c9d79)
   * Add: Function camSetPropulsionTypeLimit() (commit:00fa4c34d31fe0c27c4a5f7a84925a825cec46c0)
   * Add: Function fireWeaponAtObj() (commit:9316f1c166c5c2e140e718cfc45aaec65e149641)
   * Add: eventStructureDemolish (commit:349e73fbbaca898ad7397adf33ba2cafec486df9)
   * Change: Function formAlliance() does not enable shared vision (commit:d4d0688678aa44c9cf93163bd7f073a6d9bec18a)
   * Change: Function setReticuleButton() (commit:2ce3d680b4914b2990567970a4292d4e527f199b )
   * Change: Convert fast-play demo to JavaScript (commit:04f2ffe87d50d5ce2a24091a4b4c7a89bf8180d6)
   * Change: Convert tutorial to JavaScript (commit:8ff03b8b2f232df6e2528a8badd58849b35488b9, commit:410869b15d5e57d8774be74b4b7e399fb968527e)
   * Change: Move weather scripts to JavaScript (commit:b016f609d704ce4df022e3a89f4f70f6eaabbee7, commit:d60d6559c8fd930963b66bb6c3929f703b5d70f6)
   * Change: Function __camPlayerDead() (commit:10d035d3ed3a41b74a3cedcf1c3c8060d21d9785)
   * Fix: Function removeTimer() (commit:4a24e8e2753d02775b6732d59c23a75a79b83f72)
   * Fix: Function visGetBlockingWall() (commit:f965d77200f1caf57a9be5deb284683792c1280c)
   * Fix: donateObject() typo preventing structure donation (commit:077090bb814c4c7e557a970b7792eca2d2f478a8, ticket:4816)
   * Fix: Function giftSingleStructure (commit:af176e9eb32e393b26be6ef9c3329f6fc9006ab9, ticket:4819)
   * Fix: Instant assert on passing objects to syncRequest (commit:9dca83bcf80b031da6dca838416ea4b25223effb)
   * Fix: Technology tree chart generator now works with the JSON research files (commit:e3be50a2ee8054a13aaf8bc4777835ac30c2497b)
   * Remove: Base game wzscript files (commit:2999513e057beae4940209a18de2b74cfa5026dc, commit:76ac44c84b7f89a860c743202bb002586d137e63, commit:88cb1b6123bbd5fd9d3a66ea6dfb0e5eca15e6c3)
   * Remove: Old cluster code used by wzscript (commit:f6d1c0a78350a9297ea24c5c31e49b7ac518075e)
 * AI:
   * Change: Improved SemperFi-JS (commit:7af101472e0d66c4a73e684f17edf79f8d52505c, commit:6ed849c61a927184095fe7cbf3faa039e1f78860, commit:5b0de613a973ba96faab14ccf7f19a96c10c6a61, commit:4acfc135083ce3406668aa402e7852a0b5712832, commit:f5d3eda6a4aae357fa1d90491ab2f84d6612a6d4, commit:e9b67a47a64553650fd9f2491f176db93696440b, commit:3eff268f6dd2158a00026df749cadd5e315fc8bb)
   * Change: Nullbot is default AI (commit:46efbc680b990900a54bda7a8ded972449538a27)
   * Change: Improved NullBot performance (commit:35b6a1a6c09547b0eeea2d6cf5e6f4ac67b698b6, ticket:4717)
   * Fix: Nullbot can research Super Pulse Laser cyborgs without asserting (commit:52db9416a8fbb7984165bbdc58b4b96efe872c33, ticket:4639)
   * Fix: Nullbot no longer ignores starting units that cannot build (commit:0737d3ac125ae368a1cc31615f4bf537643f501f, ticket:4834)
 * Other:
   * Add: Skirmish/multiplayer cheat "bettertogether" that increases experience of selected units (commit:e760917fef73e172f0149a632a7505303b25080b)
   * Change: Play music in intelligence screen (commit:92722cb9726b8a1eb094b217857fc0a14f430741, ticket:4632)
   * Change: Allow exiting the main menu "Campaign" with the escape key (commit:c64a9a3430b45aa6879241c53f42a62d4db084d7, ticket:4648)
   * Change: More detailed power stats (commit:3dbd5a3c832e7165c7d73920657e0ede504fee82)
   * Change: Ease changing of default map (commit:db81858f454276e642c36c5c41be001f34823366, commit:5807d38b51120e8782609f3b28d348624647f306, ticket:4848, ticket:4849)
   * Change: Factories being destroyed could cause annoying asserts. Now set to quiet warnings (commit:616f142c6a031fc36aceb05f8c40156c563225bb)
   * Fix: Position locking settings loaded from challenge files (commit:20d2e85d697a4ce9e604c5930b21244fd816fb10)
   * Fix: Do not assert on loading skirmish saves when the player has lost or won (commit:77f9e5cada8469948c66ca9c3851e6991f533142, ticket:4590, ticket:3928)
   * Fix: Do not desync when destroying droids with animations (commit:123ded59aedc53dc2344be9807c321774613946f)
   * Fix: Memory bug when donating trucks to allies (commit:0090a88cabd60b9e087c125003e06eb28d1a4def)
   * Fix: Logging or source code spelling corrections (commit:d0dd6cf6b801918cba042b65bdc56e183fb675fd, commit:88c1e9c9f3beb10f1e747f7854d384f076b8cf76, commit:2ce9492056d84846a07174770cfc2c46abf44e7b, ticket:4612, ticket:4617)
   * Fix: Do not try loading videos if none are available (commit:81bf12847181ce7ddc7b096f2049e2c8bb949e35, ticket:4631)
   * Fix: Score and kills not showing in skirmish (commit:a74041b99442caa1c7e14c0ff409fc120c20e666, ticket:3491)
   * Fix: Do not save showFPS configuration option twice (commit:55c77847e4137c219170fff80d0342a0742499dd, ticket:4645)
   * Fix: Crash when opening debug menu in tutorial (commit:c0c20ab39965f4c062dc51d34ad8367d0e2b88f3, ticket:4681)
   * Fix: Music not playing on save-load or not playing the right music in skirmish (commit:b016f609d704ce4df022e3a89f4f70f6eaabbee7, ticket:983)
   * Fix: Right-clicking confused with left-clicking in main menu option buttons (commit:e54e3d505cd787a3f9681ac8f6210529f805e128, ticket:4629)
   * Fix: Screenshot crash by not calling QCoreApplication::processEvents() in SDL backend builds for Windows/macOS (commit:aa086e372f83a386bcea251e5f6fa4f73a955ef0, ticket:4714)
   * Fix: Warcam started at distance < 0 no longer breaks zoom when stopped (commit:46b191aac5167ee3766b1c869aae08351ee89b94, ticket:4830)
   * Fix: Commander production limits (commit:7d0a91180b36a0a75efefaeb94fdcf4a3d7a3832, ticket:1661)
   * Remove: Unused sensor turret properties in design menu (commit:c6b628e2c0c815467f0799c6c65e2f88d31585d3, ticket:4619)
   * Remove: Alt + Middle mouse to move to right-click on minimap (commit:6ceea6304d92705117a2aa7def97f6a11b08c140, ticket:4629)
   * Remove: Alt + Ctrl + Scroll changing game speed (commit:d1cd0dc338ab5fac19e49a461114eb9bd46ccea1, ticket:4629)
   * Remove: Unused sensor "Nexus Link" (not the weapon with the same name!) (commit:aacde23588e8a596a9764df6821d2d6abeeabf6d, ticket:4768)
 * Modding:
   * Add: Reticule images (commit:22a691903c8066539027f64dd04a6bd6977230cf)
   * Add: Flag NoFriendlyFire to prevent friendly fire from splash damage (commit:d75ccdea67fb48f41b370a0c15cea3b6703f344e)
   * Change: Allow mods to use more than one HQ before removing the radar mini-map (commit:590434843c202e92d7ab7e5488f31de9e196ecfa, ticket:3465)
   * Change: Increase capacity of design, build and research screens (commit:c05e4f7851d7f6ab7631b11b81ee9c333cab58cd, commit:3a729d9568b1a06e733651efc08003e601b5846c, ticket:4677)
   * Fix: Mods not read properly on save-load (commit:bd2bac6a5a81205f131b2bbe6efb41b6129b0c4c, ticket:2918)
 * Balance:
   * Add: Technology "Command Turret Upgrade" to increase command limits of commanders (commit:e760917fef73e172f0149a632a7505303b25080b)
   * Change: Droid ranks are now a brain property and can be upgraded (commit:e760917fef73e172f0149a632a7505303b25080b)
   * Change: HitPoint handling in stats (commit:b1cb129247bca05fb35e50b15e8bedee2d6f4a8a)
   * Fix: Do not replace cyborg rocket with cyborg scourge missile and cyborg heavy gunner with cyborg hyper velocity cannon (commit:55f5998c52a0cb2e889aa60c92e79167fc6dc8ed)
   * Fix: Structures not having initial thermal armor (commit:3dd4cdbe548e64ad18c3e06ad427e90fd00c1aa8, ticket:4616)
   * Fix: Various sensor tower research being available before the turret (commit:7487247ead349a9a497ad75e74d634e080a0d58c, ticket:666)
 * Translation:
   * Add: Indonesian (commit:3c050b0cc0a909eaa73d540bffa5224f2631f149, commit:b148301708e32821e7da4ccda085238c04be8d39)
   * Fix: German translation updates (commit:e5d7e20d49a5737a69365bb5b5e96c959e03ac9d, commit:4bc390378c90e807b31775b5e59c845d0398789e, commit:6a2a8708e4a27a455a515ee664c3f7295844bc98, d6baee2b23f29dd65b9178a1d2952484723b5f9c, ticket:4597, ticket:4845)
   * Fix: Turkish translation update (commit:013f6a95415f61232d137cf415b93cb9c8652f93, ticket:4608)
   * Fix: Polish translation update (commit:64bd5a1c5b984e62ddca87d542d53f9ab909cfbf)
   * Fix: Greek translation updates (commit:0490eaa237b0fd8f3a0e8bac722fbb12ff67d5b2, commit:4bdf251e7cede51302da809f703e7ce321440297, ticket:3703)
   * Fix: Russian translation updates (commit:19b767af2354a69b1d21199763188f44689c548f, commit:314a90469f38b4391ac17671f323b4b32c91ce5f)
   * Fix: Chinese translation update (commit:600eff0af390810582c5362b8d29ce93b9cd1080)
   * Fix: Slovenian translation update (commit:7b23d84eea28f45239f8632e4a6f882371d719d7, ticket:4838)
   * Fix: French translation for "wyvern" (commit:def430e0bef132ea54c797b5f3b2d4251bd9352f, e824571700a0b09f1a9b5068644fd21c77546fd3, ticket:4841)
 * Documentation:
   * Add: Coding style guide (commit:1c9bd06cfa53861b3f7c195c3e3f81abf247d838)
   * Add: Debugging guide (commit:e4a1139918687a8da912e7a06d8c677731e07854, commit:4d6ff701c26694060366bd17a3c681586a765095)
   * Change: Update building instructions (commit:3d0bf003b736c0897358f269921c9b1d27f05286, commit:1f759a7afc8c0aa691a5bac60c5ebae7868421ec, commit:9a3da03cc7d39ada5ff0dc17f76dbbbd759673d6, commit:f8fd4477b07cfbccf485637d0c0607a09418d7ae,fd72db1a149a02b34ea508b6fcd1dbb1a498a347, commit:448ba854bf9bbc62431ec01fe710f29e5aa3a168, commit:a878e51291ef51225e04787f6c21f258811b9019)
   * Change: QtScript documentation to Markdown (commit:40cbef4930a61736c80c1e204eab8e3d59145edd)
   * Change: Improved docker documentation (commit:c98c9e64b567a2f3a61958d2a4c6bd2d9c24d858)
   * Change: Improve PIE format explanations (commit:e7f724ce27350ea27fe81809c0ff15ff6c70a742, commit:0182af54fef20fa7a1f5d3dbc67a7583a126f166)
   * Fix: Radar detector description (commit:bcfbe04434d7166be56b63ecb44ff9e59ea9fdea, ticket:1275)
   * Fix: Command Relay Centre description (commit:e69654ebeb4f27039d406ca0cc93af8febb3d15a, ticket:1661)
 * Build systems:
   * Add: Docker file for cross-compilation (commit:b866f11b48c9043a505a8444b295b1c22aeffb6c)
   * Add: Basic CMakeLists.txt structure (commit:fa0bde7ab818174ea09505d4fc6b560588522146, commit:ae921a9ca922434ce0ad445d1dfc52e36059ff39)
   * Add: Support for PhysFS 2.1+ (too many commits, ticket:4693)
   * Add: Autotools docker file for Ubuntu 18.04 (commit:1b700cc4f61cdb5f5a6ea95c12788000f40e1f21)
   * Add: Unicode normalization support with utf8proc (commit:a5954999dda540baea0c666b6fe34b6a9ad69b87)
   * Add: OARS information (commit:1a7b0ee73870b7c26f3322a9b1b9ea83762832bc, ticket:4571)
   * Add: Clang docker file for Ubuntu 18.04 (commit:1af65c7429e13118c7a39f45b37f65fa36e8aae9)
   * Add: Docker file for Fedora latest (commit:1c16dac26a7bfc0ef7f6e1c160bd2ea741dec07f)
   * Change: Use datarootdir as prefix for non game-specific system paths (commit:65152d8110d02357202941b21b819f047d2f1536, commit:88f1ece155e86ef884f28789723e5bf10dfc6f43, ticket:4578)
   * Change: Make shaders compile on more systems (commit:3ec60e361e6bab478af77b51f79ab88f1ceac6db, ticket:4584)
   * Change: Replace OpenSSL with micro-ECC and SHA2 libraries (commit:f1c474153f7c55b5b39a9fdb805a7a7a4c1819c8)
   * Change: Make zip file creation reproducible (commit:714399bfd5c9effa0a9b1bba8f26b625eadeb1da)
   * Change: CMake builds (too many commits)
   * Change: Travis-CI builds (too many commits)
   * Change: Improved Windows installers (too many commits, ticket:4748)
   * Fix: Clang builds (commit:3e224b79a8c2ea98603444ac9827670f55db8004, commit:7b022c5a6c359f4053b314b3ee750c2b5561c41f)
   * Fix: Graphics driver warning when building structures (commit:f2d71eea0e03a6c2f7afcc8698a3883796f09346, ticket:4592)
   * Fix: Spaces in folder names breaking autorevision (commit:178dd3f1f15e02ad7fe8e1266379448550eaf55f, ticket:4348)
   * Fix: Can create Mac builds again (commit:32d4fb46776bbf4f30b99f36f3534d06ea23477e, commit:e4491400c34902ee992adbe43fed95f0d401382f)
   * Fix: MSVC warnings (too many commits)
   * Fix: Warnings generated with documentation (too many commits, ticket:4751)
   * Fix: Warnings with distributor name (commit:5ed40f3153cad4b983a473add191fcb7724416a2, commit:f7f4334869eeaad243b734341908be50ddcba0a0, ticket:4752)
   * Fix: Attempt a workaround with Nvidia driver bug causing crashes (commit:5a898bd8f1a0c916811b266026173455bb87e1c8, commit:82d6f22f3a2ed7bb21525cda709de26eb43beca1)
   * Fix: Docker file for Ubuntu 16.04 (commit:f1b69981381de3c9b79caaed0af997d633560072)
   * Fix: GCC warnings (too many commits)

2017-04-23: Version 3.2.3
 * General:
   * Fix: Rescale body points if players have different armour levels when transferring units (commit:d0934ff3adb980f4c3c67d3c6c4a3572af0a6890, ticket:4554)
   * Fix: Occasional crash when entering host game menu (commit:03d494d36663e7d483eb2d5f8a498358d0cd64ed, ticket:4567, ticket:4564, ticket:4546, ticket:4361 and others)
   * Fix: Game freeze on clicking on start game in menu (commit:382077800bd98b718fb2bc8221d9d6be66602765, ticket:4566)
   * Fix: Never put scavengers on human teams by accident (commit:a691778a5fcabe33b8b8fabc60e836fd50953e6e, ticket:4563)
 * Graphics:
   * Add: We now support higher than 8x MSAA, if supported by driver - do not show 8x if not supported (commit:33057c24ed87423e8a5e2d9d9aa5a53dee5dda08)
   * Change: Optimizing graphics rendering (commit:92b50b766582f1712756aca1321fa06c0380c4ad, commit:c1f697f28aa8d4817a6ed8c6bb1e150a56050c4f, commit:a70920985ef860c1a1adf01bdda49a28411df09d, commit:486dd8e9c0283a92f7fa109271c2edd623800441)
   * Change: Increase default resolution to 1024x768 rather than 640x480 (commit:9b0fa9e79a0e941c2f6d2e86795674872ef44217)
   * Fix: Avoiding some techniques to hopefully run with more drivers (commit:8a2ff4499d0e732832dac0db264d4a735c10b8c8, commit:4134f82d22fe557791ab7a988629a8539ee3700a, commit:871fa31c809a9808b0d12787c523ecf4821f9a25)
   * Fix: Fix clipped letters (commit:9c04d4ad6b378c6d246203b57e5038259f13348a)
   * Fix: Fix text rendering blend mode, makes progress bar more readable (commit:0bfd2179408383de94dc120782b5bc23cdf884a5, ticket:4569)
   * Fix: Still/moving helicopter/VTOL animations were reversed (commit:fb9bea5e0adc24a1a0de14ebdc883168380e5576, ticket:4489)
   * Fix: Prevent structure turret stretching again (commit:f79286dc13562e8b1277be0ab120a79f7d2d2fa7, ticket:4537)
 * Campaign:
   * Change: Lots of initial campaign ported to Javascript. Discuss these changes in our new porting forum here: http://forums.wz2100.net/viewforum.php?f=51
 * Scripting:
   * Change: Function donateObject() works on structures. Function findResearch() works on other players (commit:839e0b0f5c0ec3a2b5b6018d1c82697db0804d22)
   * Add: New function hackDoNotSave(global name) to prevent variable from being put in savegames (commit:ff57dc5733b69123b76a8f5dc469c4555f7b49f1)
   * Add: Add setHealth(object, health %) to set a game object's health (commit:62a7c961683266d7ce53fdd23b3fe913d9b9b01a)

2016-12-04: Version 3.2.2
 * General:
   * Change: Improved debug menu (commit:e89e1625401dfd9eefef8851f4a7af3245ce283e, commit:550f6eb01e2fabd27e491f71223b3c323c20cad6)
   * Change: Improved handling of multiplayer map/mod downloads (commit:4b73c266fd9a232902500cb48a98ec8d4f8985c2)
   * Fix: Fixed super heavy-gunner dependency (ticket:4490, commit:116ac5c679e978025f91c53ff91a16847e131226)
   * Fix: Do not crash on invalid research orders (commit:c6e9dfcf658ce7f6c62a6ae5b7fa5c06a559e332)
   * Fix: Improved Windows XP compatibility (commit:e58323f8cba93cc1f06f5cf6913c1c8876ff9f93)
   * Fix: Do not enter an infinite loop on loading invalid stored templates (commit:a394991dd19e93248ef3c409a4147c23ed7cc3b4)
 * Graphics:
   * Change: Fixed functionality graphics rewritten to use programmable shaders - this should fix crashes on Windows with Intel drivers (several commits, too many tickets)
   * Fix: Make water tiles visible even when just the water surface is visible (commit:4e6d245b7540cc7e07bb573754bfcd6083c15c81, ticket:4504)
 * Modding:
   * Change: New animation system (commit:af9c9137d231d4b2c1d4e5e1ffde0e86dc443b3c)
 * Campaign:
   * Fix: Alpha campaign cyborg production (commit:bc3db59f5f28e20683901645949acfeb316b0774, ticket:4515)
   * Fix: Disappearing commander designs in beta and gamma campaigns (commit:df4e1e378c77cffbf164d55f8e7ea4b9a9aadf8d, ticket:4458)
 * AI:
   * Fix: Do not desynch when NullBot VTOLs rearm (commit:216827c96f1eda16aedb2c444055415d35f84097, ticket:4464)

2016-07-28: Version 3.2.1
 * General:
   * Fix: Cursor flickering on some hardware (commit:ec3eb89550752db7098952af6aa79b20d4bfc9de, ticket:4450)
   * Fix: Assert on burning babas in campaign (commit:31d9772e4ccda50de48325801397215e3a025f92)
   * Fix: Assert when placing artefacts (commit:commit d3f56e0be196a1ed0f4f7c20f8a71cd144d70ffb)
   * Fix: Crash on transition between alpha and beta campaign (commit:75778395a1ff635786329c12a2a9a637640b4be0, ticket:4439)
   * Fix: Disappearing commander designs in campaign (commit:5a1142606b8fd86efdfe21dee856a2795ebc335c, ticket:4438)
   * Fix: Wrong hit chance for cyborg grenadier, changed from 70 to 65 (commit:8a929fcbd29a433c1a150573555748c8b35ee6ad, ticket:4436)
   * Fix: Reorder libs to fix linker error (commit:ff9631198cdfe7751a0f5c164ab15817c4cc6242)
   * Fix: Incorrect rendering of structure turrets (commit:d1bfaa32c3b8bb85d8e046ad9b110d3d7fb4e0a6, ticket:4453)

2016-07-10: Version 3.2.0
 * General:
   * Fix: Clear factory indicators when switching between commanders (commit:75da8d95bdd89724b8fe3d7b7816928e7773d071, ticket:1131)
   * Fix: Do not clear chat on setting structure limits (commit:a10dc950080ec4ad757591f644afe1d2e917f74c, ticket:4276)
   * Fix: Crash while loading map (commit:db886e7be065e3da25d1e7a106de5ede5e677a97, ticket:4426)
   * Fix: Saving/loading of command and repair droids (commit:3c0e4c77da70c81e86e4383ec38e4a1da5e7e5de, ticket:4426)
 * AI:
   * Change: Update the NullBot AI to version 3.06 (commit:11ef36281652b2933d982bf2379f54dc2d4da6f5)

2016-06-19: Version 3.2.0 beta4
 * General:
   * Change: Add default teams for Clover, Manhattan and MizaMaze (commit:d53404f63bdc543e577ca3ecd00e0ab783bdc8a5)
   * Fix: Crash if construction droids were doing construction without being ordered to (commit:4c6d778351333bde00bedb1958965df23ccd1c98, ticket:4417, ticket:4417)
   * Fix: Loading of default teams, given non-default starting positions (commit:d53404f63bdc543e577ca3ecd00e0ab783bdc8a5, ticket:4341)
   * Fix: Desynch on destroying droids while trying to build droids at droid limit (commit:63506e684962a0639927abe5d7866f4b0bf1c6b0)
 * Graphics:
   * Change: Add team colour to repair facility turret (commit:2fd3a506080eaaca2e9cb96bf90e36199c152ab2, ticket:4415)
   * Fix: Stretch to ground of defensive and wall structures did not work (commit:94d0afe21c515e63f8543aa694eba43be6584a95)
   * Fix: Structure direction not taken into account when stretching to ground (commit:04df320e5a4df64c9e06153d5da00f951db55af8, ticket:4366)
 * Balance:
   * Fix: Weapon rate of fire upgrades did not take effect on burst-fire weapons (commit:9498600700129d69d3633adecef76ea1a4de33c0, ticket:4411)

2016-05-28: Version 3.2.0 beta3
 * General:
   * Fix: Some maps would not load or give wrong minimap resolution (commit:e75d0f926540a505ca750691bdf0a1a95e8df8b4, ticket:4404, ticket:4405)
   * Fix: Several issues related to saving and loading templates (commit:73dba8a5ed032f9388c8eb940595cd287029ae6c, ticket:4406)
   * Fix: Superfluous templates removed and cyborgs added to cam2/cam3 starts (commit:fa8c431511308eeff70136f64febf4a62898334f, commit:0f312d0c8ca14c22dd448543771eec3c5cc9c561)
   * Fix: Lobby console output (commit:c3080516a4e10c90cd6ef911c9ba5c874382217c, ticket:4403)
   * Fix: Default template should not be present in tutorial (commit:85ac04406facd3a97342d1da45c256bc0fa47207, ticket:4402)
   * Fix: Broken warning on exiting multiplayer games (commit:b93cac88d978dd0dd06a2c29928e12f5e2759b18, ticket:4384)
   * Fix: Skewed video playback resolution (commit:be9548bdec4ac6e6644c04f5a0a2536e6190804e, ticket:4382)
   * Fix: Dangling tooltip on removing owning widget (commit:04a68d30fea972502d83c64b0790ee7a48ad811e, ticket:4396)
   * Fix: Cycle through menu lists consistently (commit:95d5bb5483e0919a2bb1dffa82ed85b0b3423501, ticket:3318)
 * Balance:
   * Fix: Improve repair droid targeting (commit:2b9b042cd8d0e9f9c736c39e0fe1d027416e8fff, commit:9d2108ed87e5e1f6319d78f53c12e1ca84be7869, ticket:3895, ticket:3362)
   * Fix: Factory upgrades were set to incorrect values (commit:9e6857a7424518d834b7509f8dd9a44cdcebd696)
 * Graphics:
   * Fix: Resolution and screen settings (commit:630c624433ead2663c1576a8491f409ea5a5766e, ticket:4410, ticket:4386)
 * Translations:
   * Fix: Garbled translations in scripts due to parsing as Latin1 instead of UTF-8 (commit:ee69d3ae2974f41844cd311171053d81c3c43aac, ticket:4380)
   * Fix: Language names for NSIS installer (commit:11fc451b41c98cd780ed1d5a3886cb6d30190ce6)
   * Fix: Untranslatable text in lobby (commit:f03488e704b8a5fb93d6f861b615a2ba2348069c, ticket:4296)

2016-05-16: Version 3.2.0 beta2
 * Balance:
   * Fix: Some weapon accuracy values tweaked to be closer to the 3.1 experience (commit:dc6ddae6953c7f8cb2b0bd073641f02ed348da8b)
   * Fix: Inconsistent application of body upgrades (commit:11150dacac874ee973b94cee3a63175ed933d112, ticket:4369)
 * General:
   * Fix: Crash on choosing AI while another player clicks ready (commit:c58e747775fa3618d61b325e38fd4f15281220e3, ticket:4392)
   * Fix: Small bodied droids did not count for transport capacity (commit:5e457617b67cf02baceaad38efd7f7fe443a8db6, ticket:4394)
   * Fix: Designed templates did not survive save and load (commit:0556c63f676828db552420bff3e979b5a0be1c72, ticket:4372)
   * Fix: Droid selection bounding box improvements (commit:07e33362d4ee5d9c4b1d9f3ccd63ecc88f73d93b, ticket:4157)
   * Fix: Allied research time display (commit:1ee5fcb42ae5fe20ebbc35b911ee09696d2bbb3e)
   * Fix: Alphabetical map name sorting, was reversed (commit:c82e091c62b3273411012d3035e342912fce4ef8)
   * Fix: Visibility issues in loaded games (commit:c94b5437e41a2a86d7bc024c23889ac6ef1bdc24, ticket:4388)
   * Fix: Building aborted on burning oil wells (commit:2da928680fdb4a34b9a46b4ae41845f84f41d9fe, ticket:4379)
   * Fix: Let idle trucks help with building structures as well as repairing them (commit:24c8416c1345594e834629d0cf467e37088964b7, ticket:737)
   * Fix: Specific .png files which were causing libpng warnings (commit:0fde4c81152463389e906998f4590873d8058eb7, ticket:4320)
   * Fix: WzScript-based AIs were trying to build illegal cyborgs (commit:f9a723424f51ffa578b1bfce179f1bf30f277675, commit:712e3adffd334d7fdba3cef210aeb41560b204f7, ticket:4364)
 * Graphics:
   * Change: Enable coloured cursors by default (commit:a1c76bacd80cdd4a5652f5f25fb6a697b9174510, ticket:4387)
   * Fix: Shadow rendering (commit:c0f41c445e19546271ea1dcc23010db2f4f5fa26, ticket:4378)

2016-05-07: Version 3.2.0 beta1
 * UI:
   * Add: Add teams mode without shared research (commit:8713039c5f1309bbb5e1c269d83cf91877b99646)
   * Add: Add Shift+V to select all fully-armed VTOLs (commit:0694970497e7ee8903c115249c11d40772ab3edb)
   * Add: Default map team setups supported, added for some maps (commit:30612665dc978457ff80f299db88fc64cb527e7c)
   * Add: Enable ECM Jammer tech. Increase radar detector cost to 2000, from 900 (commit:fdfc3d837b7236c2440b29f8c6d4771bb5d1f83d)
   * Add: Add minipod tower research to full base starts (commit:d8500eb7b7dc7e37bdabc35b529f6b9b3efcff84)
   * Change: Move Command HUD to make more room for more items (commit:e252b9a460829f03ea0557330de1789fd5f4ee30)
   * Change: Make VTOLs return to rearm when out of ammo, if told to patrol or circle (commit:7a52d37d5f3e6e3a0093bcc198a3fbfe3e344bec, ticket:3705)
   * Change: Allow designing and building obsolete tanks (commit:714727e241e286e395ad09313315de7c3655d90b)
   * Change: Make smooth water bed generation, instead of random jitter (commit:4aa873b3aa57f1426d9ef4f239409d41ec3491a8)
   * Change: Default stop/hold/hq hotkeys changed (commit:81c1c76dbf88e680f867e7c75a74dc5a85e178ba)
   * Change: Only play 'power resource' message once for each research (commit:88dc5c1b9b5145f2a4a67c916bbb3b3849fd5d01)
   * Change: No armour bonus while building is in construction (commit:e547361d0c8d9cad9c096d3188ce3726de03f91e, ticket:3641)
   * Remove: Secondary orders hold and pursue removed, use primary order hold and attack instead (commit:8fd88edcc2adf804dc5cf032076137f434fcf7b4)
   * Remove: The optimal/short/long range GUI elements have been removed (commit:244c8ec1418d21484499d9a1f79f7afeb9330b86)
 * Balance:
   * Change: Always use latest armour upgrade value for already built droids (commit:01510e4dda3de00f3164b7f6722a55401f8d39cb)
   * Change: Improved doomed target calculations (commit:78fdea0c8c37b783861332ec9aae2646fe8672b1, commit:ab26ab2af27c7baabdd6f6c098760fe09e3fe78a, commit:3c12b7a6ab85e15ad20ca06ed4d249c490b0bdcb)
   * Change: Make easy difficulty AIs get 25% less power from derricks (commit:ba592d6d1b7fcea7ec786e8db85a280be90590cd)
   * Change: Make insane difficulty give 2x power income to AIs (commit:7e18c73af439ec4b3bd5940e8b41231933d7fbc6)
   * Change: Improved counterbattery target checking, can also now use allied counterbattery sensors (commit:70c5bd3088ec670702d950e6fe9f3c541ffc996b)
   * Fix: Fix wrong calculation of rate in some cases (commit:3f2dd664dddb2ea4d3b16a3b0399e4dddf9dc4c8)
   * Remove: Command turret upgrades (commit:40bbf3a40ece5aa206c9508beb37711c2df9b45a, ticket:4019)
   * Remove: Transports no longer have weapons (commit:e8550e49dec90352043f6f83087ead77e98e2125)
   * Remove: Remove the distinction between short and long range for accuracy purposes (commit:30e0f8e65c475c094ac6032d523c94af38f2522c)
 * Graphics:
   * Add: Now possible to render multiple levels for all features, structures and walls (commit:443702483a08a27f1fb89bd47364d9b9c74224df)
   * Add: Generalized support for standing still and moving effects for propulsions (commit:500f3a8aec96d4eb1dca3db69eb91d801b160496)
   * Add: Can now set a shader program for each model level (commit:1b826910c44003a7d9ecf7e86d128dcb1bfaa6ea, commit:465894d7b9d36f103a2bf196077bd9071ab75757)
   * Change: Significantly improve model rendering performance (commit:e4e9ed5a54032b2c5f76e8a53c1b7d1ace7b69ad, commit:06e4590128a6b23e0b6186247e9d0024390bdb14, commit:aa40e70b44523820f628352ba546cadb6fb494af, commit:8d5b07485f1b8e4e118b9f6a07bf837e9f85bce4)
 * Scripting:
   * Add eventGroupSeen() and improve eventArea(), rename resetArea() to resetLabel() (commit:52ab1be90ddb25d84977b4effb476ddac68522cd)
   * Add: New functions setReticuleButton(), showInterface() and hideInterface() to control the UI (commit:c0abe4efe3967daccf76fbb8a9e14d00be3f4012, commit:cd54d3880cb5bc742b4b46725ea55a7b9a042c75)
   * Add: New function syncRequest() and event eventSyncRequest for synced game updates (commit:569975e6ea1f3a00c793b2f2434783f55a584ae8)
   * Add: New structure flag which requires it to be built adjacent to another completed structure the player owns (commit:d7df351d498c6b8bc06201bcc4c1900315869e22, ticket:4016)
   * Add: New functions addSpotter() and removeSpotter() to add and remove temporary areas of vision (commit:371ab04cdacfd6d7727decb06a94f17dd6a03fa6)
   * Add: New event 'eventObjectRecycled(object)' for demolish and recycle actions (commit:a98cf2ace771bdde9556eadd6243691264d50864)
   * Add: New cheat 'jsload' which allows you to load any AI script you want from the 'scripts' directory (commit:ccc540b24e527618c6d84096fc00cb6a6d14ec51)
   * Add: Two new functions for transporter handling in campaign startTransporterEntry() and setTransporterExit() (commits:b1b60ba7a3781303d349099403c7e48d92c4d121)
   * Add: New function makeTemplate() (commit:8b14b26ae797f76c4093ea8c6cd2f031d911afa3)
   * Add: New events eventPlayerLeft() and eventDesignCreated() (commit:391492ddfc35e76a3e6d4fb06874a6aacd67e74a)
   * Add: New function propulsionCanReach() (commit:be44aaf8429f6da22e24ca9243500e01e675177f)
   * Add: New function removeLabel() (commit:7437d6662c822ded2baa18b473912bc7398c0184)
   * Add: New event enumSelectionChanged() and new function enumSelected() (commit:1072228b92e40d0b0b538d8213091c02b48613f4)
   * Add: New functions missionTime() and extraPowerTime() (commit:9b38f6188b1841ddd4b34f740c897483e8665eb6)
   * Add: New function getLabel(object) function for retrieving the label of an object (commit:c22375c1263458177ea2cf564f6a9e9aab53e633)
   * Add: New event eventBeaconRemoved() (commit:d573f3856554062963d73787e06ac15cda8c26ad)
   * Add: New function function cameraZoom() to change camera zoom (commit:aedb42f4821da20da368341ce5fbad30c1d233bd)
   * Add: New function setPowerModifier() to change the power modifier (commit:7e18c73af439ec4b3bd5940e8b41231933d7fbc6, ticket:3820)
   * Add: New event eventArea<label>() and new function resetArea() (commit:f7144766384691dc1dadf1b3dd1785fff058403b)
   * Add: New functions getExperienceGain() and setExperienceGain() (commit:55be151a66eb0a1a8b38149728951a1992b28c62)
   * Add: New functions addBeacon() and removeBeacon(), and new event eventBeacon() (commit:88b6abff593912567018589255c314bf4be7dc43, commit:acf0f0083b2288a87ae7ef718301f80152a4a1a5)
   * Add: New function addLabel() for dynamic creation of script labels (commit:5de3539dd1cbc129e1c1a595e41e0a7128756635)
   * Add: New function setSky() to change the skybox on the fly (commit:b4ed741ee1cf0ef75c2b13b673e5bfa4438d5fcc)
   * Add: New event eventCheatMode() (commit:30da9a9d4b7088facc632723f2c36f33efd879c6)
   * Add: New events eventGameLoaded(), eventGameSaving(), and eventGameSaved() (commit:c7cabf192b5b1d5f698f0402c30dd737ecd06846)
   * Add: New function setDroidLimit() that sets game build limits (commit:ee6da7ce13f73ab47c8e83a1c59658d2d2408ac1)
   * Add: New function enumTemplates() to list the templates of a player (commit:33f6a2a51bbf3ef1800f5fe818013cdc27531759)
   * Add: New function getDroidProduction() for virtual representation of production (commit:40fcab0f6c476c5915c193477d3e3dacbf62ed23)
   * Add: New event eventPickup() for whenever an object is picked up (commit:70684314e2b2d09c55c045e5f0765fd845896850)
   * Add: New functions setAlliance() and removeObject() (commit:deb1cd08ec10594c7cb7d7b88f656aec31b44ddb, commit:6b4d2eade249fe6988f6a3fe3630106ecda4c968)
   * Change: New function groupAdd(group, object) that deprecates groupAddDroid() (commit:dc46de746baa6238f66b51831954b1ae3954d515)
   * Change: Rename setScrollParams() -> setScrollLimits(), new function getScrollLimits() (commit:0e703c683fea98f3f30655dae3fa0814c8474bfe)
   * Change: Rename label() to getObject() and make it more flexible (commit:30886e207a3b30feaa9fe5b430d45d2a25c32ad6)
   * Change: Rename missionTimer() -> getMissionTimer() for consistency (commit:7de0941fce4baf4b7471c8789324651601abff1c)
 * Modding:
   * Change: Savegames and stats are now in JSON format
   * Change: Lazy loading of textures and PIE files,  no longer any need to add them in WRF files (commit:6a9ca8c0e8bdfb21c25cf1f45ede28a12c6a1e59, commit:035c7bf2034bfe4064c86e4053e008726c02132d)
   * Add: The minimum damage that a weapon causes is now moddable (commit:889ed7727f8f3fd55428092f14008dde8ab6b5be)
 * Testing:
   * Support for autogames using command line --autogame (commit:c6e96a71643978ed7f950f56bd71fb03e3475ff1, commit:edc47e872011ef06d2f10fe938c2e2c7e9f29fd8)
   * For analysing graphics performance issues, there is a new hotkey ctrl+k in debug mode to get info on what takes time (commit:5f32c3eafe26c959045f10b21bea2efc69c770d2)
 * Other:
   * We now require OpenGL 2.0
   * Parts of the campaign has been ported to javascript
   * The entire codebase has been run through astyle to clean it up

2016-04-10: Version 3.1.5
 * General:
   * Fix: Campaign loads and transport missions visibility should now work again. (commit:c5117b0adb7bc1329df91ae170c19af2e2fffb4b, ticket:4354)

2016-04-03: Version 3.1.4
 * General:
   * Fix: Loading games with teams & alliances now works again (commit:255009d7c18e8013e5f39b471e20a96bf7c9a9b4, ticket:4334)
   * Fix: Starting games in alliance mode now always works (commit:dddf05cbe4bb31b87b8fb69c4b4ad4e634edc151, ticket:4343)
   * Fix: Order of 'go to transport' now works again (commit:201dc762786ead3f1096d95f6fb949bc3aacbc3a, ticket:4339)
   * Fix: Template checks & error messages. (commit:20f95af3f41a43446a93513a1d610519c6006a2b)

2016-01-01: Version 3.1.3
 * General:
   * Change: Ping only displayed for multiplayer games (commit:2199ffdd416cb5189c0ee5af4137a6248c3a2ff1)
   * Change: Rank display removed for now (commit:30ed6e846faecf2cf186a7d94182318de65fb362)
   * Change: Better placement of IP dialog (commit:ea673ca4e32edc41097389948aec0f7bd3883567, ticket:4159)
   * Change: Remove hack to support some old systems that breaks with GLEW 1.12 (commit:6a6c611ca3d9d6745e5343f2ee041892772ccae6, ticket:4300)
   * Change/fix: Change --savegame command line option into two new options that actually work (commit:6f2f5d91c88005ef632f13af2e8d493aeea24d35)
   * Fix: Crash in campaign (commit:f661a7b213b2d7db8053bde8c21e5ab42374f652, ticket:4251)
   * Fix: Update included miniUPNP to version 1.219 (commit:512a10d453c52b424f948c78d732f6d1fe627fb8, ticket:4321)
   * Fix: 'kill' command for SP games (commit:d44708e1093a457fb110839c029d02ea69623715)
   * Fix: 'Assigned to Commander' voice over issue (commit:960ed9dfd82af57421b1c5e417a42bc8890065bc, ticket:1432)
   * Fix: Fix assert failure when Nexus AI tries to build a sensor tower (commit:a0b203bc4f570931470f6ff0d6c38d5fcd905ee6)
   * Fix: Check if received templates are valid when received (commit:260a88ea12bd26cf2c12a68bb338af591f9ba59f)
   * Fix: Many potential issues found with static analysis tools closed

2014-12-30: Version 3.1.2
 * General:
